FIT_LIMIT   = 1e-10           
FIT_MAXITER = 0    
Pi          = acos(-1.0)
N           =  (2.0/Pi)**(0.75) 

sto(x) =  1.0 / (Pi * 3.0)**(0.5) * x**2 * exp(-x) * 2 * Pi**(0.5)

a1              = 0.0589662        # +/- 0.0002144    (0.3636%)
a3              = 0.350349         # +/- 0.00042      (0.1199%)
a5              = 0.460497         # +/- 0.0003117    (0.06768%)
a7              = 0.203561         # +/- 0.0003386    (0.1664%)
a9              = -0.0409857       # +/- 5.976e-05    (0.1458%)
a11             = -0.0256158       # +/- 3.568e-05    (0.1393%)
a13             = -0.0106231       # +/- 3.941e-05    (0.371%)
a15             = -0.00348455      # +/- 2.142e-05    (0.6146%)
a17             = -0.000902044     # +/- 7.689e-06    (0.8524%)
a19             = -0.000161084     # +/- 1.984e-06    (1.232%)

a2              = 0.0351685        # +/- 2.579e-05    (0.07333%)
a4              = 0.065497         # +/- 5.11e-05     (0.07802%)
a6              = 0.122978         # +/- 9.157e-05    (0.07446%)
a8              = 0.240961         # +/- 0.0001297    (0.05384%)
a10             = 1.10465          # +/- 0.001143     (0.1035%)
a12             = 2.60909          # +/- 0.006509     (0.2495%)
a14             = 6.7037           # +/- 0.02727      (0.4067%)
a16             = 19.5098          # +/- 0.1091       (0.5592%)
a18             = 69.7088          # +/- 0.5162       (0.7405%)
a20             = 380.065          # +/- 4.272        (1.124%)

f1(x)  =  a1  * N * ( a2  )**(0.75) * x * exp(-(a2  * x**2)) * 2.0 * Pi**(0.5)
f2(x)  =  a3  * N * ( a4  )**(0.75) * x * exp(-(a4  * x**2)) * 2.0 * Pi**(0.5)
f3(x)  =  a5  * N * ( a6  )**(0.75) * x * exp(-(a6  * x**2)) * 2.0 * Pi**(0.5)
f4(x)  =  a7  * N * ( a8  )**(0.75) * x * exp(-(a8  * x**2)) * 2.0 * Pi**(0.5)
f5(x)  =  a9  * N * ( a10 )**(0.75) * x * exp(-(a10 * x**2)) * 2.0 * Pi**(0.5)
f6(x)  =  a11 * N * ( a12 )**(0.75) * x * exp(-(a12 * x**2)) * 2.0 * Pi**(0.5)
f7(x)  =  a13 * N * ( a14 )**(0.75) * x * exp(-(a14 * x**2)) * 2.0 * Pi**(0.5)
f8(x)  =  a15 * N * ( a16 )**(0.75) * x * exp(-(a16 * x**2)) * 2.0 * Pi**(0.5)
f9(x)  =  a17 * N * ( a18 )**(0.75) * x * exp(-(a18 * x**2)) * 2.0 * Pi**(0.5)
f10(x) =  a19 * N * ( a20 )**(0.75) * x * exp(-(a20 * x**2)) * 2.0 * Pi**(0.5)

fit_gto(x) = f1(x) + f2(x) + f3(x) + f4(x) + f5(x) + f6(x) + f7(x) + f8(x) + f9(x) + f10(x)

fit fit_gto(x) "sto-2s.dat" using 1:2 via a1, a3, a5, a7, a9,  a11, a13, a15, a17, a19, a2, a4, a6, a8, a10, a12, a14, a16, a18, a20
