# constants
FIT_LIMIT   = 1e-10              # fitting tolerance
FIT_MAXITER = 0                  # no limit for number of iterations
pi          = acos(-1.0)         # value of pi
N           = (2.0/pi)**(0.75)   # 1s normalization constant

# sto-6g exponent parameters - pople

a1 = 0.4301284983
a3 = 0.6789135305

# sto-6g linear parameters - pople

a2 =  0.8518186635
a4 =  0.1516232927

f1(x)   =  a1  * N * ( a2  )**(0.75) * x * exp(-a2  * x**2)
f2(x)   =  a3  * N * ( a4  )**(0.75) * x * exp(-a4  * x**2)

fit_gto(x) = f1(x) + f2(x)

fit fit_gto(x) "sto-1s.dat" using 1:2 via a1, a3, a2, a4
