# constants
FIT_LIMIT   = 1e-10              # fitting tolerance
FIT_MAXITER = 0                  # no limit for number of iterations
pi          = acos(-1.0)         # value of pi
N           = (2.0/pi)**(0.75)   # 1s normalization constant

# sto-6g exponent parameters - pople

a1 = 0.0567524208
a3 = 0.2601413550
a5 = 0.5328461143
a7 = 0.2916254405

# sto-6g linear parameters - pople

a2 = 5.2168445340
a4 = 0.9546182760
a6 = 0.2652034102
a8 = 0.0880186277

f1(x)   =  a1  * N * ( a2  )**(0.75) * x * exp(-a2  * x**2)
f2(x)   =  a3  * N * ( a4  )**(0.75) * x * exp(-a4  * x**2)
f3(x)   =  a5  * N * ( a6  )**(0.75) * x * exp(-a6  * x**2)
f4(x)   =  a7  * N * ( a8  )**(0.75) * x * exp(-a8  * x**2)

fit_gto(x) = f1(x) + f2(x) + f3(x) + f4(x)

fit fit_gto(x) "sto-1s.dat" using 1:2 via a1, a3, a5, a7, a2, a4, a6, a8
