# constants
FIT_LIMIT   = 1e-10              # fitting tolerance
FIT_MAXITER = 0                  # no limit for number of iterations
pi          = acos(-1.0)         # value of pi
N           = (2.0/pi)**(0.75)   # 1s normalization constant

# sto-6g exponent parameters - pople

a2  = 11.3056369600
a4  = 2.0717281780
a6  = 0.5786484833
a8  = 0.1975724573
a10 = 0.0744527175

# sto-6g linear parameters - pople

a1  = 0.0221405531
a3  = 0.1135411520
a5  = 0.3318161484
a7  = 0.4825700713
a9  = 0.1935721966

f1(x)   =  a1  * N * ( a2  )**(0.75) * x * exp(-a2  * x**2)
f2(x)   =  a3  * N * ( a4  )**(0.75) * x * exp(-a4  * x**2)
f3(x)   =  a5  * N * ( a6  )**(0.75) * x * exp(-a6  * x**2)
f4(x)   =  a7  * N * ( a8  )**(0.75) * x * exp(-a8  * x**2)
f5(x)   =  a9  * N * ( a10 )**(0.75) * x * exp(-a10 * x**2)

fit_gto(x) = f1(x) + f2(x) + f3(x) + f4(x) + f5(x)

fit fit_gto(x) "sto-1s.dat" using 1:2 via a1, a3, a5, a7, a9, a2, a4, a6, a8, a10
