FIT_LIMIT   = 1e-10           
FIT_MAXITER = 0    
Pi          = acos(-1.0)
N           = 8.0 * 2**(0.75) / ( 15.0**(0.5) * Pi**(0.25) )

a1              = 0.00728232       # +/- 4.524e-05    (0.6213%)
a3              = 0.0538484        # +/- 0.0002216    (0.4115%)
a5              = 0.207154         # +/- 0.0005489    (0.265%)
a7              = 0.426586         # +/- 0.0005055    (0.1185%)
a9              = 0.384382         # +/- 0.000686     (0.1785%)
a11             = 0.0890775        # +/- 0.000464     (0.5209%)
a2              = 2.48841          # +/- 0.008207     (0.3298%)
a4              = 0.798271         # +/- 0.001842     (0.2307%)
a6              = 0.331194         # +/- 0.0006234    (0.1882%)
a8              = 0.15594          # +/- 0.0002524    (0.1619%)
a10             = 0.0787899        # +/- 0.0001122    (0.1424%)
a12             = 0.04059          # +/- 5.133e-05    (0.1265%)

f1(x)  =  a1  * N * ( a2  )**(1.75) * x**3 * exp(-(a2  * x**2))
f2(x)  =  a3  * N * ( a4  )**(1.75) * x**3 * exp(-(a4  * x**2))
f3(x)  =  a5  * N * ( a6  )**(1.75) * x**3 * exp(-(a6  * x**2))
f4(x)  =  a7  * N * ( a8  )**(1.75) * x**3 * exp(-(a8  * x**2))
f5(x)  =  a9  * N * ( a10 )**(1.75) * x**3 * exp(-(a10 * x**2))
f6(x)  =  a11 * N * ( a12 )**(1.75) * x**3 * exp(-(a12 * x**2))

fit_gto(x) = f1(x) + f2(x) + f3(x) + f4(x) + f5(x) + f6(x)

fit fit_gto(x) "sto-3d.dat" using 1:2 via a1, a3, a5, a7, a9,  a11, a2, a4, a6, a8, a10, a12

