FIT_LIMIT   = 1e-10           
FIT_MAXITER = 0    
Pi          = acos(-1.0)
N           = 4 * 2**(0.75) / ( 3**(0.5) * Pi**(0.25) )

a2              = 2.61471          # +/- 0.007607     (0.2909%)
a4              = 0.937386         # +/- 0.002214     (0.2362%)
a6              = 0.393535         # +/- 0.0007988    (0.203%)
a8              = 0.182            # +/- 0.0003253    (0.1787%)
a10             = 0.089362         # +/- 0.0001416    (0.1584%)
a12             = 0.0445805        # +/- 6.22e-05     (0.1395%)
a14             = 10.0169          # +/- 0.04236      (0.4229%)
a1              = 0.0215332        # +/- 9.62e-05     (0.4468%)
a3              = 0.0893253        # +/- 0.0002975    (0.333%)
a5              = 0.245787         # +/- 0.0005449    (0.2217%)
a7              = 0.410078         # +/- 0.0004271    (0.1042%)
a9              = 0.323073         # +/- 0.0006868    (0.2126%)
a11             = 0.067887         # +/- 0.0003865    (0.5693%)
a13             = 0.00316279       # +/- 2.02e-05     (0.6387%)

f1(x)  =  a1  * N * ( a2  )**(1.25) * x**2 * exp(-(a2  * x**2))
f2(x)  =  a3  * N * ( a4  )**(1.25) * x**2 * exp(-(a4  * x**2))
f3(x)  =  a5  * N * ( a6  )**(1.25) * x**2 * exp(-(a6  * x**2))
f4(x)  =  a7  * N * ( a8  )**(1.25) * x**2 * exp(-(a8  * x**2))
f5(x)  =  a9  * N * ( a10 )**(1.25) * x**2 * exp(-(a10 * x**2))
f6(x)  =  a11 * N * ( a12 )**(1.25) * x**2 * exp(-(a12 * x**2))
f7(x)  =  a13 * N * ( a14 )**(1.25) * x**2 * exp(-(a14 * x**2))

fit_gto(x) = f1(x) + f2(x) + f3(x) + f4(x) + f5(x) + f6(x) + f7(x)

fit fit_gto(x) "sto-2p.dat" using 1:2 via a2, a4, a6, a8, a10, a12, a14, a1, a3, a5, a7, a9,  a11, a13
 
