FIT_LIMIT   = 1e-10           
FIT_MAXITER = 0    
Pi          = acos(-1.0)
N           =  (2.0/Pi)**(0.75) 

sto(x) =  1.0 / (Pi * 3.0)**(0.5) * x**2 * exp(-x) * 2 * Pi**(0.5)

a1              = -0.00109575      # +/- 2.001e-05    (1.826%)
a3              = -0.00599798      # +/- 5.978e-05    (0.9967%)
a5              = -0.0215595       # +/- 7.779e-05    (0.3608%)
a7              = -0.0485743       # +/- 9.624e-05    (0.1981%)
a9              = 0.327732         # +/- 0.0005434    (0.1658%)
a11             = 0.56521          # +/- 0.0002621    (0.04638%)
a13             = 0.17585          # +/- 0.0004887    (0.2779%)
a2              = 81.5599          # +/- 1.397        (1.713%)
a4              = 14.898           # +/- 0.1491       (1.001%)
a6              = 4.09863          # +/- 0.02233      (0.5449%)
a8              = 1.35143          # +/- 0.00262      (0.1939%)
a10             = 0.206232         # +/- 0.0001444    (0.07%)
a12             = 0.0935031        # +/- 7.924e-05    (0.08474%)
a14             = 0.0444612        # +/- 3.566e-05    (0.08021%)

f1(x)  =  a1  * N * ( a2  )**(0.75) * x * exp(-(a2  * x**2)) * 2.0 * Pi**(0.5)
f2(x)  =  a3  * N * ( a4  )**(0.75) * x * exp(-(a4  * x**2)) * 2.0 * Pi**(0.5)
f3(x)  =  a5  * N * ( a6  )**(0.75) * x * exp(-(a6  * x**2)) * 2.0 * Pi**(0.5)
f4(x)  =  a7  * N * ( a8  )**(0.75) * x * exp(-(a8  * x**2)) * 2.0 * Pi**(0.5)
f5(x)  =  a9  * N * ( a10 )**(0.75) * x * exp(-(a10 * x**2)) * 2.0 * Pi**(0.5)
f6(x)  =  a11 * N * ( a12 )**(0.75) * x * exp(-(a12 * x**2)) * 2.0 * Pi**(0.5)
f7(x)  =  a13 * N * ( a14 )**(0.75) * x * exp(-(a14 * x**2)) * 2.0 * Pi**(0.5)

fit_gto(x) = f1(x) + f2(x) + f3(x) + f4(x) + f5(x) + f6(x) + f7(x)

fit fit_gto(x) "sto-2s.dat" using 1:2 via a1, a3, a5, a7, a9,  a11, a13, a2, a4, a6, a8, a10, a12, a14
