FIT_LIMIT   = 1e-10           
FIT_MAXITER = 0    
Pi          = acos(-1.0)
N           = 8.0 * 2**(0.75) / ( 15.0**(0.5) * Pi**(0.25) )

a1              = 0.0216608        # +/- 9.706e-05    (0.4481%)
a3              = 0.0971435        # +/- 0.0003131    (0.3223%)
a5              = 0.269199         # +/- 0.0005379    (0.1998%)
a7              = 0.423631         # +/- 0.0003609    (0.08519%)
a9              = 0.299176         # +/- 0.0006727    (0.2249%)
a11             = 0.0549789        # +/- 0.0003101    (0.5641%)
a13             = 0.00272221       # +/- 1.768e-05    (0.6494%)
a2              = 1.25784          # +/- 0.002981     (0.237%)
a4              = 0.523351         # +/- 0.001013     (0.1936%)
a6              = 0.247881         # +/- 0.0004141    (0.1671%)
a8              = 0.126995         # +/- 0.0001878    (0.1479%)
a10             = 0.0681322        # +/- 9.014e-05    (0.1323%)
a12             = 0.0367532        # +/- 4.363e-05    (0.1187%)
a14             = 3.9157           # +/- 0.01327      (0.3389%)

f1(x)  =  a1  * N * ( a2  )**(1.75) * x**3 * exp(-(a2  * x**2))
f2(x)  =  a3  * N * ( a4  )**(1.75) * x**3 * exp(-(a4  * x**2))
f3(x)  =  a5  * N * ( a6  )**(1.75) * x**3 * exp(-(a6  * x**2))
f4(x)  =  a7  * N * ( a8  )**(1.75) * x**3 * exp(-(a8  * x**2))
f5(x)  =  a9  * N * ( a10 )**(1.75) * x**3 * exp(-(a10 * x**2))
f6(x)  =  a11 * N * ( a12 )**(1.75) * x**3 * exp(-(a12 * x**2))
f7(x)  =  a13 * N * ( a14 )**(1.75) * x**3 * exp(-(a14 * x**2))

fit_gto(x) = f1(x) + f2(x) + f3(x) + f4(x) + f5(x) + f6(x) + f7(x)

fit fit_gto(x) "sto-3d.dat" using 1:2 via a1, a3, a5, a7, a9,  a11, a13, a2, a4, a6, a8, a10, a12, a14

