FIT_LIMIT   = 1e-10           
FIT_MAXITER = 0    
Pi          = acos(-1.0)
N           = 4 * 2**(0.75) / ( 3**(0.5) * Pi**(0.25) )

a1              = -0.000691381     # +/- 6.974e-06    (1.009%)
a3              = -0.0043269       # +/- 1.653e-05    (0.3821%)
a5              = -0.0132512       # +/- 1.476e-05    (0.1114%)
a7              = 0.150541         # +/- 0.0003055    (0.2029%)
a9              = 0.439164         # +/- 0.0004131    (0.09407%)
a11             = 0.406871         # +/- 0.0004271    (0.105%)
a13             = 0.0815302        # +/- 0.0002931    (0.3595%)
a2              = 13.1962          # +/- 0.09591      (0.7268%)
a4              = 3.42237          # +/- 0.01257      (0.3674%)
a6              = 1.20921          # +/- 0.001683     (0.1392%)
a8              = 0.231364         # +/- 0.0001401    (0.06054%)
a10             = 0.116672         # +/- 9.237e-05    (0.07917%)
a12             = 0.0622984        # +/- 5.03e-05     (0.08073%)
a14             = 0.0337627        # +/- 2.553e-05    (0.07562%)

f1(x)  =  a1  * N * ( a2  )**(1.25) * x**2 * exp(-(a2  * x**2))
f2(x)  =  a3  * N * ( a4  )**(1.25) * x**2 * exp(-(a4  * x**2))
f3(x)  =  a5  * N * ( a6  )**(1.25) * x**2 * exp(-(a6  * x**2))
f4(x)  =  a7  * N * ( a8  )**(1.25) * x**2 * exp(-(a8  * x**2))
f5(x)  =  a9  * N * ( a10 )**(1.25) * x**2 * exp(-(a10 * x**2))
f6(x)  =  a11 * N * ( a12 )**(1.25) * x**2 * exp(-(a12 * x**2))
f7(x)  =  a13 * N * ( a14 )**(1.25) * x**2 * exp(-(a14 * x**2))

fit_gto(x) = f1(x) + f2(x) + f3(x) + f4(x) + f5(x) + f6(x) + f7(x)

fit fit_gto(x) "sto-3p.dat" using 1:2 via a1, a3, a5, a7, a9, a11, a13, a2, a4, a6, a8, a10, a12, a14
