FIT_LIMIT   = 1e-10           
FIT_MAXITER = 0    
Pi          = acos(-1.0)
N           = (128.0 / Pi)**(0.25) 

a1              = 0.00148285       # +/- 2.926e-06    (0.1973%)
a3              = -0.0630219       # +/- 0.0008056    (1.278%)
a5              = -0.213094        # +/- 0.007397     (3.471%)
a7              = -0.157574        # +/- 0.006018     (3.819%)
a9              = 0.627205         # +/- 0.005026     (0.8013%)
a11             = 0.571096         # +/- 0.005383     (0.9426%)
a13             = 0.0806216        # +/- 0.001872     (2.321%)
a2              = 3.04278          # +/- 0.005411     (0.1778%)
a4              = 0.388344         # +/- 0.0009849    (0.2536%)
a6              = 0.202411         # +/- 0.00189      (0.9336%)
a8              = 0.130598         # +/- 0.002389     (1.83%)
a10             = 0.0577965        # +/- 0.00025      (0.4325%)
a12             = 0.0359745        # +/- 0.000141     (0.392%)
a14             = 0.0221756        # +/- 7.307e-05    (0.3295%)

f1(x)  =  a1  * N * ( a2  )**(0.75) * x * exp(-(a2  * x**2))
f2(x)  =  a3  * N * ( a4  )**(0.75) * x * exp(-(a4  * x**2))
f3(x)  =  a5  * N * ( a6  )**(0.75) * x * exp(-(a6  * x**2))
f4(x)  =  a7  * N * ( a8  )**(0.75) * x * exp(-(a8  * x**2))
f5(x)  =  a9  * N * ( a10 )**(0.75) * x * exp(-(a10 * x**2))
f6(x)  =  a11 * N * ( a12 )**(0.75) * x * exp(-(a12 * x**2))
f7(x)  =  a13 * N * ( a14 )**(0.75) * x * exp(-(a14 * x**2))

fit_gto(x) = f1(x) + f2(x) + f3(x) + f4(x) + f5(x) + f6(x) + f7(x)

fit fit_gto(x) "sto-4s.dat" using 1:2 via a1, a3, a5, a7, a9,  a11, a13, a2, a4, a6, a8, a10, a12, a14


