FIT_LIMIT   = 1e-10           
FIT_MAXITER = 0    
Pi          = acos(-1.0)
N           = 4 * 2**(0.75) / ( 3**(0.5) * Pi**(0.25) )

a2              = 1.55857          # +/- 0.003782     (0.2426%)
a4              = 0.655488         # +/- 0.001371     (0.2091%)
a6              = 0.304445         # +/- 0.0005641    (0.1853%)
a8              = 0.151208         # +/- 0.0002512    (0.1661%)
a10             = 0.0783334        # +/- 0.0001167    (0.149%)
a12             = 0.0407713        # +/- 5.396e-05    (0.1323%)
a14             = 4.34409          # +/- 0.01298      (0.2987%)
a16             = 16.6376          # +/- 0.07229      (0.4345%)
a1              = 0.0407561        # +/- 0.0001493    (0.3663%)
a3              = 0.129311         # +/- 0.0003574    (0.2764%)
a5              = 0.287            # +/- 0.0005011    (0.1746%)
a7              = 0.393162         # +/- 0.0003551    (0.09033%)
a9              = 0.255731         # +/- 0.0006495    (0.254%)
a11             = 0.0444644        # +/- 0.0002705    (0.6084%)
a13             = 0.00919662       # +/- 4.315e-05    (0.4692%)
a15             = 0.00131441       # +/- 8.673e-06    (0.6599%)

f1(x)  =  a1  * N * ( a2  )**(1.25) * x**2 * exp(-(a2  * x**2))
f2(x)  =  a3  * N * ( a4  )**(1.25) * x**2 * exp(-(a4  * x**2))
f3(x)  =  a5  * N * ( a6  )**(1.25) * x**2 * exp(-(a6  * x**2))
f4(x)  =  a7  * N * ( a8  )**(1.25) * x**2 * exp(-(a8  * x**2))
f5(x)  =  a9  * N * ( a10 )**(1.25) * x**2 * exp(-(a10 * x**2))
f6(x)  =  a11 * N * ( a12 )**(1.25) * x**2 * exp(-(a12 * x**2))
f7(x)  =  a13 * N * ( a14 )**(1.25) * x**2 * exp(-(a14 * x**2))
f8(x)  =  a15 * N * ( a16 )**(1.25) * x**2 * exp(-(a16 * x**2))

fit_gto(x) = f1(x) + f2(x) + f3(x) + f4(x) + f5(x) + f6(x) + f7(x)+ f8(x)

fit fit_gto(x) "sto-2p.dat" using 1:2 via a2, a4, a6, a8, a10, a12, a14, a16, a1, a3, a5, a7, a9,  a11, a13, a15
 
#fit fit_gto(x) "sto-2p.dat" using 1:2 via a2, a4, a6, a8, a10, a12, a14, a16
#fit fit_gto(x) "sto-2p.dat" using 1:2 via a1, a3, a5, a7, a9,  a11, a13, a15
 
