FIT_LIMIT   = 1e-10           
FIT_MAXITER = 0    
Pi          = acos(-1.0)
N           = 2.0 * 2.0**(0.75) / Pi**(0.25) 

a1              = 0.099155         # +/- 0.0002396    (0.2416%)
a3              = 0.538935         # +/- 0.000269     (0.04992%)
a5              = 0.496067         # +/- 0.0004377    (0.08824%)
a7              = -0.140006        # +/- 0.0001673    (0.1195%)
a9              = -0.0682088       # +/- 9.894e-05    (0.1451%)
a11             = -0.0176136       # +/- 0.0001061    (0.6022%)
a13             = -0.00287599      # +/- 3.947e-05    (1.372%)
a15             = -0.000254289     # +/- 6.565e-06    (2.582%)
a2              = 0.0288092        # +/- 1.317e-05    (0.04571%)
a4              = 0.0508069        # +/- 2.235e-05    (0.044%)
a6              = 0.0902047        # +/- 2.911e-05    (0.03228%)
a8              = 0.325494         # +/- 0.0002364    (0.07263%)
a10             = 0.68011          # +/- 0.001449     (0.213%)
a12             = 1.55357          # +/- 0.006925     (0.4457%)
a14             = 4.10011          # +/- 0.03232      (0.7884%)
a16             = 14.7399          # +/- 0.2017       (1.368%)

f1(x)  =  a1  * N * ( a2  )**(0.75) * x * exp(-(a2  * x**2))
f2(x)  =  a3  * N * ( a4  )**(0.75) * x * exp(-(a4  * x**2))
f3(x)  =  a5  * N * ( a6  )**(0.75) * x * exp(-(a6  * x**2))
f4(x)  =  a7  * N * ( a8  )**(0.75) * x * exp(-(a8  * x**2))
f5(x)  =  a9  * N * ( a10 )**(0.75) * x * exp(-(a10 * x**2))
f6(x)  =  a11 * N * ( a12 )**(0.75) * x * exp(-(a12 * x**2))
f7(x)  =  a13 * N * ( a14 )**(0.75) * x * exp(-(a14 * x**2))
f8(x)  =  a15 * N * ( a16 )**(0.75) * x * exp(-(a16 * x**2))

fit_gto(x) = f1(x) + f2(x) + f3(x) + f4(x) + f5(x) + f6(x) + f7(x) + f8(x)

fit fit_gto(x) "sto-3s.dat" using 1:2 via a1, a3, a5, a7, a9,  a11, a13, a15, a2, a4, a6, a8, a10, a12, a14, a16
