FIT_LIMIT   = 1e-10           
FIT_MAXITER = 0    
Pi          = acos(-1.0)
N           = 4 * 2**(0.75) / ( 3**(0.5) * Pi**(0.25) )


a2              = 1.06296          # +/- 0.002281     (0.2146%)
a4              = 0.494714         # +/- 0.0009444    (0.1909%)
a6              = 0.246845         # +/- 0.0004255    (0.1724%)
a8              = 0.12941          # +/- 0.0002025    (0.1565%)
a10             = 0.0699514        # +/- 9.908e-05    (0.1416%)
a12             = 0.0376963        # +/- 4.775e-05    (0.1267%)
a14             = 2.52486          # +/- 0.006275     (0.2485%)
a16             = 7.03352          # +/- 0.0215       (0.3057%)
a18             = 26.9303          # +/- 0.1197       (0.4446%)
a1              = 0.0641151        # +/- 0.0002008    (0.3131%)
a3              = 0.167614         # +/- 0.0003905    (0.233%)
a5              = 0.313161         # +/- 0.0004301    (0.1373%)
a7              = 0.363237         # +/- 0.0003607    (0.09931%)
a9              = 0.200154         # +/- 0.000586     (0.2928%)
a11             = 0.0294592        # +/- 0.00019      (0.6449%)
a13             = 0.0186153        # +/- 7.254e-05    (0.3897%)
a15             = 0.00404395       # +/- 1.968e-05    (0.4866%)
a17             = 0.000569066      # +/- 3.855e-06    (0.6775%)

f1(x)  =  a1  * N * ( a2  )**(1.25) * x**2 * exp(-(a2  * x**2))
f2(x)  =  a3  * N * ( a4  )**(1.25) * x**2 * exp(-(a4  * x**2))
f3(x)  =  a5  * N * ( a6  )**(1.25) * x**2 * exp(-(a6  * x**2))
f4(x)  =  a7  * N * ( a8  )**(1.25) * x**2 * exp(-(a8  * x**2))
f5(x)  =  a9  * N * ( a10 )**(1.25) * x**2 * exp(-(a10 * x**2))
f6(x)  =  a11 * N * ( a12 )**(1.25) * x**2 * exp(-(a12 * x**2))
f7(x)  =  a13 * N * ( a14 )**(1.25) * x**2 * exp(-(a14 * x**2))
f8(x)  =  a15 * N * ( a16 )**(1.25) * x**2 * exp(-(a16 * x**2))
f9(x)  =  a17 * N * ( a18 )**(1.25) * x**2 * exp(-(a18 * x**2))

fit_gto(x) = f1(x) + f2(x) + f3(x) + f4(x) + f5(x) + f6(x) + f7(x) + f8(x) + f9(x)

fit fit_gto(x) "sto-2p.dat" using 1:2 via a2, a4, a6, a8, a10, a12, a14, a16, a18, a1, a3, a5, a7, a9,  a11, a13, a15, a17
 
#fit fit_gto(x) "sto-2p.dat" using 1:2 via a2, a4, a6, a8, a10, a12, a14, a16, a18
#fit fit_gto(x) "sto-2p.dat" using 1:2 via a1, a3, a5, a7, a9,  a11, a13, a15, a17
 
