FIT_LIMIT   = 1e-10           
FIT_MAXITER = 0    
Pi          = acos(-1.0)
N           = 2.0 * 2.0**(0.75) / Pi**(0.25) 

a1              = 0.206812         # +/- 0.001347     (0.6515%)
a3              = 0.525051         # +/- 0.0006796    (0.1294%)
a5              = 0.391797         # +/- 0.001148     (0.2931%)
a7              = -0.131709        # +/- 9.948e-05    (0.07553%)
a9              = -0.0759833       # +/- 8.512e-05    (0.112%)
a11             = -0.022492        # +/- 5.781e-05    (0.257%)
a13             = -0.0039808       # +/- 1.588e-05    (0.3989%)
a15             = -0.000364112     # +/- 2.206e-06    (0.6058%)
a17             = 0.0160756        # +/- 0.000412     (2.563%)
a2              = 0.0360219        # +/- 8.995e-05    (0.2497%)
a4              = 0.0580583        # +/- 8.974e-05    (0.1546%)
a6              = 0.0961745        # +/- 6.838e-05    (0.0711%)
a8              = 0.306878         # +/- 0.0001827    (0.05954%)
a10             = 0.61097          # +/- 0.0006687    (0.1094%)
a12             = 1.3509           # +/- 0.002098     (0.1553%)
a14             = 3.50599          # +/- 0.007334     (0.2092%)
a16             = 12.5281          # +/- 0.03907      (0.3119%)
a18             = 0.0222659        # +/- 7.949e-05    (0.357%)

f1(x)  =  a1  * N * ( a2  )**(0.75) * x * exp(-(a2  * x**2))
f2(x)  =  a3  * N * ( a4  )**(0.75) * x * exp(-(a4  * x**2))
f3(x)  =  a5  * N * ( a6  )**(0.75) * x * exp(-(a6  * x**2))
f4(x)  =  a7  * N * ( a8  )**(0.75) * x * exp(-(a8  * x**2))
f5(x)  =  a9  * N * ( a10 )**(0.75) * x * exp(-(a10 * x**2))
f6(x)  =  a11 * N * ( a12 )**(0.75) * x * exp(-(a12 * x**2))
f7(x)  =  a13 * N * ( a14 )**(0.75) * x * exp(-(a14 * x**2))
f8(x)  =  a15 * N * ( a16 )**(0.75) * x * exp(-(a16 * x**2))
f9(x)  =  a17 * N * ( a18 )**(0.75) * x * exp(-(a18 * x**2))

fit_gto(x) = f1(x) + f2(x) + f3(x) + f4(x) + f5(x) + f6(x) + f7(x) + f8(x) + f9(x)

fit fit_gto(x) "sto-3s.dat" using 1:2 via a1, a3, a5, a7, a9,  a11, a13, a15, a17, a2, a4, a6, a8, a10, a12, a14, a16, a18
