FIT_LIMIT   = 1e-10           
FIT_MAXITER = 0    
Pi          = acos(-1.0)
N           = 16.0 * 2**(0.75) / ( 105.0**(0.5) * Pi**(0.25) )

a1              = 0.00733532       # +/- 2.65e-05     (0.3612%)
a3              = 0.0548           # +/- 2.75e-05     (0.05018%)
a5              = 0.222145         # +/- 2.584e-05    (0.01163%)
a7              = 0.43906          # +/- 2.752e-05    (0.006269%)
a9              = 0.370504         # +/- 2.339e-05    (0.006312%)
a11             = 0.0754656        # +/- 1.188e-05    (0.01574%)
a13             = 0.00356167       # +/- 1.639e-05    (0.4602%)
a15             = 3.80822e-05      # +/- 1.905e-05    (50.03%)
a17             = 0.000118505      # +/- 1.624e-05    (13.7%)

a2              = 0.863655         # +/- 0.0008591    (0.09947%)
a4              = 0.479644         # +/- 7.526e-05    (0.01569%)
a6              = 0.227682         # +/- 7.9e-06      (0.00347%)
a8              = 0.117002         # +/- 2.323e-06    (0.001986%)
a10             = 0.063344         # +/- 1.334e-06    (0.002106%)
a12             = 0.0343481        # +/- 3.005e-06    (0.008748%)
a14             = 1.66168          # +/- 0.003509     (0.2112%)
a16             = 5.2956           # +/- 0.2379       (4.492%)
a18             = 7.53196          # +/- 1.21         (16.07%)

f1(x)  =  a1  * N * ( a2  )**(2.25) * x**4 * exp(-(a2  * x**2))
f2(x)  =  a3  * N * ( a4  )**(2.25) * x**4 * exp(-(a4  * x**2))
f3(x)  =  a5  * N * ( a6  )**(2.25) * x**4 * exp(-(a6  * x**2))
f4(x)  =  a7  * N * ( a8  )**(2.25) * x**4 * exp(-(a8  * x**2))
f5(x)  =  a9  * N * ( a10 )**(2.25) * x**4 * exp(-(a10 * x**2))
f6(x)  =  a11 * N * ( a12 )**(2.25) * x**4 * exp(-(a12 * x**2))
f7(x)  =  a13 * N * ( a14 )**(2.25) * x**4 * exp(-(a14 * x**2))
f8(x)  =  a15 * N * ( a16 )**(2.25) * x**4 * exp(-(a16 * x**2))
f9(x)  =  a17 * N * ( a18 )**(2.25) * x**4 * exp(-(a18 * x**2))

fit_gto(x) = f1(x) + f2(x) + f3(x) + f4(x) + f5(x) + f6(x) + f7(x) + f8(x) + f9(x)

fit fit_gto(x) "sto-4f.dat" using 1:2 via a1, a3, a5, a7, a9,  a11, a13, a15, a17, a2, a4, a6, a8, a10, a12, a14, a16, a18

#fit fit_gto(x) "sto-4f.dat" using 1:2 via a2, a4, a6, a8, a10, a12, a14, a16, a18
#fit fit_gto(x) "sto-4f.dat" using 1:2 via a1, a3, a5, a7, a9,  a11, a13, a15, a17
