      subroutine AMOEBA(P,Y,MP,NP,NDIM,FTOL,FUNK,ITER,ITMAX,PrintFreq,
     %print_P_in_file)
      implicit none
      
* input scalars:
      integer NMAX, MP, NP , NDIM, ITER, ITMAX, PrintFreq
      double precision  FTOL, FUNK , FLast
      double precision  alpha, beta, gamma, ypr, yprr
      PARAMETER (NMAX=2100,ALPHA=1.0,BETA=0.5,GAMMA=2.0)
      double precision  P(MP,NP),Y(MP),PR(NMAX),PRR(NMAX),PBAR(NMAX)
      integer first, last, i, Loop, Nloop
      integer arrmin,imin
*
      integer j, ihi, inhi, nbvert, ilo
      double precision  pval, rtol
      double precision  tenm14 
      parameter (tenm14=1.e-14)

      external print_P_in_file
*
      write(6,'(/a)')' amoeba: entering:'

*     if(ftol.lt.tenm14) then
*        write(6,'(a,e22.15)')
*    . ' error_AMOEBA> tolerance too small =',ftol
*        stop ' error_AMOEBA> tolerance too small '
*     end if

      nbvert=NDIM+1
      
      ITER=0
1     ILO=1
      IF(Y(1).GT.Y(2))THEN
        IHI=1
        INHI=2
      ELSE
        IHI=2
        INHI=1
      ENDIF
      DO 11 I=1,nbvert
        IF(Y(I).LT.Y(ILO)) ILO=I
        IF(Y(I).GT.Y(IHI))THEN
          INHI=IHI
          IHI=I
        ELSE IF(Y(I).GT.Y(INHI))THEN
          IF(I.NE.IHI) INHI=I
        ENDIF
11    CONTINUE
      RTOL=2.*ABS(Y(IHI)-Y(ILO))/(ABS(Y(IHI))+ABS(Y(ILO)))
      if(RTOL.LT.FTOL) then
         write(6,'(a,d22.10)')
     .   ' amoeba: tolerance on function reached =',FTOL
*        if(PrintFreq.ne.0) then
*           Nloop=(MP+4)/5
*           first=1
*           do loop=1, Nloop
*              last=min(first+4,MP)
*              write(6,'(/a,i5,a,5d22.10)')
*    .       ' amoeba: iteration #',iter,' functions =',
*    .                 (Y(i),i=first,last)
*              first=first+5 
*          end do
*        end if
        RETURN
      end if

      if (iter.gt.0) then
      write(6,'(a,i5,a,d22.10)')
     .' AMOEBA: iteration #',iter,' Function =',FLast
      endif

      if(PrintFreq.ne.0) then 
       if(mod(iter,PrintFreq).eq.0 ) then


          write(6,'(a,i5,a,5d22.10)')
          imin=arrmin(Y,MP)
!          close (99)
!          open (99,file='amoeba.par')
!          write(99,'(d25.15)')(P(imin,i),i=1,NP)
!          close(99)
       call print_P_in_file
       end if
      end if

      if(iter.eq.itmax) then 
         write(6,'(a,i5)')
     .   ' amoeba: maximum iterations reached at #',itmax
         write(6,'(a,d22.10)')
     .   ' amoeba: tolerance on function still   =',RTOL
         return
      end if

      ITER=ITER+1
      DO 12 J=1,NDIM
        PBAR(J)=0.
12    CONTINUE

      DO 14 I=1,nbvert
        IF(I.NE.IHI)THEN
          DO 13 J=1,NDIM
            Pval  =P(I,J)
            PBAR(J)=PBAR(J)+P(I,J)
13        CONTINUE
        ENDIF
14    CONTINUE

      DO 15 J=1,NDIM
        PBAR(J)=PBAR(J)/NDIM
        PR(J)=(1.+ALPHA)*PBAR(J)-ALPHA*P(IHI,J)
15    CONTINUE
*
* Funk as got some change
*
      YPR=FUNK(PR,Ndim)
      FLast=YPR
      IF(YPR.LE.Y(ILO))THEN
        DO 16 J=1,NDIM
          PRR(J)=GAMMA*PR(J)+(1.-GAMMA)*PBAR(J)
16      CONTINUE
        YPRR=FUNK(PRR, Ndim)
        FLast=YPRR
        IF(YPRR.LT.Y(ILO))THEN
          DO 17 J=1,NDIM
            P(IHI,J)=PRR(J)
17        CONTINUE
          Y(IHI)=YPRR
        ELSE
          DO 18 J=1,NDIM
            P(IHI,J)=PR(J)
18        CONTINUE
          Y(IHI)=YPR
        ENDIF
      ELSE IF(YPR.GE.Y(INHI))THEN
        IF(YPR.LT.Y(IHI))THEN
          DO 19 J=1,NDIM
            P(IHI,J)=PR(J)
19        CONTINUE
          Y(IHI)=YPR
        ENDIF
        DO 21 J=1,NDIM
          PRR(J)=BETA*P(IHI,J)+(1.-BETA)*PBAR(J)
21      CONTINUE
        YPRR=FUNK(PRR, Ndim)
        FLast=YPRR
        IF(YPRR.LT.Y(IHI))THEN
          DO 22 J=1,NDIM
            P(IHI,J)=PRR(J)
22        CONTINUE
          Y(IHI)=YPRR
        ELSE
          DO 24 I=1,nbvert
            IF(I.NE.ILO)THEN
              DO 23 J=1,NDIM
                PR(J)=0.5*(P(I,J)+P(ILO,J))
                P(I,J)=PR(J)
23            CONTINUE
              Y(I)=FUNK(PR, Ndim)
              FLast=Y(I)
            ENDIF
24        CONTINUE
        ENDIF
      ELSE
        DO 25 J=1,NDIM
          P(IHI,J)=PR(J)
25      CONTINUE
        Y(IHI)=YPR
      ENDIF
      GO TO 1
      END
