! -*- f90 -*-
!-----------------------------------------------------------------------------
!          This file is part of QmcMol A GNU QMC program for molecules.
!       Copyright (C) 2002 CNRS - U.P.M.C. Paris 6 - FRANCE
!          R. Assaraf, M. Caffarel, F. Colonna, X. Krokidis, B. Levy, 
!          P. Pernod, and P. Reinhardt - qmcmol@lct.jussieu.fr
!                       http://www.lct.jussieu.fr/QmcMol
! QmcMol is free software; you can redistribute it and/or modify it
! under the terms of the GNU General Public License as published by the Free
! Software  Foundation;  either version 2, or (at your option) any later
! version. QmcMol is distributed in the hope that it will be useful,but
! WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or  FITNESS FOR A PARTICULAR PURPOSE.   See the GNU General Public License
! for  more  details.  You  should  have  received a copy of the GNU General
! Public  License  along  with  QmcMol;  see the file COPYING.  If not,
! write to the  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
! Boston, MA 02111-1307, USA.
!-----------------------------------------------------------------------------

  module basic_types_tools_mod
  use objects_mod

! generic aliases for basic types 

  real(dp), pointer :: real_0_alias                 => NULL ()
  real(dp), pointer :: real_1_alias (:)             => NULL ()
  real(dp), pointer :: real_2_alias (:,:)           => NULL ()
  real(dp), pointer :: real_3_alias (:,:,:)         => NULL ()
  real(dp), pointer :: real_4_alias (:,:,:,:)       => NULL ()
  real(dp), pointer :: real_5_alias (:,:,:,:,:)     => NULL ()
  real(dp), pointer :: real_6_alias (:,:,:,:,:,:)   => NULL ()
  real(dp), pointer :: real_7_alias (:,:,:,:,:,:,:) => NULL ()

  integer(dpi), pointer :: integer_0_alias               => NULL ()
  integer(dpi), pointer :: integer_1_alias (:)           => NULL ()
  integer(dpi), pointer :: integer_2_alias (:,:)         => NULL ()
  integer(dpi), pointer :: integer_3_alias (:,:,:)       => NULL ()
  integer(dpi), pointer :: integer_4_alias (:,:,:,:)     => NULL ()
  integer(dpi), pointer :: integer_5_alias (:,:,:,:,:)   => NULL ()
  integer(dpi), pointer :: integer_6_alias (:,:,:,:,:,:) => NULL ()

  character(len= 1), pointer :: character_1_alias (:)     => NULL ()
  character(len= 1), pointer :: character_2_alias (:,:)   => NULL ()
  character(len= 2), pointer :: character_3_alias (:,:,:) => NULL () 
    
! Description : type real_n_type  allows arrays manipulation as scalars
! Description : type real_n_type is a box to put an array, the objects 
! Description : are catalogued by the addresses of the boxes.
! Description : the routines are devoted to :
! Description : write the object
! Description : extract an array from a box
! Description : put an array in a box, and catalog.
! Description : allocate an array and catalog
! Description : allocate a new box 
! Description : real_n_alias is a generic alias for any real n-dimension array


   integer(dpi), parameter :: maxdim =  7 ! maximal dimensionality 

   type real_0_type
    real(dp), pointer :: p => NULL()
   end type real_0_type

  type (real_0_type), pointer :: real_0_type_alias 

  type real_1_type
    real(dp), pointer :: p(:) => NULL()
    character(len=8) :: dim_names (1)
  end type real_1_type

  type(real_1_type), pointer :: real_1_type_alias

  type real_2_type
     real(dp), pointer :: p(:,:) => NULL()
     character(len=8) :: dim_names (2)
  end type real_2_type

  type(real_2_type), pointer :: real_2_type_alias
 
  type real_3_type
     real(dp), pointer :: p(:,:,:) => NULL()
     character(len=8) :: dim_names (3)
  end type real_3_type

  type(real_3_type), pointer :: real_3_type_alias

  type real_4_type
     real(dp), pointer :: p(:,:,:,:) => NULL()
     character(len=8) :: dim_names (4)
  end type real_4_type

  type(real_4_type), pointer :: real_4_type_alias

  type real_5_type
     real(dp), pointer :: p(:,:,:,:,:) => NULL()
     character(len=8) :: dim_names (5)
  end type real_5_type

  type(real_5_type), pointer :: real_5_type_alias

  type real_6_type
     real(dp), pointer :: p(:,:,:,:,:,:) => NULL()
     character(len=8) :: dim_names (6)
  end type real_6_type

  type(real_6_type), pointer :: real_6_type_alias
 
  type real_7_type
     real(dp), pointer :: p(:,:,:,:,:,:,:) => NULL()
     character(len=8) :: dim_names (7)
  end type real_7_type

  type(real_7_type), pointer :: real_7_type_alias
 

! Description : integer_0 scalar
! Description : type integer_n  allows arrays manipulation as scalars
! Description : integer_n_alias is a generic alias for any integer n-dimension array

  type integer_0_type
     integer(dpi), pointer :: p => NULL()
  end type integer_0_type

   type (integer_0_type),pointer :: integer_0_type_alias

  type integer_1_type
     integer(dpi), pointer :: p(:) => NULL()
     character(len=8) :: dim_names (1)
  end type integer_1_type

  type(integer_1_type), pointer :: integer_1_type_alias

  type integer_2_type
     integer(dpi), pointer :: p(:,:) => NULL()
     character(len=8) :: dim_names (2)
  end type integer_2_type

  type(integer_2_type), pointer :: integer_2_type_alias

  type integer_3_type
     integer(dpi), pointer :: p(:,:,:) => NULL()
     character(len=8) :: dim_names (3)
  end type integer_3_type

  type(integer_3_type), pointer :: integer_3_type_alias

  type integer_4_type
     integer(dpi), pointer :: p(:,:,:,:) => NULL()
     character(len=8) :: dim_names (4)
  end type integer_4_type

  type(integer_4_type), pointer :: integer_4_type_alias

  type integer_5_type
     integer(dpi), pointer :: p(:,:,:,:,:) => NULL()
     character(len=8) :: dim_names (5)
  end type integer_5_type

  type(integer_5_type), pointer :: integer_5_type_alias

  type integer_6_type
     integer(dpi), pointer :: p(:,:,:,:,:,:) => NULL()
     character(len=8) :: dim_names (6)
  end type integer_6_type

  type(integer_6_type), pointer :: integer_6_type_alias

! the strings 

  type character_0_type 
     character(len= 1), pointer :: p => NULL ()
  end type character_0_type

  type(character_0_type), pointer :: character_0_type_alias
 
  type character_1_type 
     character(len= 1), pointer :: p (:) => NULL ()
  end type character_1_type

  type(character_1_type), pointer :: character_1_type_alias 
 
  type character_2_type 
     character(len= 1), pointer :: p (:,:) => NULL ()
  end type character_2_type

  type(character_2_type), pointer :: character_2_type_alias 

  type character_3_type
      character(len= 1), pointer :: p (:,:,:) => NULL ()
  end type character_3_type

  type(character_3_type), pointer ::  character_3_type_alias 

! allocations ot types real_n or real_n_type
  interface alloc
    module procedure real_0_allocation, &
                     real_1_allocation, &
                     real_2_allocation, &
                     real_3_allocation, &
                     real_4_allocation, &
                     real_5_allocation, &
                     real_6_allocation, &
                     real_7_allocation, &

                    integer_0_allocation, &
                    integer_1_allocation, &
                    integer_2_allocation, &
                    integer_3_allocation, &
                    integer_4_allocation, &
                    integer_5_allocation, &
                    integer_6_allocation, &

                    string_0_allocation, &
                    string_1_allocation, &
                    string_2_allocation 
  end interface

! builds an alias from an address for each type 
  interface alias_byaddr_bld
    module procedure real_0_type_alias_byaddr_bld, &
                     real_1_type_alias_byaddr_bld, &
                     real_2_type_alias_byaddr_bld, &
                     real_3_type_alias_byaddr_bld, &
                     real_4_type_alias_byaddr_bld, &
                     real_5_type_alias_byaddr_bld, &
                     real_6_type_alias_byaddr_bld, &
                     real_7_type_alias_byaddr_bld, &

                     integer_0_type_alias_byaddr_bld, &
                     integer_1_type_alias_byaddr_bld, &
                     integer_2_type_alias_byaddr_bld, &
                     integer_3_type_alias_byaddr_bld, &
                     integer_4_type_alias_byaddr_bld, &
                     integer_5_type_alias_byaddr_bld, &
                     integer_6_type_alias_byaddr_bld, &
                       
                     character_1_type_alias_byaddr_bld, & 
                     character_2_type_alias_byaddr_bld, & 
                     character_3_type_alias_byaddr_bld, &
                     real_0_byaddr_bld, &
                     real_1_byaddr_bld, &
                     real_2_byaddr_bld, &
                     real_3_byaddr_bld, &
                     real_4_byaddr_bld, &
                     real_5_byaddr_bld, &
                     real_6_byaddr_bld, &
                     real_7_byaddr_bld, &

                     integer_0_byaddr_bld, &
                     integer_1_byaddr_bld, &
                     integer_2_byaddr_bld, &
                     integer_3_byaddr_bld, &
                     integer_4_byaddr_bld, &
                     integer_5_byaddr_bld, &
                     integer_6_byaddr_bld, &
                     
                     character_1_byaddr_bld, &
                     character_2_byaddr_bld, &
                     character_3_byaddr_bld
                     
  end interface

! catalogs  a fortran object 
  interface catalog
    module procedure real_0_catalog, &
                     real_1_catalog, &
                     real_2_catalog, &
                     real_3_catalog, &
                     real_4_catalog, &
                     real_5_catalog, &
                     real_6_catalog, &
                     real_7_catalog, &

                     integer_0_catalog, &
                     integer_1_catalog, &
                     integer_2_catalog, &
                     integer_3_catalog, &
                     integer_4_catalog, &
                     integer_5_catalog, &
                     integer_6_catalog, &

                     string_0_catalog,  &
                     string_1_catalog,  &
                     string_2_catalog 
  end interface

 interface is_needed
    module procedure real_0_is_needed, &
                     real_1_is_needed, &
                     real_2_is_needed, &
                     real_3_is_needed, &
                     real_4_is_needed, &
                     real_5_is_needed, &
                     real_6_is_needed, &
                     real_7_is_needed, &

                    integer_0_is_needed, &
                    integer_1_is_needed, &
                    integer_2_is_needed, &
                    integer_3_is_needed, &
                    integer_4_is_needed, &
                    integer_5_is_needed, &
                    integer_6_is_needed, &

                    character_1_byaddr_bld, &
                    character_2_byaddr_bld, &
                    character_3_byaddr_bld
  end interface

! builds a real vector from a real array
  interface real_vector_bld
  module procedure vector_from_real_0_type_alias, &
                   vector_from_real_1_type_alias, &
                   vector_from_real_2_type_alias, &
                   vector_from_real_3_type_alias, &
                   vector_from_real_4_type_alias, &
                   vector_from_real_5_type_alias, &
                   vector_from_real_6_type_alias, &
                   vector_from_real_7_type_alias, &
                   real_1_byaddr_real_1_bld
  end interface 
  contains

! this modules contains tools only for types real_1 and real_1_type
! corresponding tools for other types are in the include file

 
! =========================================================================
  subroutine real_1_type_write (real_1_type_obj, unit)
! -------------------------------------------------------------------------
!
! Name           : real_1_type_obj
!
! Argument (in ) : real_1_type_obj
! Argument (in ) : unit
!
! Description    : prints a real_1_type object
! Description    : with a text, given by the global variable text
!
! Authors: R. Assaraf
! Date   : 17 May 2001
! -------------------------------------------------------------------------
  implicit none

! i/o:
  type(real_1_type)  :: real_1_type_obj 
  integer(dpi) :: unit
 
! local:
  character(len=max_string_len_routine_name), save :: l_here 
  integer(dpi) :: cur_type 
  integer(dpi) :: dim_1

! begin:
  if (header_exe) then

    l_here = "real_1_type_write"

   cur_type = string_in_array_locate_or_die ('real_1', types_name)

  types_write (cur_type) =  routine_cur_index ()

  return

  endif

  call enter(l_here, 10)

  if (.not.associated(real_1_type_obj%p)) then
    write (logf,*) trim(text_print), 'not associated'
  endif

  do dim_1= lbound(real_1_type_obj%p,dim = 1),ubound(real_1_type_obj%p,dim = 1)  

    message = text_print+'('+dim_1+')'
    write (unit, '(2a,g17.10)') trim(message),'=',real_1_type_obj%p(dim_1)

  enddo ! do dim_1

  text_print = blanks

  call exit(l_here, 10)

  end subroutine real_1_type_write 


! =========================================================================
  subroutine real_1_alias_bld (real_1_target, dim_1 )
! -------------------------------------------------------------------------
!
! Name           : real_1_alias_bld
!
! Argument (in ) : real_1_target
! Argument (in)  : dim_1
!
! Description    : real_1_alias => real_1_target (1:dim_1)
!
! Authors: R. Assaraf
! Date   : 21 Jul 2001
! -------------------------------------------------------------------------
  implicit none
! i/o:
  integer(dpi)     :: dim_1
  real(dp), target :: real_1_target (dim_1) 
  
! local:
  character(len=max_string_len_routine_name) :: l_here 
 
! begin:
  l_here='real_1_alias_bld'
  call enter(l_here, 10)


  real_1_alias =>  real_1_target 

  call exit(l_here, 10)

  end subroutine real_1_alias_bld

! =========================================================================
  subroutine real_1_byaddr_real_1_bld (real_1_obj, addr_obj, dim_1)
! -------------------------------------------------------------------------
!
! Name           : real_1_alias_byaddr_bld
!
! Argument (out) : alias
! Argument (in ) : addr_obj
! Argument (in)  : dim_1
!
! Description    : builds real_1_obj from the address addr_obj
! Description    : real_1_obj (1) -> addr_obj and real_1_obj (1:dim_1) 
!
! Authors: R. Assaraf
! Date  : 21 Jul 2001
! -------------------------------------------------------------------------
  implicit none
 
! i/o:
  real(dp), pointer :: real_1_obj (:)
  integer(dpi)     :: addr_obj
  integer(dpi)     :: dim_1
   
! local:
  character(len=max_string_len_routine_name) :: l_here 
  integer(dpi) :: dim_1_addr

! begin:
  l_here = 'real_1_byaddr_real_1_bld'
  call enter(l_here, 10)
 
  dim_1_addr = address (dim_1)
  call exe_by_address_2 (address (real_1_alias_bld),  (/addr_obj,  dim_1_addr/)) 

  real_1_obj =>  real_1_alias

  call exit(l_here, 10)

  end subroutine real_1_byaddr_real_1_bld



! ========================================================================
  subroutine  vector_from_real_1_type_alias (alias, real_1_obj)
! ------------------------------------------------------------------------
!
! Name           : vector_from_real_1_type_alias
!
! Argument (out) : alias 
! Argument (in)  : real_1_obj
!
! Description    :  builds an  vector alias from  real_1 array 
!
! Authors: R. Assaraf
! Date  : 15 Jul 2002
! ------------------------------------------------------------------------
  implicit none
  
! i/o:
 
  real(dp), pointer :: alias (:) 
  real(dp), target :: real_1_obj (:)

! local
  character(len=max_string_len_routine_name) :: l_here   
  integer(dpi) :: first_elm_addr
  integer(dpi) :: size_alias

! begin
  l_here= 'vector_from_real_1_type_alias'
 
   if(header_exe) then

    return
  endif
  call enter (l_here, 10)

  size_alias = size (real_1_obj)

  first_elm_addr = address (real_1_obj (1))

  call real_vector_bld (alias, first_elm_addr, size_alias)

  call exit (l_here, 10)
  
end subroutine vector_from_real_1_type_alias

! ========================================================================
  subroutine real_1_from_obj_byindex_bld (real_1_result, obj_i)
! ------------------------------------------------------------------------
!
! Name           : real_1_from_obj_byindex_bld
!
! Argument(out)  : real_1_result 
! Argument(in)   : obj_i
!
! Description    : builds the alias real_1_result of  array
! Description    : objects_names (obj_i)
!
! Authors: R. Assaraf
! Date  : 30 Jul 2002
! ------------------------------------------------------------------------
  implicit none

! i/o: 
    real(dp), pointer :: real_1_result (:)
    integer(dpi)     :: obj_i 
  
! local:

    character(len=max_string_len_fort_type) :: cur_type_name      
    character(len=max_string_len_routine_name) :: l_here

! begin:
  l_here = "real_1_from_obj_byindex_bld"
 
   call header_die

  call enter (l_here, 10)  

   if (obj_i <= 0) call die (l_here, 'obj_i='+obj_i)

    cur_type_name = types_name (objects_type (obj_i))//blanks

   if (objects_addr (obj_i) <= 0 )  &
      call die (l_here,  objects_names(obj_i)+' has the address'+&
                objects_addr (obj_i))

   select case (cur_type_name)
      
   case ('real_0')
      call alias_byaddr_bld (real_0_alias, objects_addr ( obj_i))
      call real_vector_bld (real_1_result, real_0_alias)

   case ('real_1')
      call alias_byaddr_bld (real_1_alias, objects_addr (obj_i))
      call real_vector_bld (real_1_result, real_1_alias)

   case ('real_2')
      call alias_byaddr_bld (real_2_alias, objects_addr (obj_i))
           call real_vector_bld (real_1_result, real_2_alias)

   case ('real_3')
      call alias_byaddr_bld (real_3_alias, objects_addr (obj_i))
      call real_vector_bld (real_1_result, real_3_alias)

   case ('real_4')
      call alias_byaddr_bld (real_4_alias, objects_addr (obj_i))
      call real_vector_bld (real_1_result, real_4_alias)
    
   case ('real_5')
      call alias_byaddr_bld (real_5_alias, objects_addr (obj_i))
      call real_vector_bld (real_1_result, real_5_alias)
   
   case ('real_6')
      call alias_byaddr_bld (real_6_alias, objects_addr (obj_i))
      call real_vector_bld (real_1_result, real_6_alias)
 
  case default
  call die (l_here, 'cur_type_name='+cur_type_name)

  end select

 call exit (l_here, 10)

  end subroutine real_1_from_obj_byindex_bld

! ========================================================================
  function object_dimension (obj_i)  result (result)
! ------------------------------------------------------------------------
!
! Name           : object_dimension
!
! Argument(in)  :  obj_i
!
! Description    : gives the dimension of the object of index obj_i
!
! Authors: R. Assaraf
! Date  : 16 Aug 2002
! ------------------------------------------------------------------------
  implicit none

! i/o: 
    integer(dpi) :: result
    integer(dpi) :: obj_i 
  
! local:
    integer(dpi) :: pos_dim
    character(len=max_string_len_fort_type)     :: cur_type_name      
    character(len=max_string_len_routine_name) :: l_here
    
! begin:
  call header_die
  l_here = "object_dimension"   
  call enter (l_here, 10)  

   if (obj_i <= 0) call die (l_here, 'obj_i='+obj_i)

    cur_type_name = types_name (objects_type (obj_i))//blanks
 
    pos_dim = index ( cur_type_name,'_',back = .true.) + 1
    call decode (result, cur_type_name (pos_dim:pos_dim))
 
 call exit (l_here, 10)

 end function object_dimension

! ========================================================================
  subroutine array_component_value_set (obj_i, ind ,string_value)
! ------------------------------------------------------------------------
!
! Name           : array_component_value_set
!
! Argument (in)  : obj_i
! Argument (in)  : ind
! Argument (in)  : string_value
!
! Description    : If the object of indice obj_i is 'A', ind=(1,2), 
! Description    :  string_value="3.14",  sets 'A(1,2) = 3.14'.
!
! Authors: R. Assaraf
! Date  : 16  Aug  2002
! ------------------------------------------------------------------------
  implicit none

! i/o: 
    integer(dpi), intent(in) :: obj_i
    integer(dpi), intent(in) :: ind (:) 
    character(len=*), intent(in) :: string_value 

! local:
    character(len=max_string_len_routine_name) :: l_here
    character(len=max_string_len_fort_type)    :: cur_type_name 
    character(len=max_string_len_object_name)  :: array_name 
    integer (dpi) :: obj_dim
! begin:
  call header_die
  l_here = "array_component_value_set" 
  call enter (l_here, 10)  

   if (obj_i <= 0) call die (l_here, 'obj_i='+obj_i)

   if (objects_type (obj_i) <= 0 .or. objects_addr (obj_i)== 0) then 
    call one_object_info_write (obj_i, logf, l_here )
    call die (l_here, 'object >'+objects_names(obj_i)+'< seems to be not built')
   endif 

   obj_dim = object_dimension (obj_i)
   if (types_name (objects_type (obj_i))(1:4)=='char') obj_dim =obj_dim-1

   if (size (ind) /= obj_dim) then
     write (logf,*) trim (l_here), 'size(ind)=',size(ind), 'and dimension of ',  &
                trim(objects_names(obj_i)),'=',object_dimension (obj_i)
     call die (l_here, 'should be equal')
    endif

    cur_type_name = types_name (objects_type (obj_i))//blanks
    array_name = objects_names (obj_i)//blanks 

   select case (cur_type_name)
      
   case ('real_0')
      call alias_byaddr_bld (real_0_alias, objects_addr ( obj_i))
      call decode(real_0_alias, string_value)

   case ('real_1')
      call alias_byaddr_bld (real_1_alias, objects_addr (obj_i))
      call indices_in_array_bounds_chk &
     (ind, lbound (real_1_alias), ubound (real_1_alias), array_name) 
 
      call decode(real_1_alias (ind(1)), string_value)

   case ('real_2')
      call alias_byaddr_bld (real_2_alias, objects_addr (obj_i))
      call indices_in_array_bounds_chk &
     (ind, lbound (real_2_alias), ubound (real_2_alias), array_name) 
        
      call decode(real_2_alias (ind(1), ind(2)), string_value)

   case ('real_3')
      call alias_byaddr_bld (real_3_alias, objects_addr (obj_i))
       call indices_in_array_bounds_chk &
     (ind, lbound (real_3_alias), ubound (real_3_alias), array_name) 
  
      call decode(real_3_alias (ind(1), ind(2), ind(3)), string_value)

   case ('real_4')
      call alias_byaddr_bld (real_4_alias, objects_addr (obj_i))
       call indices_in_array_bounds_chk &
     (ind, lbound (real_4_alias), ubound (real_4_alias), array_name) 
  
      call decode(real_4_alias (ind(1), ind(2), ind(3), ind(4)), string_value)

   case ('real_5')
      call alias_byaddr_bld (real_5_alias, objects_addr (obj_i))
       call indices_in_array_bounds_chk &
     (ind, lbound (real_5_alias), ubound (real_5_alias), array_name) 
  
      call decode(real_5_alias (ind (1), ind(2), ind(3), ind(4), ind (5)), string_value)

   case ('real_6')
      call alias_byaddr_bld (real_6_alias, objects_addr (obj_i))
       call indices_in_array_bounds_chk &
     (ind, lbound (real_6_alias), ubound (real_6_alias), array_name) 
  
      call decode(real_6_alias (ind(1), ind(2), ind(3), ind(4), ind (5), ind(6)), string_value)


   case ('integer_0')
      call alias_byaddr_bld (integer_0_alias, objects_addr ( obj_i))
      call decode(integer_0_alias, string_value)

   case ('integer_1')
      call alias_byaddr_bld (integer_1_alias, objects_addr (obj_i))
      call indices_in_array_bounds_chk &
     (ind, lbound (integer_1_alias), ubound (integer_1_alias), array_name) 
 
      call decode(integer_1_alias (ind(1)), string_value)

   case ('integer_2')
      call alias_byaddr_bld (integer_2_alias, objects_addr (obj_i))
      call indices_in_array_bounds_chk &
     (ind, lbound (integer_2_alias), ubound (integer_2_alias), array_name) 
        
      call decode(integer_2_alias (ind(1), ind(2)), string_value)

   case ('integer_3')
      call alias_byaddr_bld (integer_3_alias, objects_addr (obj_i))
       call indices_in_array_bounds_chk &
     (ind, lbound (integer_3_alias), ubound (integer_3_alias), array_name) 
  
      call decode(integer_3_alias (ind(1), ind(2), ind(3)), string_value)

   case ('integer_4')
      call alias_byaddr_bld (integer_4_alias, objects_addr (obj_i))
       call indices_in_array_bounds_chk &
     (ind, lbound (integer_4_alias), ubound (integer_4_alias), array_name) 
  
      call decode(integer_4_alias (ind(1), ind(2), ind(3), ind(4)), string_value)

   case ('integer_5')
      call alias_byaddr_bld (integer_5_alias, objects_addr (obj_i))
       call indices_in_array_bounds_chk &
     (ind, lbound (integer_5_alias), ubound (integer_5_alias), array_name) 
  
      call decode(integer_5_alias (ind (1), ind(2), ind(3), ind(4), ind (5)), string_value)

   case ('integer_6')
      call alias_byaddr_bld (integer_6_alias, objects_addr (obj_i))
       call indices_in_array_bounds_chk &
     (ind, lbound (integer_6_alias), ubound (integer_6_alias), array_name) 
  
      call decode(integer_6_alias (ind(1), ind(2), ind(3), ind(4), ind (5), ind(6)), string_value)

    case ('character_1')
      call alias_byaddr_bld (character_1_alias, objects_addr ( obj_i))
      call string_to_char_1 (character_1_alias, string_value)

   case ('character_2')
      call alias_byaddr_bld (character_2_alias, objects_addr (obj_i))
      call indices_in_array_bounds_chk &
     (ind, lbound (character_2_alias (1,:)), ubound (character_2_alias(1,:)), array_name)
 
      call string_to_char_1 (character_2_alias (:,ind(1)), string_value)
    
  case default
  call die (l_here, 'cur_type_name='+cur_type_name)

  end select

 call exit (l_here, 10)

  end subroutine array_component_value_set

! ================================================================
  subroutine indices_in_array_bounds_chk (ind, lb,ub, array_name) 
! ----------------------------------------------------------------
!
! Name          : indices_in_array_bounds_chk
!
! Argument (in) : ind
! Argument (in) : lb
! Argument (in) : ub
! Argument (in) : array_name
!
! Description   : checks that  lb < ind < ub
!
! Authors: R. Assaraf
! Date   : 16 Aug 2002
! ----------------------------------------------------------------
  implicit none

! i/o:
  integer(dpi), intent(in)       :: ind (:)
  integer(dpi), intent(in)       :: lb  (:)
  integer(dpi), intent(in)       :: ub  (:)
  character (len=*), intent (in) :: array_name 
  
! local:      
  integer(dpi)    :: i
  logical (bool)  :: ind_in_bounds 
  character(len=max_string_len_routine_name) :: l_here 

! begin:
  call header_die
  l_here='indices_in_array_bounds_chk'
  call enter(l_here, 10)
 
  if (size (ind) /= size (lb) .or. size (ind) /= size (ub) .or. &
       size (ub) /= size (lb)) then

     write (logf,*) trim (l_here), ' checking size compatibility for array >', &
          trim (array_name), '<'
     write (logf,*) trim (l_here), ' size (ind)=', size (ind)
     write (logf,*) trim (l_here), ' size (lb)=', size (lb)
     write (logf,*) trim (l_here), ' size (ub)=', size (ub)
     call die (l_here, 'should be equal ')
  endif

   ind_in_bounds = .true. 
   do i = 1, size (ind)
    if (ind (i) < lb (i) .or. ind (i) > ub (i)) ind_in_bounds = .false.
   enddo
  
   if (.not.ind_in_bounds) then
      write (logf,*) trim (l_here), ' request on  ', trim (array_name), '(ind)', &
           ' with ind=', ind
      write (logf,*) trim (l_here), ' lb= ', lb 
      write (logf,*)  trim (l_here),' ub= ', ub
      call die (l_here, ' indices not compatible with array boundaries ' )
   endif
   
   call exit(l_here, 10)

  end subroutine indices_in_array_bounds_chk


! ================================================================
  subroutine real_objects_gather_bld (par, objs_byind)
! ----------------------------------------------------------------
!
! Name          : real_objects_gather_bld
!
! Description   : builds par (1: n) so it  contains all the values 
! Description   : of the reals arrays in objs_byind
!
! Authors: R. Assaraf
! Date   : 02 Aug 2002
! ----------------------------------------------------------------
  implicit none

! i/o:
  real(dp), pointer :: par  (:)
  integer(dpi)     :: objs_byind (:)


! local:      
  type (real_1_type), pointer, save :: real_1_objs (:) => NULL ()
  integer(dpi)  :: objs_byind_values_nb
  integer(dpi)    :: i, j, par_ind
  character(len=max_string_len_routine_name) :: l_here 

! begin:
  l_here='real_objects_gather_bld'
  
  if (header_exe) then

  return 
  endif
    
   call enter(l_here, 10)
 
! builds real_1_objs aliases of objects described by objs_byind
   if (associated (real_1_objs)) then 
      if (size(real_1_objs) /= size (objs_byind))  then
         deallocate (real_1_objs)
         allocate (real_1_objs (size (objs_byind)))
      endif
   else
      allocate (real_1_objs(size (objs_byind)))
   endif
  
   do i = 1,  size (real_1_objs)
      call real_1_from_obj_byindex_bld (real_1_objs(i)%p, objs_byind (i))
   enddo

! allocation of par
   objs_byind_values_nb = 0
   do i = 1, size (real_1_objs)
      objs_byind_values_nb = objs_byind_values_nb + size (real_1_objs (i)%p)
   enddo
   
   if (associated (par)) then
      if (size (par) /= objs_byind_values_nb) then
         deallocate (par)
         allocate (par (objs_byind_values_nb))
      endif
   else          
      allocate (par (objs_byind_values_nb))
   endif
      
! fills par with the values 
      par_ind = 0 
      do i = 1, size (real_1_objs)
         do j = 1, size (real_1_objs(i)%p)
         par_ind = par_ind +1
         par (par_ind) = real_1_objs(i)%p(j)
         enddo
      enddo

 
   call exit(l_here, 10)

  end subroutine real_objects_gather_bld

! ================================================================
  subroutine real_objects_scatter_bld (objs_byind, par)
! ----------------------------------------------------------------
!
! Name          : real_objects_scatter_bld
!
! Description   : the real objects are affected to the values of par (1..n) 
!
! Authors: R. Assaraf
! Date   : 02 Aug 2002
! ----------------------------------------------------------------
  implicit none

! i/o:
  real(dp) :: par  (:)
  integer(dpi)  :: objs_byind (:)


! local:      
  type (real_1_type), pointer, save :: real_1_objs (:) => NULL ()
  integer(dpi)                     :: objs_byind_values_nb
  integer(dpi)                     :: i, j, par_ind
  character(len=max_string_len_routine_name) :: l_here 

! begin:
  l_here='real_objects_scatter_bld'
  
  if (header_exe) then

  return 
  endif
    
   call enter(l_here, 10)
   
    if (associated (real_1_objs)) then 
      if (size(real_1_objs) /= size (objs_byind))  then
         deallocate (real_1_objs)
         allocate (real_1_objs (size (objs_byind)))
      endif
   else
      allocate (real_1_objs(size (objs_byind)))
   endif

   do i = 1,  size (real_1_objs)
      call real_1_from_obj_byindex_bld (real_1_objs(i)%p, objs_byind (i))
   enddo

   objs_byind_values_nb = 0
   do i = 1, size (real_1_objs)
      objs_byind_values_nb = objs_byind_values_nb + size (real_1_objs (i)%p)
   enddo

   if (objs_byind_values_nb /= size (par)) call die (l_here,  &
         'objs_byind_values_nb='+objs_byind_values_nb+        &
         ' should be equal to size(par)='+size(par))   
      
      par_ind = 0 
      do i = 1, size (real_1_objs)
         do j = 1, size (real_1_objs(i)%p)
         par_ind = par_ind +1
         real_1_objs(i)%p(j) = par (par_ind)
         enddo
      enddo
 
   call exit(l_here, 10)

  end subroutine real_objects_scatter_bld
 
!==========================================================================
  function scalar_integer_value (name) result (result)
!--------------------------------------------------------------------------
!
! Name           : scalar_integer_value
!
! Argument (in ) : name
!
! Descriptions   : value of scalar integer object
!
! Authors:F.Colonna
! Date  :20 Jan 2003
! --------------------------------------------------------------------------
  implicit none

! result:
  integer(dpi)        :: result 

! i/o:
  character(len=*)    :: name   

! local:
  character(len=max_string_len_routine_name) :: l_here
  integer(dpi), pointer :: integer_0_obj
  integer(dpi)          :: addr_obj, ind_obj

! begin:
  l_here ='scalar_integer_value'
  call enter (l_here)

  if(debug) then
    write (logf,*) trim(l_here),'-d: name >',trim(name),'<'
  end if

	ind_obj = object_index (name)
  addr_obj = objects_addr (ind_obj)  

  call integer_0_byaddr_bld (integer_0_obj, addr_obj)
  result = integer_0_obj

  call exit (l_here)

  if(debug) then
    write (logf,*) trim(l_here),'-d: result = ',result
  end if

  end function scalar_integer_value

!==========================================================================
  subroutine scalar_integer_store (name, value)
!--------------------------------------------------------------------------
!
! Name           : scalar_integer_store
!
! Argument (in ) : name
!
! Descriptions   : store integer value as object name
!
! Authors:F.Colonna
! Date  :20 Jan 2003
! --------------------------------------------------------------------------
  implicit none

! i/o:
  character(len=*)    :: name   
  integer(dpi)        :: value  

! local:
  character(len=max_string_len_routine_name) :: l_here
  integer(dpi), pointer :: integer_0_obj
  integer(dpi)          :: addr_obj, ind_obj

! begin:
  l_here ='scalar_integer_store'
  call enter (l_here)

  if(debug) then
    write (logf,*) trim(l_here),'-d: name >',trim(name),'<'
    write (logf,*) trim(l_here),'-d: value=',value 
  end if

	ind_obj = object_index (name)
  addr_obj = objects_addr (ind_obj)  

  call integer_0_byaddr_bld (integer_0_obj, addr_obj)
  integer_0_obj = value

  call exit (l_here)

  end subroutine scalar_integer_store 


!!! others_types


!----------------------------------------------------------------------
  subroutine string_0_catalog (name, string_0_obj)
! -------------------------------------------------------------------------
!
! Name           : string_0_catalog
!
! Argument       : name
! Argument       : string_0_type_obj
!
! Description    : catalog  string_0_obj
!
! Authors: R. Assaraf
! Date   : 15 Aug 2002
! -------------------------------------------------------------------------
  implicit none

! i/o:
  character (len=*) :: name
  character(len=*)  :: string_0_obj
 
! local:
  character (len=max_string_len_routine_name) :: l_here
  integer(dpi)      :: len_string_0_obj

! begin:
  l_here='string_0_catalog'
  call enter(l_here, 10)
    len_string_0_obj = len (string_0_obj)
    call char_1_byaddr_char_1_bld (character_1_alias,address (string_0_obj(1:1)), len_string_0_obj)

    call character_1_catalog (name,character_1_alias)

  nullify (character_1_alias)

  call exit (l_here, 10)

  end subroutine string_0_catalog

!----------------------------------------------------------------------
  subroutine string_1_catalog (name, string_1_obj)
! -------------------------------------------------------------------------
!
! Name           : string_1_catalog
!
! Argument(in)   : name
! Argument(in)   : string_1_type_obj
!
! Description    : catalog  an array of strings 
!
! Authors: R. Assaraf
! Date   : 15  Aug 2002
! -------------------------------------------------------------------------
  implicit none

! i/o:
  character (len=*) :: name
  character(len=*)  :: string_1_obj (:)
   
! local:
  character (len=max_string_len_routine_name) :: l_here
  integer(dpi) :: len_string_1_obj

! begin:
  l_here='string_1_catalog'
  call enter(l_here, 10)

    len_string_1_obj = len (string_1_obj)

    call char_2_byaddr_char_2_bld (character_2_alias,          &
                                             address (string_1_obj(1)(1:1)),&
           len_string_1_obj, size (string_1_obj))

    call character_2_catalog (name,character_2_alias)

  nullify (character_2_alias)

  call exit (l_here, 10)

  end subroutine string_1_catalog

 !----------------------------------------------------------------------
  subroutine string_2_catalog (name, string_2_obj)
! -------------------------------------------------------------------------
!
! Name           : string_2_catalog
!
! Argument(in)   : name
! Argument(in)   : string_2_type_obj
!
! Description    : catalog  an array of strings 
!
! Authors: R. Assaraf
! Date   : 15  Aug 2002
! -------------------------------------------------------------------------
  implicit none

! i/o:
  character (len=*) :: name
  character(len=*)  :: string_2_obj (:,:)
  
! local:
  character (len=max_string_len_routine_name) :: l_here
  integer(dpi)      :: len_string_2_obj

! begin:
  l_here='string_2_catalog'
  call enter(l_here, 10)
    len_string_2_obj = len (string_2_obj)
    call char_2_byaddr_char_2_bld (character_2_alias,          &
                                             address (string_2_obj(1,1)(1:1)),&
           len_string_2_obj, size (string_2_obj))

    call character_2_catalog (name,character_2_alias)

  nullify (character_2_alias)

  call exit (l_here, 10)

  end subroutine string_2_catalog

!----------------------------------------------------------------------
  subroutine string_0_allocation (name, string_0_obj)
! -------------------------------------------------------------------------
!
! Name           : string_0_allocation
!
! Argument       : name
! Argument       : string_0_type_obj
!
! Description    : allocation  string_0_obj
!
! Authors: R. Assaraf
! Date   : 15 Aug 2002
! -------------------------------------------------------------------------
  implicit none

! i/o:
  character (len=*)         :: name
  character(len=*), pointer :: string_0_obj

! local:
  character (len=max_string_len_routine_name) :: l_here

! begin:
  l_here='string_0_allocation'
  call enter(l_here, 10)

  cur_create = cur_create + 1
  allocate (string_0_obj)
  call catalog (name, string_0_obj)

  call exit (l_here, 10)

  end subroutine string_0_allocation

!----------------------------------------------------------------------
  subroutine string_1_allocation (name, string_1_obj, dim_1)
! -------------------------------------------------------------------------
!
! Name           : string_1_allocation
!
! Argument(in)   : name
! Argument(in)   : string_1_type_obj
! Argument(in)   : dim_1
! Description    : allocation  of an array of strings 
!
! Authors: R. Assaraf
! Date   : 15  Aug 2002
! -------------------------------------------------------------------------
  implicit none

! i/o:
  character (len=*) :: name
  character(len=*), pointer  :: string_1_obj (:) 
  integer (dpi)              :: dim_1

! local:
  character (len=max_string_len_routine_name) :: l_here

! begin:
  l_here='string_1_allocation'
  call enter(l_here, 10)

  cur_create = cur_create + 1

  allocate (string_1_obj (dim_1))

  write (logf,*) trim (l_here), ': allocate (', trim (name), '(', dim_1,') )'

  call catalog (name, string_1_obj)

  call exit (l_here, 10)

  end subroutine string_1_allocation

!----------------------------------------------------------------------
  subroutine string_2_allocation (name, string_2_obj, dim_1, dim_2)
! -------------------------------------------------------------------------
!
! Name           : string_2_allocation
!
! Argument(in)   : name
! Argument(in)   : string_2_type_obj
! Argument(in)   : dim_1, dim_2
! Description    : allocation  of an array of strings 
!
! Authors: R. Assaraf
! Date   : 15  Aug 2002
! -------------------------------------------------------------------------
  implicit none

! i/o:
  character (len=*) :: name
  character(len=*), pointer  :: string_2_obj (:,:) 
  integer (dpi)              :: dim_1, dim_2

! local:
  character (len=max_string_len_routine_name) :: l_here

! begin:
  l_here='string_2_allocation'
  call enter(l_here, 10)
  
  cur_create = cur_create + 1

  allocate (string_2_obj (dim_1,dim_2))

  write (logf,*) trim (l_here), ': allocate (', trim (name), '(', dim_1,',',dim_2,') )'

  call catalog (name, string_2_obj)

  call exit (l_here, 10)

  end subroutine string_2_allocation

!----------------------------------------------------------------------
  subroutine real_0_type_write (real_0_type_obj, unit)
! -------------------------------------------------------------------------
!
! Name           : real_0_type_obj
!
! Argument (in ) : real_0_type_obj
! Argument (in ) : unit
!
! Description    : prints a real_0_type object
! Description    : with a text, given by the global variable text
!
! Authors: R. Assaraf
! Date   : 17 May 2001
! -------------------------------------------------------------------------
  implicit none

! i/o:
  type(real_0_type)  :: real_0_type_obj 
  integer(dpi) :: unit
 
! local:
  character(len=max_string_len_routine_name), save :: l_here 
  integer(dpi) :: cur_type 

! begin:
  if (header_exe) then

    l_here = "real_0_type_write"

   cur_type = string_in_array_locate_or_die ('real_0', types_name)

  types_write (cur_type) =  routine_cur_index ()

  return

  endif

  call enter(l_here, 10)

  if (.not.associated(real_0_type_obj%p)) then
    write (logf,*) trim(text_print), 'not associated'
  endif


    message = text_print
    write (unit, '(2a,g17.10)') trim(message),'=',real_0_type_obj%p


  text_print = blanks

  call exit(l_here, 10)

  end subroutine real_0_type_write 
 
!----------------------------------------------------------------------
  subroutine real_2_type_write (real_2_type_obj, unit)
! -------------------------------------------------------------------------
!
! Name           : real_2_type_obj
!
! Argument (in ) : real_2_type_obj
! Argument (in ) : unit
!
! Description    : prints a real_2_type object
! Description    : with a text, given by the global variable text
!
! Authors: R. Assaraf
! Date   : 17 May 2001
! -------------------------------------------------------------------------
  implicit none

! i/o:
  type(real_2_type)  :: real_2_type_obj 
  integer(dpi) :: unit
 
! local:
  character(len=max_string_len_routine_name), save :: l_here 
  integer(dpi) :: cur_type 
  integer(dpi) :: dim_1,dim_2

! begin:
  if (header_exe) then

    l_here = "real_2_type_write"

   cur_type = string_in_array_locate_or_die ('real_2', types_name)

  types_write (cur_type) =  routine_cur_index ()

  return

  endif

  call enter(l_here, 10)

  if (.not.associated(real_2_type_obj%p)) then
    write (logf,*) trim(text_print), 'not associated'
  endif

  do dim_1= lbound(real_2_type_obj%p,dim = 1),ubound(real_2_type_obj%p,dim = 1)  
  do dim_2= lbound(real_2_type_obj%p,dim = 2),ubound(real_2_type_obj%p,dim = 2)  

    message = text_print+'('+dim_1+','+dim_2+')'
    write (unit, '(2a,g17.10)') trim(message),'=',real_2_type_obj%p(dim_1,dim_2)

 enddo ! do dim_1
 enddo ! do dim_2
  text_print = blanks

  call exit(l_here, 10)

  end subroutine real_2_type_write 
 
!----------------------------------------------------------------------
  subroutine real_3_type_write (real_3_type_obj, unit)
! -------------------------------------------------------------------------
!
! Name           : real_3_type_obj
!
! Argument (in ) : real_3_type_obj
! Argument (in ) : unit
!
! Description    : prints a real_3_type object
! Description    : with a text, given by the global variable text
!
! Authors: R. Assaraf
! Date   : 17 May 2001
! -------------------------------------------------------------------------
  implicit none

! i/o:
  type(real_3_type)  :: real_3_type_obj 
  integer(dpi) :: unit
 
! local:
  character(len=max_string_len_routine_name), save :: l_here 
  integer(dpi) :: cur_type 
  integer(dpi) :: dim_1,dim_2,dim_3

! begin:
  if (header_exe) then

    l_here = "real_3_type_write"

   cur_type = string_in_array_locate_or_die ('real_3', types_name)

  types_write (cur_type) =  routine_cur_index ()

  return

  endif

  call enter(l_here, 10)

  if (.not.associated(real_3_type_obj%p)) then
    write (logf,*) trim(text_print), 'not associated'
  endif

  do dim_1= lbound(real_3_type_obj%p,dim = 1),ubound(real_3_type_obj%p,dim = 1)  
  do dim_2= lbound(real_3_type_obj%p,dim = 2),ubound(real_3_type_obj%p,dim = 2)  
  do dim_3= lbound(real_3_type_obj%p,dim = 3),ubound(real_3_type_obj%p,dim = 3)  

    message = text_print+'('+dim_1+','+dim_2+','+dim_3+')'
    write (unit, '(2a,g17.10)') trim(message),'=',real_3_type_obj%p(dim_1,dim_2,dim_3)

 enddo ! do dim_1
 enddo ! do dim_2
 enddo ! do dim_3
  text_print = blanks

  call exit(l_here, 10)

  end subroutine real_3_type_write 
 
!----------------------------------------------------------------------
  subroutine real_4_type_write (real_4_type_obj, unit)
! -------------------------------------------------------------------------
!
! Name           : real_4_type_obj
!
! Argument (in ) : real_4_type_obj
! Argument (in ) : unit
!
! Description    : prints a real_4_type object
! Description    : with a text, given by the global variable text
!
! Authors: R. Assaraf
! Date   : 17 May 2001
! -------------------------------------------------------------------------
  implicit none

! i/o:
  type(real_4_type)  :: real_4_type_obj 
  integer(dpi) :: unit
 
! local:
  character(len=max_string_len_routine_name), save :: l_here 
  integer(dpi) :: cur_type 
  integer(dpi) :: dim_1,dim_2,dim_3,dim_4

! begin:
  if (header_exe) then

    l_here = "real_4_type_write"

   cur_type = string_in_array_locate_or_die ('real_4', types_name)

  types_write (cur_type) =  routine_cur_index ()

  return

  endif

  call enter(l_here, 10)

  if (.not.associated(real_4_type_obj%p)) then
    write (logf,*) trim(text_print), 'not associated'
  endif

  do dim_1= lbound(real_4_type_obj%p,dim = 1),ubound(real_4_type_obj%p,dim = 1)  
  do dim_2= lbound(real_4_type_obj%p,dim = 2),ubound(real_4_type_obj%p,dim = 2)  
  do dim_3= lbound(real_4_type_obj%p,dim = 3),ubound(real_4_type_obj%p,dim = 3)  
  do dim_4= lbound(real_4_type_obj%p,dim = 4),ubound(real_4_type_obj%p,dim = 4)  

    message = text_print+'('+dim_1+','+dim_2+','+dim_3+','+dim_4+')'
    write (unit, '(2a,g17.10)') trim(message),'=',real_4_type_obj%p(dim_1,dim_2,dim_3,dim_4)

 enddo ! do dim_1
 enddo ! do dim_2
 enddo ! do dim_3
 enddo ! do dim_4
  text_print = blanks

  call exit(l_here, 10)

  end subroutine real_4_type_write 
 
!----------------------------------------------------------------------
  subroutine real_5_type_write (real_5_type_obj, unit)
! -------------------------------------------------------------------------
!
! Name           : real_5_type_obj
!
! Argument (in ) : real_5_type_obj
! Argument (in ) : unit
!
! Description    : prints a real_5_type object
! Description    : with a text, given by the global variable text
!
! Authors: R. Assaraf
! Date   : 17 May 2001
! -------------------------------------------------------------------------
  implicit none

! i/o:
  type(real_5_type)  :: real_5_type_obj 
  integer(dpi) :: unit
 
! local:
  character(len=max_string_len_routine_name), save :: l_here 
  integer(dpi) :: cur_type 
  integer(dpi) :: dim_1,dim_2,dim_3,dim_4,dim_5

! begin:
  if (header_exe) then

    l_here = "real_5_type_write"

   cur_type = string_in_array_locate_or_die ('real_5', types_name)

  types_write (cur_type) =  routine_cur_index ()

  return

  endif

  call enter(l_here, 10)

  if (.not.associated(real_5_type_obj%p)) then
    write (logf,*) trim(text_print), 'not associated'
  endif

  do dim_1= lbound(real_5_type_obj%p,dim = 1),ubound(real_5_type_obj%p,dim = 1)  
  do dim_2= lbound(real_5_type_obj%p,dim = 2),ubound(real_5_type_obj%p,dim = 2)  
  do dim_3= lbound(real_5_type_obj%p,dim = 3),ubound(real_5_type_obj%p,dim = 3)  
  do dim_4= lbound(real_5_type_obj%p,dim = 4),ubound(real_5_type_obj%p,dim = 4)  
  do dim_5= lbound(real_5_type_obj%p,dim = 5),ubound(real_5_type_obj%p,dim = 5)  

    message = text_print+'('+dim_1+','+dim_2+','+dim_3+','+dim_4+','+dim_5+')'
    write (unit, '(2a,g17.10)') trim(message),'=',real_5_type_obj%p(dim_1,dim_2,dim_3,dim_4,dim_5)

 enddo ! do dim_1
 enddo ! do dim_2
 enddo ! do dim_3
 enddo ! do dim_4
 enddo ! do dim_5
  text_print = blanks

  call exit(l_here, 10)

  end subroutine real_5_type_write 
 
!----------------------------------------------------------------------
  subroutine real_6_type_write (real_6_type_obj, unit)
! -------------------------------------------------------------------------
!
! Name           : real_6_type_obj
!
! Argument (in ) : real_6_type_obj
! Argument (in ) : unit
!
! Description    : prints a real_6_type object
! Description    : with a text, given by the global variable text
!
! Authors: R. Assaraf
! Date   : 17 May 2001
! -------------------------------------------------------------------------
  implicit none

! i/o:
  type(real_6_type)  :: real_6_type_obj 
  integer(dpi) :: unit
 
! local:
  character(len=max_string_len_routine_name), save :: l_here 
  integer(dpi) :: cur_type 
  integer(dpi) :: dim_1,dim_2,dim_3,dim_4,dim_5,dim_6

! begin:
  if (header_exe) then

    l_here = "real_6_type_write"

   cur_type = string_in_array_locate_or_die ('real_6', types_name)

  types_write (cur_type) =  routine_cur_index ()

  return

  endif

  call enter(l_here, 10)

  if (.not.associated(real_6_type_obj%p)) then
    write (logf,*) trim(text_print), 'not associated'
  endif

  do dim_1= lbound(real_6_type_obj%p,dim = 1),ubound(real_6_type_obj%p,dim = 1)  
  do dim_2= lbound(real_6_type_obj%p,dim = 2),ubound(real_6_type_obj%p,dim = 2)  
  do dim_3= lbound(real_6_type_obj%p,dim = 3),ubound(real_6_type_obj%p,dim = 3)  
  do dim_4= lbound(real_6_type_obj%p,dim = 4),ubound(real_6_type_obj%p,dim = 4)  
  do dim_5= lbound(real_6_type_obj%p,dim = 5),ubound(real_6_type_obj%p,dim = 5)  
  do dim_6= lbound(real_6_type_obj%p,dim =6),ubound(real_6_type_obj%p,dim = 6)  

    message = text_print+'('+dim_1+','+dim_2+','+dim_3+','+dim_4+','+dim_5+','+dim_6+')'
    write (unit, '(2a,g17.10)') trim(message),'=',real_6_type_obj%p(dim_1,dim_2,dim_3,dim_4,dim_5,dim_6)

 enddo ! do dim_1
 enddo ! do dim_2
 enddo ! do dim_3
 enddo ! do dim_4
 enddo ! do dim_5
 enddo ! do dim_6
  text_print = blanks

  call exit(l_here, 10)

  end subroutine real_6_type_write 
 
!----------------------------------------------------------------------
  subroutine real_7_type_write (real_7_type_obj, unit)
! -------------------------------------------------------------------------
!
! Name           : real_7_type_obj
!
! Argument (in ) : real_7_type_obj
! Argument (in ) : unit
!
! Description    : prints a real_7_type object
! Description    : with a text, given by the global variable text
!
! Authors: R. Assaraf
! Date   : 17 May 2001
! -------------------------------------------------------------------------
  implicit none

! i/o:
  type(real_7_type)  :: real_7_type_obj 
  integer(dpi) :: unit
 
! local:
  character(len=max_string_len_routine_name), save :: l_here 
  integer(dpi) :: cur_type 
  integer(dpi) :: dim_1,dim_2,dim_3,dim_4,dim_5,dim_6,dim_7

! begin:
  if (header_exe) then

    l_here = "real_7_type_write"

   cur_type = string_in_array_locate_or_die ('real_7', types_name)

  types_write (cur_type) =  routine_cur_index ()

  return

  endif

  call enter(l_here, 10)

  if (.not.associated(real_7_type_obj%p)) then
    write (logf,*) trim(text_print), 'not associated'
  endif

  do dim_1= lbound(real_7_type_obj%p,dim = 1),ubound(real_7_type_obj%p,dim = 1)  
  do dim_2= lbound(real_7_type_obj%p,dim = 2),ubound(real_7_type_obj%p,dim = 2)  
  do dim_3= lbound(real_7_type_obj%p,dim = 3),ubound(real_7_type_obj%p,dim = 3)  
  do dim_4= lbound(real_7_type_obj%p,dim = 4),ubound(real_7_type_obj%p,dim = 4)  
  do dim_5= lbound(real_7_type_obj%p,dim = 5),ubound(real_7_type_obj%p,dim = 5)  
  do dim_6= lbound(real_7_type_obj%p,dim = 6),ubound(real_7_type_obj%p,dim = 6)  
  do dim_7= lbound(real_7_type_obj%p,dim = 7),ubound(real_7_type_obj%p,dim = 7)  

    message = text_print+'('+dim_1+','+dim_2+','+dim_3+','+dim_4+','+dim_5+','+dim_6+','+dim_7+')'
    write (unit, '(2a,g17.10)') trim(message),'=',real_7_type_obj%p(dim_1,dim_2,dim_3,dim_4,dim_5,dim_6,dim_7)

 enddo ! do dim_1
 enddo ! do dim_2
 enddo ! do dim_3
 enddo ! do dim_4
 enddo ! do dim_5
 enddo ! do dim_6
 enddo ! do dim_7

  text_print = blanks

  call exit(l_here, 10)

  end subroutine real_7_type_write 
  
!----------------------------------------------------------------------
  subroutine  vector_from_real_0_type_alias (alias, real_0_obj)
! ------------------------------------------------------------------------
!
! Name           : vector_from_real_0_type_alias
!
! Argument (out) : alias 
! Argument (in)  : real_0_obj
!
! Description    :  builds an  vector alias from  real_0 array 
!
! Authors: R. Assaraf
! Date  : 15 Jul 2002
! ------------------------------------------------------------------------
  implicit none
  
! i/o:
 
  real(dp), pointer :: alias (:) 
  real(dp), target :: real_0_obj 

! local
  character(len=max_string_len_routine_name), save :: l_here   
  integer(dpi) :: first_elm_addr
  integer(dpi) :: size_alias

! begin
  l_here= 'vector_from_real_0_type_alias'
 
   if(header_exe) then

    return
  endif
  call enter (l_here, 10)

  size_alias = 1

  first_elm_addr = address (real_0_obj)

  call real_vector_bld (alias, first_elm_addr, size_alias)

  call exit (l_here, 10)
  
end subroutine vector_from_real_0_type_alias
 
!----------------------------------------------------------------------
  subroutine  vector_from_real_2_type_alias (alias, real_2_obj)
! ------------------------------------------------------------------------
!
! Name           : vector_from_real_2_type_alias
!
! Argument (out) : alias 
! Argument (in)  : real_2_obj
!
! Description    :  builds an  vector alias from  real_2 array 
!
! Authors: R. Assaraf
! Date  : 15 Jul 2002
! ------------------------------------------------------------------------
  implicit none
  
! i/o:
 
  real(dp), pointer :: alias (:) 
  real(dp), target :: real_2_obj (:,:)

! local
  character(len=max_string_len_routine_name), save :: l_here   
  integer(dpi) :: first_elm_addr
  integer(dpi) :: size_alias

! begin
  l_here= 'vector_from_real_2_type_alias'
 
   if(header_exe) then

    return
  endif
  call enter (l_here, 10)

  size_alias = size (real_2_obj)

  first_elm_addr = address (real_2_obj (1,1))

  call real_vector_bld (alias, first_elm_addr, size_alias)

  call exit (l_here, 10)
  
end subroutine vector_from_real_2_type_alias
 
!----------------------------------------------------------------------
  subroutine  vector_from_real_3_type_alias (alias, real_3_obj)
! ------------------------------------------------------------------------
!
! Name           : vector_from_real_3_type_alias
!
! Argument (out) : alias 
! Argument (in)  : real_3_obj
!
! Description    :  builds an  vector alias from  real_3 array 
!
! Authors: R. Assaraf
! Date  : 15 Jul 2002
! ------------------------------------------------------------------------
  implicit none
  
! i/o:
 
  real(dp), pointer :: alias (:) 
  real(dp), target :: real_3_obj (:,:,:)

! local
  character(len=max_string_len_routine_name), save :: l_here   
  integer(dpi) :: first_elm_addr
  integer(dpi) :: size_alias

! begin
  l_here= 'vector_from_real_3_type_alias'
 
   if(header_exe) then

    return
  endif
  call enter (l_here, 10)

  size_alias = size (real_3_obj)

  first_elm_addr = address (real_3_obj (1,1,1))

  call real_vector_bld (alias, first_elm_addr, size_alias)

  call exit (l_here, 10)
  
end subroutine vector_from_real_3_type_alias
 
!----------------------------------------------------------------------
  subroutine  vector_from_real_4_type_alias (alias, real_4_obj)
! ------------------------------------------------------------------------
!
! Name           : vector_from_real_4_type_alias
!
! Argument (out) : alias 
! Argument (in)  : real_4_obj
!
! Description    :  builds an  vector alias from  real_4 array 
!
! Authors: R. Assaraf
! Date  : 15 Jul 2002
! ------------------------------------------------------------------------
  implicit none
  
! i/o:
 
  real(dp), pointer :: alias (:) 
  real(dp), target :: real_4_obj (:,:,:,:)

! local
  character(len=max_string_len_routine_name), save :: l_here   
  integer(dpi) :: first_elm_addr
  integer(dpi) :: size_alias

! begin
  l_here= 'vector_from_real_4_type_alias'
 
   if(header_exe) then

    return
  endif
  call enter (l_here, 10)

  size_alias = size (real_4_obj)

  first_elm_addr = address (real_4_obj (1,1,1,1))

  call real_vector_bld (alias, first_elm_addr, size_alias)

  call exit (l_here, 10)
  
end subroutine vector_from_real_4_type_alias
 
!----------------------------------------------------------------------
  subroutine  vector_from_real_5_type_alias (alias, real_5_obj)
! ------------------------------------------------------------------------
!
! Name           : vector_from_real_5_type_alias
!
! Argument (out) : alias 
! Argument (in)  : real_5_obj
!
! Description    :  builds an  vector alias from  real_5 array 
!
! Authors: R. Assaraf
! Date  : 15 Jul 2002
! ------------------------------------------------------------------------
  implicit none
  
! i/o:
 
  real(dp), pointer :: alias (:) 
  real(dp), target :: real_5_obj (:,:,:,:,:)

! local
  character(len=max_string_len_routine_name), save :: l_here   
  integer(dpi) :: first_elm_addr
  integer(dpi) :: size_alias

! begin
  l_here= 'vector_from_real_5_type_alias'
 
   if(header_exe) then

    return
  endif
  call enter (l_here, 10)

  size_alias = size (real_5_obj)

  first_elm_addr = address (real_5_obj (1,1,1,1,1))

  call real_vector_bld (alias, first_elm_addr, size_alias)

  call exit (l_here, 10)
  
end subroutine vector_from_real_5_type_alias
 
!----------------------------------------------------------------------
  subroutine  vector_from_real_6_type_alias (alias, real_6_obj)
! ------------------------------------------------------------------------
!
! Name           : vector_from_real_6_type_alias
!
! Argument (out) : alias 
! Argument (in)  : real_6_obj
!
! Description    :  builds an  vector alias from  real_6 array 
!
! Authors: R. Assaraf
! Date  : 15 Jul 2002
! ------------------------------------------------------------------------
  implicit none
  
! i/o:
 
  real(dp), pointer :: alias (:) 
  real(dp), target :: real_6_obj (:,:,:,:,:,:)

! local
  character(len=max_string_len_routine_name), save :: l_here   
  integer(dpi) :: first_elm_addr
  integer(dpi) :: size_alias

! begin
  l_here= 'vector_from_real_6_type_alias'
 
   if(header_exe) then

    return
  endif
  call enter (l_here, 10)

  size_alias = size (real_6_obj)

  first_elm_addr = address (real_6_obj (1,1,1,1,1,1))

  call real_vector_bld (alias, first_elm_addr, size_alias)

  call exit (l_here, 10)
  
end subroutine vector_from_real_6_type_alias

!----------------------------------------------------------------------
  subroutine  vector_from_real_7_type_alias (alias, real_7_obj)
! ------------------------------------------------------------------------
!
! Name           : vector_from_real_7_type_alias
!
! Argument (out) : alias 
! Argument (in)  : real_7_obj
!
! Description    :  builds an  vector alias from  real_6 array 
!
! Authors: R. Assaraf
! Date  : 15 Jul 2002
! ------------------------------------------------------------------------
  implicit none
  
! i/o:
 
  real(dp), pointer :: alias (:) 
  real(dp), target :: real_7_obj (:,:,:,:,:,:,:)

! local
  character(len=max_string_len_routine_name), save :: l_here   
  integer(dpi) :: first_elm_addr
  integer(dpi) :: size_alias

! begin
  l_here= 'vector_from_real_7_type_alias'
 
   if(header_exe) then

    return
  endif
  call enter (l_here, 10)

  size_alias = size (real_7_obj)

  first_elm_addr = address (real_7_obj (1,1,1,1,1,1,:))

  call real_vector_bld (alias, first_elm_addr, size_alias)

  call exit (l_here, 10)
  
end subroutine vector_from_real_7_type_alias
 
!----------------------------------------------------------------------
  subroutine integer_0_type_write (integer_0_type_obj, unit)
! -------------------------------------------------------------------------
!
! Name           : integer_0_type_obj
!
! Argument (in ) : integer_0_type_obj
! Argument (in ) : unit
!
! Description    : prints a integer_0_type object
! Description    : with a text, given by the global variable text
!
! Authors: R. Assaraf
! Date   : 17 May 2001
! -------------------------------------------------------------------------
  implicit none

! i/o:
  type(integer_0_type)  :: integer_0_type_obj 
  integer(dpi) :: unit
 
! local:
  character(len=max_string_len_routine_name), save :: l_here 
  integer(dpi) :: cur_type 

! begin:
  if (header_exe) then

    l_here = "integer_0_type_write"

   cur_type = string_in_array_locate_or_die ('integer_0', types_name)

  types_write (cur_type) =  routine_cur_index ()

  return

  endif

  call enter(l_here, 10)

  if (.not.associated(integer_0_type_obj%p)) then
    write (logf,*) trim(text_print), 'not associated'
  endif


    message = text_print
    write (unit, '(2a,g17.10)') trim(message),'=',integer_0_type_obj%p


  text_print = blanks

  call exit(l_here, 10)

  end subroutine integer_0_type_write 
 
!----------------------------------------------------------------------
  subroutine integer_1_type_write (integer_1_type_obj, unit)
! -------------------------------------------------------------------------
!
! Name           : integer_1_type_obj
!
! Argument (in ) : integer_1_type_obj
! Argument (in ) : unit
!
! Description    : prints a integer_1_type object
! Description    : with a text, given by the global variable text
!
! Authors: R. Assaraf
! Date   : 17 May 2001
! -------------------------------------------------------------------------
  implicit none

! i/o:
  type(integer_1_type)  :: integer_1_type_obj 
  integer(dpi) :: unit
 
! local:
  character(len=max_string_len_routine_name), save :: l_here 
  integer(dpi) :: cur_type 
  integer(dpi) :: dim_1

! begin:
  if (header_exe) then

    l_here = "integer_1_type_write"

   cur_type = string_in_array_locate_or_die ('integer_1', types_name)

  types_write (cur_type) =  routine_cur_index ()

  return

  endif

  call enter(l_here, 10)

  if (.not.associated(integer_1_type_obj%p)) then
    write (logf,*) trim(text_print), 'not associated'
  endif

  do dim_1= lbound(integer_1_type_obj%p,dim = 1),ubound(integer_1_type_obj%p,dim = 1)  

    message = text_print+'('+dim_1+')'
    write (unit, '(2a,g17.10)') trim(message),'=',integer_1_type_obj%p(dim_1)

 enddo ! do dim_1
  text_print = blanks

  call exit(l_here, 10)

  end subroutine integer_1_type_write 
 
!----------------------------------------------------------------------
  subroutine integer_2_type_write (integer_2_type_obj, unit)
! -------------------------------------------------------------------------
!
! Name           : integer_2_type_obj
!
! Argument (in ) : integer_2_type_obj
! Argument (in ) : unit
!
! Description    : prints a integer_2_type object
! Description    : with a text, given by the global variable text
!
! Authors: R. Assaraf
! Date   : 17 May 2001
! -------------------------------------------------------------------------
  implicit none

! i/o:
  type(integer_2_type)  :: integer_2_type_obj 
  integer(dpi) :: unit
 
! local:
  character(len=max_string_len_routine_name), save :: l_here 
  integer(dpi) :: cur_type 
  integer(dpi) :: dim_1,dim_2

! begin:
  if (header_exe) then

    l_here = "integer_2_type_write"

   cur_type = string_in_array_locate_or_die ('integer_2', types_name)

  types_write (cur_type) =  routine_cur_index ()

  return

  endif

  call enter(l_here, 10)

  if (.not.associated(integer_2_type_obj%p)) then
    write (logf,*) trim(text_print), 'not associated'
  endif

  do dim_1= lbound(integer_2_type_obj%p,dim = 1),ubound(integer_2_type_obj%p,dim = 1)  
  do dim_2= lbound(integer_2_type_obj%p,dim = 2),ubound(integer_2_type_obj%p,dim = 2)  

    message = text_print+'('+dim_1+','+dim_2+')'
    write (unit, '(2a,g17.10)') trim(message),'=',integer_2_type_obj%p(dim_1,dim_2)

 enddo ! do dim_1
 enddo ! do dim_2
  text_print = blanks

  call exit(l_here, 10)

  end subroutine integer_2_type_write 
 
!----------------------------------------------------------------------
  subroutine integer_3_type_write (integer_3_type_obj, unit)
! -------------------------------------------------------------------------
!
! Name           : integer_3_type_obj
!
! Argument (in ) : integer_3_type_obj
! Argument (in ) : unit
!
! Description    : prints a integer_3_type object
! Description    : with a text, given by the global variable text
!
! Authors: R. Assaraf
! Date   : 17 May 2001
! -------------------------------------------------------------------------
  implicit none

! i/o:
  type(integer_3_type)  :: integer_3_type_obj 
  integer(dpi) :: unit
 
! local:
  character(len=max_string_len_routine_name), save :: l_here 
  integer(dpi) :: cur_type 
  integer(dpi) :: dim_1,dim_2,dim_3

! begin:
  if (header_exe) then

    l_here = "integer_3_type_write"

   cur_type = string_in_array_locate_or_die ('integer_3', types_name)

  types_write (cur_type) =  routine_cur_index ()

  return

  endif

  call enter(l_here, 10)

  if (.not.associated(integer_3_type_obj%p)) then
    write (logf,*) trim(text_print), 'not associated'
  endif

  do dim_1= lbound(integer_3_type_obj%p,dim = 1),ubound(integer_3_type_obj%p,dim = 1)  
  do dim_2= lbound(integer_3_type_obj%p,dim = 2),ubound(integer_3_type_obj%p,dim = 2)  
  do dim_3= lbound(integer_3_type_obj%p,dim = 3),ubound(integer_3_type_obj%p,dim = 3)  

    message = text_print+'('+dim_1+','+dim_2+','+dim_3+')'
    write (unit, '(2a,g17.10)') trim(message),'=',integer_3_type_obj%p(dim_1,dim_2,dim_3)

 enddo ! do dim_1
 enddo ! do dim_2
 enddo ! do dim_3
  text_print = blanks

  call exit(l_here, 10)

  end subroutine integer_3_type_write 
 
!----------------------------------------------------------------------
  subroutine integer_4_type_write (integer_4_type_obj, unit)
! -------------------------------------------------------------------------
!
! Name           : integer_4_type_obj
!
! Argument (in ) : integer_4_type_obj
! Argument (in ) : unit
!
! Description    : prints a integer_4_type object
! Description    : with a text, given by the global variable text
!
! Authors: R. Assaraf
! Date   : 17 May 2001
! -------------------------------------------------------------------------
  implicit none

! i/o:
  type(integer_4_type)  :: integer_4_type_obj 
  integer(dpi) :: unit
 
! local:
  character(len=max_string_len_routine_name), save :: l_here 
  integer(dpi) :: cur_type 
  integer(dpi) :: dim_1,dim_2,dim_3,dim_4

! begin:
  if (header_exe) then

    l_here = "integer_4_type_write"

   cur_type = string_in_array_locate_or_die ('integer_4', types_name)

  types_write (cur_type) =  routine_cur_index ()

  return

  endif

  call enter(l_here, 10)

  if (.not.associated(integer_4_type_obj%p)) then
    write (logf,*) trim(text_print), 'not associated'
  endif

  do dim_1= lbound(integer_4_type_obj%p,dim = 1),ubound(integer_4_type_obj%p,dim = 1)  
  do dim_2= lbound(integer_4_type_obj%p,dim = 2),ubound(integer_4_type_obj%p,dim = 2)  
  do dim_3= lbound(integer_4_type_obj%p,dim = 3),ubound(integer_4_type_obj%p,dim = 3)  
  do dim_4= lbound(integer_4_type_obj%p,dim = 4),ubound(integer_4_type_obj%p,dim = 4)  

    message = text_print+'('+dim_1+','+dim_2+','+dim_3+','+dim_4+')'
    write (unit, '(2a,g17.10)') trim(message),'=',integer_4_type_obj%p(dim_1,dim_2,dim_3,dim_4)

 enddo ! do dim_1
 enddo ! do dim_2
 enddo ! do dim_3
 enddo ! do dim_4
  text_print = blanks

  call exit(l_here, 10)

  end subroutine integer_4_type_write 
 
!----------------------------------------------------------------------
  subroutine integer_5_type_write (integer_5_type_obj, unit)
! -------------------------------------------------------------------------
!
! Name           : integer_5_type_obj
!
! Argument (in ) : integer_5_type_obj
! Argument (in ) : unit
!
! Description    : prints a integer_5_type object
! Description    : with a text, given by the global variable text
!
! Authors: R. Assaraf
! Date   : 17 May 2001
! -------------------------------------------------------------------------
  implicit none

! i/o:
  type(integer_5_type)  :: integer_5_type_obj 
  integer(dpi) :: unit
 
! local:
  character(len=max_string_len_routine_name), save :: l_here 
  integer(dpi) :: cur_type 
  integer(dpi) :: dim_1,dim_2,dim_3,dim_4,dim_5

! begin:
  if (header_exe) then

    l_here = "integer_5_type_write"

   cur_type = string_in_array_locate_or_die ('integer_5', types_name)

  types_write (cur_type) =  routine_cur_index ()

  return

  endif

  call enter(l_here, 10)

  if (.not.associated(integer_5_type_obj%p)) then
    write (logf,*) trim(text_print), 'not associated'
  endif

  do dim_1= lbound(integer_5_type_obj%p,dim = 1),ubound(integer_5_type_obj%p,dim = 1)  
  do dim_2= lbound(integer_5_type_obj%p,dim = 2),ubound(integer_5_type_obj%p,dim = 2)  
  do dim_3= lbound(integer_5_type_obj%p,dim = 3),ubound(integer_5_type_obj%p,dim = 3)  
  do dim_4= lbound(integer_5_type_obj%p,dim = 4),ubound(integer_5_type_obj%p,dim = 4)  
  do dim_5= lbound(integer_5_type_obj%p,dim = 5),ubound(integer_5_type_obj%p,dim = 5)  

    message = text_print+'('+dim_1+','+dim_2+','+dim_3+','+dim_4+','+dim_5+')'
    write (unit, '(2a,g17.10)') trim(message),'=',integer_5_type_obj%p(dim_1,dim_2,dim_3,dim_4,dim_5)

 enddo ! do dim_1
 enddo ! do dim_2
 enddo ! do dim_3
 enddo ! do dim_4
 enddo ! do dim_5
  text_print = blanks

  call exit(l_here, 10)

  end subroutine integer_5_type_write 
 
!----------------------------------------------------------------------
  subroutine integer_6_type_write (integer_6_type_obj, unit)
! -------------------------------------------------------------------------
!
! Name           : integer_6_type_obj
!
! Argument (in ) : integer_6_type_obj
! Argument (in ) : unit
!
! Description    : prints a integer_6_type object
! Description    : with a text, given by the global variable text
!
! Authors: R. Assaraf
! Date   : 17 May 2001
! -------------------------------------------------------------------------
  implicit none

! i/o:
  type(integer_6_type)  :: integer_6_type_obj 
  integer(dpi) :: unit
 
! local:
  character(len=max_string_len_routine_name), save :: l_here 
  integer(dpi) :: cur_type 
  integer(dpi) :: dim_1,dim_2,dim_3,dim_4,dim_5,dim_6

! begin:
  if (header_exe) then

    l_here = "integer_6_type_write"

   cur_type = string_in_array_locate_or_die ('integer_6', types_name)

  types_write (cur_type) =  routine_cur_index ()

  return

  endif

  call enter(l_here, 10)

  if (.not.associated(integer_6_type_obj%p)) then
    write (logf,*) trim(text_print), 'not associated'
  endif

  do dim_1= lbound(integer_6_type_obj%p,dim = 1),ubound(integer_6_type_obj%p,dim = 1)  
  do dim_2= lbound(integer_6_type_obj%p,dim = 2),ubound(integer_6_type_obj%p,dim = 2)  
  do dim_3= lbound(integer_6_type_obj%p,dim = 3),ubound(integer_6_type_obj%p,dim = 3)  
  do dim_4= lbound(integer_6_type_obj%p,dim = 4),ubound(integer_6_type_obj%p,dim = 4)  
  do dim_5= lbound(integer_6_type_obj%p,dim = 5),ubound(integer_6_type_obj%p,dim = 5)  
  do dim_6= lbound(integer_6_type_obj%p,dim =6),ubound(integer_6_type_obj%p,dim = 6)  

    message = text_print+'('+dim_1+','+dim_2+','+dim_3+','+dim_4+','+dim_5+','+dim_6+')'
    write (unit, '(2a,g17.10)') trim(message),'=',integer_6_type_obj%p(dim_1,dim_2,dim_3,dim_4,dim_5,dim_6)

 enddo ! do dim_1
 enddo ! do dim_2
 enddo ! do dim_3
 enddo ! do dim_4
 enddo ! do dim_5
 enddo ! do dim_6
  text_print = blanks

  call exit(l_here, 10)

  end subroutine integer_6_type_write 
  
!----------------------------------------------------------------------
  subroutine character_1_type_write (character_1_type_obj, unit)
! -------------------------------------------------------------------------
!
! Name           : character_1_type_obj
!
! Argument (in ) : character_1_type_obj
! Argument (in ) : unit
!
! Description    : prints a character_1_type object
! Description    : with a text, given by the global variable text
!
! Authors: R. Assaraf
! Date   : 17 May 2001
! -------------------------------------------------------------------------
  implicit none

! i/o:
  type(character_1_type)  :: character_1_type_obj 
  integer(dpi) :: unit
 
! local:
  character(len=max_string_len_routine_name), save :: l_here 
  integer(dpi) :: cur_type 
  character (max_string_len) ::  string_value
 
! begin:
  if (header_exe) then

    l_here = "character_1_type_write"

   cur_type = string_in_array_locate_or_die ('character_1', types_name)

  types_write (cur_type) =  routine_cur_index ()

  return

  endif

  call enter(l_here, 10)

  if (.not.associated(character_1_type_obj%p)) then
    write (logf,*) trim(text_print), 'not associated'
  endif

    call char_1_to_string (string_value,character_1_type_obj%p)
    message = text_print
    write (unit, '(3a)') trim(message),'=',trim (string_value)

   text_print = blanks

  call exit(l_here, 10)

  end subroutine character_1_type_write 
 
!----------------------------------------------------------------------
  subroutine character_2_type_write (character_2_type_obj, unit)
! -------------------------------------------------------------------------
!
! Name           : character_2_type_obj
!
! Argument (in ) : character_2_type_obj
! Argument (in ) : unit
!
! Description    : prints a character_2_type object
! Description    : with a text, given by the global variable text
!
! Authors: R. Assaraf
! Date   : 17 May 2001
! -------------------------------------------------------------------------
  implicit none

! i/o:
  type(character_2_type)  :: character_2_type_obj 
  integer(dpi) :: unit
 
! local:
  character(len=max_string_len_routine_name), save :: l_here 
  integer(dpi) :: cur_type 
  integer(dpi) :: dim_2
  character (max_string_len) ::  string_value

! begin:
  if (header_exe) then

    l_here = "character_2_type_write"

   cur_type = string_in_array_locate_or_die ('character_2', types_name)

  types_write (cur_type) =  routine_cur_index ()

  return

  endif

  call enter(l_here, 10)

  if (.not.associated(character_2_type_obj%p)) then
    write (logf,*) trim(text_print), 'not associated'
  endif
	
  do dim_2= lbound(character_2_type_obj%p,dim = 2),ubound(character_2_type_obj%p,dim = 2)  
    call char_1_to_string (string_value,character_2_type_obj%p (:,dim_2))  
    message = text_print+'('+dim_2+')'
    write (unit, '(3a)') trim(message),'=',trim (string_value)

 enddo ! do dim_1

  text_print = blanks

  call exit(l_here, 10)

  end subroutine character_2_type_write 

!----------------------------------------------------------------------
  subroutine character_3_type_write (character_3_type_obj, unit)
! -------------------------------------------------------------------------
!
! Name           : character_3_type_obj
!
! Argument (in ) : character_3_type_obj
! Argument (in ) : unit
!
! Description    : prints a character_3_type object
! Description    : with a text, given by the global variable text
!
! Authors: R. Assaraf
! Date   : 17 May 2001
! -------------------------------------------------------------------------
  implicit none

! i/o:
  type(character_3_type)  :: character_3_type_obj 
  integer(dpi) :: unit
 
! local:
  character(len=max_string_len_routine_name), save :: l_here 
  integer(dpi) :: cur_type 
  integer(dpi) :: dim_2, dim_3
  character (max_string_len) ::  string_value

! begin:
  if (header_exe) then

    l_here = "character_3_type_write"

   cur_type = string_in_array_locate_or_die ('character_2', types_name)

  types_write (cur_type) =  routine_cur_index ()

  return

  endif

  call enter(l_here, 10)

  if (.not.associated(character_3_type_obj%p)) then
    write (logf,*) trim(text_print), 'not associated'
  endif
	
  do dim_2= lbound(character_3_type_obj%p,dim = 2),ubound(character_3_type_obj%p,dim = 2)
  do dim_3= lbound(character_3_type_obj%p,dim = 3),ubound(character_3_type_obj%p,dim = 3)  
    call char_1_to_string (string_value,character_3_type_obj%p (:,dim_2,dim_3))  
    message = text_print+'('+dim_2+','+dim_3+')'
    write (unit, '(3a)') trim(message),'=',trim (string_value)

 enddo ! do dim_3
 enddo ! do dim_2
  text_print = blanks

  call exit(l_here, 10)

  end subroutine character_3_type_write 
 
!----------------------------------------------------------------------
  subroutine char_1_type_alias_byaddr_bld (alias, addr_obj)
! -------------------------------------------------------------------------
!
!Name           : char_1_type_alias_byaddr_bld
!
! Argument (in ) : addr_obj
! Argument (out) : alias
!
! Description    : builds the object alias from the address addr_obj
! Description    : alias => character_1_type_alias
!
! Authors: R. Assaraf
! Date  : 17 May 2001
! -------------------------------------------------------------------------
  implicit none
 
! i/o:
  type(character_1_type), pointer :: alias
  integer(dpi)         :: addr_obj
 
! local:
  character(len=max_string_len_routine_name), save :: l_here 

! begin:
  l_here = 'char_1_type_alias_byaddr_bld'
  call enter(l_here, 10)

  call exe_by_address_1 (address (character_1_type_alias_bld), addr_obj)
  alias =>  character_1_type_alias

  call exit(l_here, 10)

  end subroutine char_1_type_alias_byaddr_bld
 
!----------------------------------------------------------------------
  subroutine char_2_type_alias_byaddr_bld (alias, addr_obj)
! -------------------------------------------------------------------------
!
! Name           : char_2_type_alias_byaddr_bld
!
! Argument (in ) : addr_obj
! Argument (out) : alias
!
! Description    : builds the object alias from the address addr_obj
! Description    : alias => character_2_type_alias
!
! Authors: R. Assaraf
! Date  : 17 May 2001
! -------------------------------------------------------------------------
  implicit none
 
! i/o:
  type(character_2_type), pointer :: alias
  integer(dpi)         :: addr_obj
 
! local:
  character(len=max_string_len_routine_name), save :: l_here 

! begin:
  l_here = 'char_2_type_alias_byaddr_bld'
  call enter(l_here, 10)

  call exe_by_address_1 (address (character_2_type_alias_bld), addr_obj)
  alias =>  character_2_type_alias

  call exit(l_here, 10)

  end subroutine char_2_type_alias_byaddr_bld
 
!----------------------------------------------------------------------
  subroutine char_3_type_alias_byaddr_bld (alias, addr_obj)
! -------------------------------------------------------------------------
!
! Name           : char_3_type_alias_byaddr_bld
!
! Argument (in ) : addr_obj
! Argument (out) : alias
!
! Description    : builds the object alias from the address addr_obj
! Description    : alias => character_2_type_alias
!
! Authors: R. Assaraf
! Date  : 17 May 2001
! -------------------------------------------------------------------------
  implicit none
 
! i/o:
  type(character_3_type), pointer :: alias
  integer(dpi)         :: addr_obj
 
! local:
  character(len=max_string_len_routine_name), save :: l_here 

! begin:
  l_here = 'char_3_type_alias_byaddr_bld'
  call enter(l_here, 10)

  call exe_by_address_1 (address (character_3_type_alias_bld), addr_obj)
  alias =>  character_3_type_alias

  call exit(l_here, 10)

  end subroutine char_3_type_alias_byaddr_bld
 
!----------------------------------------------------------------------
  subroutine char_1_byaddr_char_1_bld (character_1_obj, addr_obj, dim_1)
! -------------------------------------------------------------------------
!
! Name           : character_1_alias_byaddr_bld
!
! Argument (out) : alias
! Argument (in ) : addr_obj
! Argument : dim_1
!
! Description    : builds character_1_obj from the address addr_obj
! Description    : character_1_obj (1) -> addr_obj and character_1_obj (1:dim_1) 
!
! Authors: R. Assaraf
! Date  : 21 Jul 2001
! -------------------------------------------------------------------------
  implicit none
 
! i/o:
  character(len= 1), pointer :: character_1_obj (:)
  integer(dpi)     :: addr_obj
  integer(dpi)     :: dim_1
   
! local:
  character(len=max_string_len_routine_name), save :: l_here 
  integer(dpi) :: dim_1_addr
! begin:
  l_here = 'char_1_byaddr_char_1_bld'
  call enter(l_here, 10)
 
  dim_1_addr = address (dim_1)
  call exe_by_address_2 (address (character_1_alias_bld),  (/addr_obj,  dim_1_addr/)) 

  character_1_obj =>  character_1_alias

  call exit(l_here, 10)

  end subroutine char_1_byaddr_char_1_bld
 
!----------------------------------------------------------------------
  subroutine char_2_byaddr_char_2_bld (character_2_obj, addr_obj, dim_1,dim_2)
! -------------------------------------------------------------------------
!
! Name           : character_2_alias_byaddr_bld
!
! Argument (out) : alias
! Argument (in ) : addr_obj
! Argument : dim_1
! Argument : dim_2
!
! Description    : builds character_2_obj from the address addr_obj
! Description    : character_2_obj (1) -> addr_obj and character_2_obj (1:dim_1,dim_2) 
!
! Authors: R. Assaraf
! Date  : 21 Jul 2001
! -------------------------------------------------------------------------
  implicit none
 
! i/o:
  character(len= 1), pointer :: character_2_obj (:,:)
  integer(dpi)     :: addr_obj
  integer(dpi)     :: dim_1,dim_2
   
! local:
  character(len=max_string_len_routine_name), save :: l_here 
  integer(dpi) :: dim_1_addr ,dim_2_addr

! begin:
  l_here = 'char_2_byaddr_char_2_bld'
  call enter(l_here, 10)
 
  dim_1_addr = address (dim_1)
  dim_2_addr = address (dim_2)

  call exe_by_address_3 (address (character_2_alias_bld),  (/addr_obj,  dim_1_addr, dim_2_addr/)) 

  character_2_obj =>  character_2_alias

  call exit(l_here, 10)

  end subroutine char_2_byaddr_char_2_bld
 
!----------------------------------------------------------------------
  subroutine character_1_alias_bld (character_1_target, dim_1 )
! -------------------------------------------------------------------------
!
! Name           : character_1_alias_bld
!
! Argument (in ) : character_1_target
! Argument : dim_1
!
! Description    : character_1_alias => character_1_target (1:dim_1)
!
! Authors: R. Assaraf
! Date   : 21 Jul 2001
! -------------------------------------------------------------------------
  implicit none

! i/o:
  integer(dpi)      :: dim_1
  character(len= 1), target :: character_1_target (dim_1) 
  
! local:
  character(len=max_string_len_routine_name), save :: l_here 
 
! begin:
  l_here='character_1_alias_bld'
  call enter(l_here, 10)


  character_1_alias =>  character_1_target 

  call exit(l_here, 10)

  end subroutine character_1_alias_bld
 
!----------------------------------------------------------------------
  subroutine character_2_alias_bld (character_2_target, dim_1,dim_2 )
! -------------------------------------------------------------------------
!
! Name           : character_2_alias_bld
!
! Argument (in ) : character_2_target
! Argument : dim_1
! Argument : dim_2
!
! Description    : character_2_alias => character_2_target (1:dim_1,dim_2)
!
! Authors: R. Assaraf
! Date   : 21 Jul 2001
! -------------------------------------------------------------------------
  implicit none
! i/o:
  integer(dpi)      :: dim_1,dim_2
  character(len= 1), target :: character_2_target (dim_1,dim_2) 
  
! local:
  character(len=max_string_len_routine_name), save :: l_here 
 
! begin:
  l_here='character_2_alias_bld'
  call enter(l_here, 10)


  character_2_alias =>  character_2_target 

  call exit(l_here, 10)

  end subroutine character_2_alias_bld


include(fortran_types_macros.m4)

define(`typ',`real')
define(`kind',`dp')

define(`_n_',`0')
include(fortran_types_routines_macros.m4)
define(`_dims_arguments_',`')
define(`_dims_declaration_',`')
include(basic_type_routines.m4)


define(`_n_',`1')
include(fortran_types_routines_macros.m4)
include(basic_type_routines.m4)

define(`_n_',`2')
include(fortran_types_routines_macros.m4)
include(basic_type_routines.m4)


define(`_n_',`3')
include(fortran_types_routines_macros.m4)
include(basic_type_routines.m4)

define(`_n_',`4')
include(fortran_types_routines_macros.m4)
include(basic_type_routines.m4)

define(`_n_',`5')
include(fortran_types_routines_macros.m4)
include(basic_type_routines.m4)


define(`_n_',`6')
include(fortran_types_routines_macros.m4)
include(basic_type_routines.m4)


define(`_n_',`7')
include(fortran_types_routines_macros.m4)
include(basic_type_routines.m4)

define(`typ',`integer')
define(`kind',`dpi')

define(`_n_',`0')
include(fortran_types_routines_macros.m4)
define(`_dims_arguments_',`')
define(`_dims_declaration_',`')
include(basic_type_routines.m4)


define(`_n_',`1')
include(fortran_types_routines_macros.m4)
include(basic_type_routines.m4)

define(`_n_',`2')
include(fortran_types_routines_macros.m4)
include(basic_type_routines.m4)


define(`_n_',`3')
include(fortran_types_routines_macros.m4)
include(basic_type_routines.m4)

define(`_n_',`4')
include(fortran_types_routines_macros.m4)
include(basic_type_routines.m4)

define(`_n_',`5')
include(fortran_types_routines_macros.m4)
include(basic_type_routines.m4)


define(`_n_',`6')
include(fortran_types_routines_macros.m4)
include(basic_type_routines.m4)


define(`typ',`character')
define(`kind',`len =1')

define(`_n_',`1')
include(fortran_types_routines_macros.m4)
include(basic_type_routines.m4)

define(`_n_',`2')
include(fortran_types_routines_macros.m4)
include(basic_type_routines.m4)

define(`_n_',`3')
include(fortran_types_routines_macros.m4)
include(basic_type_routines.m4)



end module basic_types_tools_mod
