*===================================================================== *
      subroutine CUTFRM ( maxitm, formul, subitm, nbitem) 
* -------------------------------------------------------------------- *
*
* Comments: extracts nbitem items from a formula from Parser
*
* author:F.Colonna
* date:Wed Dec 16 12:43:27 NFT 1992
* -------------------------------------------------------------------- *
       implicit none
* input :
      character*(*)  formul
      integer maxitm

* output arrays:
      character*(*)  subitm (maxitm)

* output scalars:
      integer nbitem
      character*(1)  previous, next

* local scalars:
      integer lenstr, begin , last, carac, sub, item
      character*(512) Stemp
      logical locdbg

* begin:
      locdbg = .true.
      locdbg = .false.

      lenstr= len_trim(formul)
      if(locdbg) then
        write(6,'(3a)')
     .' debug_cutfrm> input formul:"',trim(formul),'"'
      end if

      call RMVBLK (formul, Stemp, lenstr)  !. remove blanks
      formul=Stemp
*     call SYMTRL (Stemp, formul, lenstr)  !. substitute symbols
      call UPPLOW (formul)                 !. converts to lowercase

      if(lenstr.eq.0) then
         write(6,'(a)')' warning_CUTFRM> formula empty '
         return
      end if

      nbitem = 0
      begin = 1

      do carac =1, lenstr

         if     (formul(carac:carac).eq.'(') then

               last   = carac - 1
               if(begin.le.last) then
                  nbitem = nbitem + 1
                  subitm (nbitem) =  formul(begin:last)
               end if
               begin  = carac + 1

            call addop (maxitm, nbitem, subitm, formul, carac)

         else if(formul(carac:carac).eq.')') then

               last   = carac - 1
               if(begin.le.last) then
                  nbitem = nbitem + 1
                  subitm (nbitem) =  formul(begin:last)
               end if
               begin  = carac + 1

            call addop (maxitm, nbitem, subitm, formul, carac)

         else if(formul(carac:carac).eq.'+') then

            if(formul(carac-1:carac-1).ne.'d'.and.
     .         formul(carac-1:carac-1).ne.'e')  then

               last   = carac   - 1
               if(begin.le.last) then
                  nbitem = nbitem + 1
                  subitm (nbitem) =  formul(begin:last)
               end if
               begin  = carac + 1

               call addop (maxitm, nbitem, subitm, formul, carac)

            end if


         else if(formul(carac:carac).eq.'-') then

           if(formul(carac-1:carac-1).ne.'d'.and.
     .         formul(carac-1:carac-1).ne.'e')  then

               last   = carac   - 1
               if(begin.le.last) then
                  nbitem = nbitem + 1
                  subitm (nbitem) =  formul(begin:last)
               end if
               begin  = carac + 1

               call addop (maxitm, nbitem, subitm, formul, carac)

            end if

         else if(formul(carac:carac).eq.'*') then

           previous = formul(carac-1:carac-1)
           next = formul(carac+1:carac+1)

           if(previous.ne.'*'.and.next.eq.'*') then

               last   = carac   - 1
               if(begin.le.last) then
                  nbitem = nbitem + 1
                  subitm (nbitem) =  formul(begin:last)
               end if
               begin  = carac + 2

                  nbitem = nbitem + 1
                  subitm (nbitem) =  formul(carac:carac+1)

            else if(previous.ne.'*'.and.next.ne.'*') then

               last   = carac   - 1
               if(begin.le.last) then
                  nbitem = nbitem + 1
                  subitm (nbitem) =  formul(begin:last)
               end if
               begin  = carac + 1

            call addop (maxitm, nbitem, subitm, formul, carac)

            else
            end if

         else if(formul(carac:carac).eq.'/') then

               last   = carac   - 1
               if(begin.le.last) then
                  nbitem = nbitem + 1
                  subitm (nbitem) =  formul(begin:last)
               end if
               begin  = carac + 1

            call addop (maxitm, nbitem, subitm, formul, carac)

         else

         end if

      end do

* if no ")" terminates formula:

      if(formul(lenstr:lenstr).ne.')') then
               last   =  lenstr
               if(begin.le.last) then
                  nbitem = nbitem + 1
                  subitm (nbitem) =  formul(begin:last)
               end if
      end if

      item = 0
      do sub=1, nbitem
        if(subitm(sub)(1:3).ne.'   ') then
           item = item + 1
           subitm(item) = subitm(sub)
        end if
      end do

      nbitem = item

*     call chklim (6,' error_CUTFRM> number of operand > 26 ',
*    .             maxitm, nbitem, 'STOP')

* end of routine CUTFRM
      return
      end
