#!/usr/bin/ksh

compiler=$1

#preprocessor 
export QMCMOL_PP="fpp"

case "$compiler" in
    intel)

        # compiler
	export QMCMOL_F95="ifort"
        export QMCMOL_F77="ifort"

        # compilation options
	export QMCMOL_F95FLAGS="-g "
        export QMCMOL_F95FAST="-O3"
        export QMCMOL_F77FLAGS="-O3"

       # libraries

#       LFLIB="/usr/local/Intel/fc/9.0/lib/"    # on bridoye 
        LFLIB="/usr/local/Intel/compiler90/lib" # on hydrogene
#        LFLIB="/opt/intel/fc/9.0/lib" # on nopal

        export QMCMOL_LIBS=" -L$LFLIB -lm   -lstdc++  -lifcore -lifport -lsvml"
   
       # C compilation  
        export QMCMOL_CC="gcc"
        export QMCMOL_CFLAGS="-DUNDERSCORE"

       # link 
         export QMCMOL_LD="gcc"
         export QMCMOL_LDFLAGS=""
         ;;

    lahaie)

        # compiler
	export QMCMOL_F95="lf95"
        export QMCMOL_F77="lf95"

        # compilation options
	export QMCMOL_F95FLAGS="--maxfatals 1 --info --swm 3104 --chk --ap --f95 -g --lst --pca --trace --info --xref --trap"
	export QMCMOL_F95FAST="-O3 --maxfatals 1 "
        export QMCMOL_F77FLAGS="-O3"

        # libraries
      	LFLIB="/usr/local/lf9560/lib"
	export QMCMOL_LIBS="-L$LFLIB   -lfj9i6 -lfj9e6 -lfj9f6 -lm "
        # C compilation    
        export QMCMOL_CC="gcc"
        export QMCMOL_CFLAGS="-DUNDERSCORE"

       # link
         export QMCMOL_LD="gcc"
         export QMCMOL_LDFLAGS=""
         ;;


    portland_32b)
        
       # compiler
        export QMCMOL_F95="pgf90"
        export QMCMOL_F77="pgf90"

       # compilation options
	export QMCMOL_F95FLAGS=" -g -C     -DDECALPHA -DRISC -DBLAS"
	export QMCMOL_F95FAST="-O3 --maxfatals 1 "
	export QMCMOL_F77FLAGS="-O3"

       # libraries
	LFLIB="/usr/local/pgi/linux86/6.0/lib"
        export QMCMOL_LIBS=" -L$LFLIB   -lpgf90 -lpgc -lpgftnrtl  -lpgf90_rpm1 -lpghpf2  -lm"
       # C compilation  
        export QMCMOL_CC="gcc"
        export QMCMOL_CFLAGS="-DUNDERSCORE"

       # link 
         export QMCMOL_LD="gcc"
         export QMCMOL_LDFLAGS=""

;;
  portland_64b)
        # compiler
        export QMCMOL_F95="pgf90"
        export QMCMOL_F77="pgf90"

       # compilation options
        export QMCMOL_F95FLAGS=" -g -C -i8  -Mfunc32  -DDECALPHA -DRISC -DBLAS"
        export QMCMOL_F95FAST="-O3 -i8  -Mfunc32  -DDECALPHA -DRISC -DBLAS  "
        export QMCMOL_F77FLAGS="-O3"

       # libraries
        LFLIB="/usr/local/pgi/linux86-64/5.2/lib"
        export QMCMOL_LIBS=" -L$LFLIB  -L/usr/lib64 -lc  -lm -lpgc -lpgf90rtl  -lpgf90 -lpgc -lpgftnrtl  -lpgf90_rpm1 -lpghpf2  -lm"
       # C compilation
         export QMCMOL_CC="pgcc"
         export QMCMOL_CFLAGS="-DUNDERSCORE"

       # link
         export QMCMOL_LD="pgf90 -Mnomain"
         export QMCMOL_LDFLAGS=""
 ;;
        
   gnu95)
   # compiler
        export QMCMOL_F95="g95"
        export QMCMOL_F77="g95"


  
;;
   xlf_32b)

       # compiler
        export QMCMOL_F95="xlf"
        export QMCMOL_F77="xlf"

       # compilation options
	export QMCMOL_F95FLAGS="  -qsigtrap -v -qxlf77=leadzero -qinitauto=FA -qnosave -qhalt=w -qTKQ_SIZE=100000"
	export QMCMOL_F95FAST="-O3"
	export QMCMOL_F77FLAGS="-O3"

       # libraries
	LFLIB="/usr/lib"
        export QMCMOL_LIBS=" -L$LFLIB  	-lxlf90_t -lxlf90_r -lxlf90 -lm"

       # C compilation  
        export QMCMOL_CC="gcc"
        export QMCMOL_CFLAGS="-DUNDERSCORE"

       # link 
         export QMCMOL_LD="gcc"
         export QMCMOL_LDFLAGS=""

;;
   xlf_64b)

       # compiler
        export QMCMOL_F95="xlf95"
        export QMCMOL_F77="xlf"

       # compilation options
        export QMCMOL_F95FLAGS="  -qsuffix=f=f90  -c -qintsize=8"
        export QMCMOL_F95FAST=" -qsuffix=f=f90  -qintsize=8 -O3 -c"
        export QMCMOL_F77FLAGS="-O3"

       # libraries
        LFLIB="/usr/lpp/xlf/lib"
        export QMCMOL_LIBS=" -L$LFLIB   -lxlf90_t -lxlf90_r -lxlf90 -lm"

       # C compilation
        export QMCMOL_CC="cc"
        export QMCMOL_CFLAGS=""

      # link
        export QMCMOL_LD="cc "
        export QMCMOL_LDFLAGS=""
;;

esac


