! -*- f90 -*-
!-----------------------------------------------------------------------------
!          This file is part of QmcMol A GNU QMC program for molecules.
!              Copyright (C) 2002 CNRS - U.P.M.C. Paris 6 - FRANCE
!          R. Assaraf, M. Caffarel, F. Colonna, X. Krokidis, B. Levy, 
!          P. Pernod, and P. Reinhardt - qmcmol@lct.jussieu.fr
!                       http://www.lct.jussieu.fr/QmcMol
! QmcMol is free software; you can redistribute it and/or modify it
! under the terms of the GNU General Public License as published by the Free
! Software  Foundation;  either version 2, or (at your option) any later
! version. QmcMol is distributed in the hope that it will be useful,but
! WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or  FITNESS FOR A PARTICULAR PURPOSE.   See the GNU General Public License
! for  more  details.  You  should  have  received a copy of the GNU General
! Public  License  along  with  QmcMol;  see the file COPYING.  If not,
! write to the  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
! Boston, MA 02111-1307, USA.
!-----------------------------------------------------------------------------


! ========================================================================
  subroutine equal_set_bld (obj_1, obj_2)
! ------------------------------------------------------------------------
!
! Name           : equal_set
!
! Description    :
!
! Authors: R. Assaraf
! Date   :  27 Jul 2005
! ------------------------------------------------------------------------
  use basic_types_tools_mod
  use parser_mod
  use objects_paths_mod
  use expressions_mod
 

  implicit none

! i/o:
  integer(dpi)      :: obj_1, obj_2
  real(dp), pointer :: x      => NULL ()
  real(dp), pointer :: y      => NULL ()
  real(dp), pointer :: x1 (:) => NULL ()
  real(dp), pointer :: y1 (:) => NULL ()
  real(dp), pointer :: x2(:,:) => NULL ()
  real(dp), pointer :: x3(:,:,:) => NULL ()
  integer(dpi), pointer :: n1 (:)  => NULL ()
  integer(dpi), pointer :: i1  => NULL ()
  integer(dpi), pointer :: i2  => NULL ()
! local:
  integer(dpi) :: type_1, type_2
  character(len=max_string_len_routine_name), save :: l_here
! begin:
  
  l_here = 'equal_set_bld'
  call enter (l_here)


  type_1 = objects_type (obj_1)
  type_2 = objects_type (obj_2)

  if (types_name (type_1)=='integer_0'.and.types_name (type_2)=='integer_0') then

     call alias_byaddr_bld (i1, objects_addr (obj_1))
     call alias_byaddr_bld (i2, objects_addr (obj_2))
     i1 = i2
     call touch_byind ((/obj_1/))

  else if (types_name (type_1)=='real_0'.and.types_name (type_2)=='real_0') then
        
     call alias_byaddr_bld (x, objects_addr (obj_1))
     call alias_byaddr_bld (y, objects_addr (obj_2))

     x = y
     call touch_byind ((/obj_1/))

  else if (types_name (type_1)=='real_1'.and.types_name (type_2)=='real_1') then
     call alias_byaddr_bld (x1, objects_addr (obj_1))
     call alias_byaddr_bld (y1, objects_addr (obj_2))
     
     x1 = y1
     call touch_byind ((/obj_1/))
  else if (types_name (type_1)=='real_1'.and.types_name (type_2)=='real_0') then
     
     call alias_byaddr_bld (x1, objects_addr (obj_1))
     call alias_byaddr_bld (y, objects_addr (obj_2))
     
     x1 = y
     call touch_byind ((/obj_1/))
  else if (types_name (type_1)=='real_2'.and.types_name (type_2)=='real_0') then

     call alias_byaddr_bld (x2, objects_addr (obj_1))
     call alias_byaddr_bld (y, objects_addr (obj_2))

     x2 = y
     call touch_byind ((/obj_1/))
  else if (types_name (type_1)=='real_3'.and.types_name (type_2)=='real_0') then
     
     call alias_byaddr_bld (x3, objects_addr (obj_1))
     call alias_byaddr_bld (y, objects_addr (obj_2))

     x3 = y
     call touch_byind ((/obj_1/))
  else if (types_name (type_1)=='integer_1'.and.types_name (type_2)=='real_1') then

     call alias_byaddr_bld (n1, objects_addr (obj_1))
     call alias_byaddr_bld (y1, objects_addr (obj_2))
     
     call  real_objects_scatter_bld (n1, y1)
     call  touch_byind (n1)    
  else
     write (logf,*) trim(l_here),'-e: objects >',&
          trim(objects_names(obj_1)),'<, >',&
          trim(objects_names(obj_2)),'<'
     write(logf,*) trim(l_here),'-e: of types >',&
          trim(types_name(type_1)),'< and >',&
          trim(types_name(type_2)),'<'
     
     call die ('equal_set','invalid types')

  endif
  
  call exit (l_here)
end subroutine equal_set_bld
