die "Usage:\n perl $0 *.f90" if $#ARGV < 0 ;

# put here files not to be "fasted"
@FilesExceptionList=(
	'mos_at_points_mod.f90',
	'print_mod.f90',
	'write_mod.f90',
  );

# put here routines not "fasted"
@RoutinesExceptionList=('',
  );

foreach $inpfil (@ARGV){

    if ( $inpfil !~ /\*+/) {

	if(!grep /\b$inpfil\b/, @FilesExceptionList){
	    $savfil=$inpfil.".sav";
	    rename $inpfil, $savfil;

	    print " diff $savfil $inpfil\n";

	    open(INP, "<$savfil");
	    open(OUT, ">$inpfil");

	    $suite=0;

	    while(<INP>){
		if($suite){$_ = "!fast ".$_}
		$suite=0;

# get subroutine name 
		if(($s)=($_ =~ /^\s*subroutine\s*(\S+_bld)\s*$/)){
		    $subname=$s ;
		    $excl != grep /\b$subname\b/,@RoutinesExceptionList ;
		    if($excl){print "routine $subname is NOT fasted\n"}
		    else{print "routine $subname is fasted\n"};
		}
		if(!$excl) {
		    if (/^\s*include \'ensnb\_/){
			$_ = "!fast ".$_;
		    }
		    if (/^\s*include \'debug\_/){
			$_ = "!fast ".$_;
		    }
		    if (/^\s*include \'chksiz\_/){
			$_ = "!fast ".$_;
		    }
		    if (/^\s*call\s*enter/){
			$_ = "!fast ".$_;
		    }
		    if (/^\s*call\s*exit/){
			$_ = "!fast ".$_;
		    }
		    if (/^\s+if\s*\(\s*debug\)/ && !/then/ ){
			$_ = "!fast ".$_;
			if(/\&\s*$/){$suite=1};
		    }
		    elsif (/^\s+associated_(\S+:)\s*if\s*\(.*\)\s*then\s*$/ ...  /^\s*end\s*if\s*\s+associated_/){
			$_ = "!fast ".$_;
				}
		    elsif (/^\s+ensure_(\S+:)\s*/ ...  /^\s*end\s*\w+\s*\s+ensure_/){
			$_ = "!fast ".$_;
		    }
		    elsif (/^\s+require_(\S+:)\s*/ ...  /^\s*end\s*\w+\s*\s+require_/){
			$_ = "!fast ".$_;
		    }
		    elsif (/^\s+debug_(\S+:)\s*if\s*\(\s*debug\)\s*then\s*$/ ...  /^\s*end\s*if\s*\s+debug_/){
			$_ = "!fast ".$_;
		    }
		    elsif (/^\s+if\s*\(\s*debug\)\s*then\s*$/ ... /^\s*end\s*if\s*$/){
			$_ = "!fast ".$_;
		    }
		}
		print OUT ;
		}
	    close INP;
	    close OUT;
	}
	else{ print "$inpfil excluded\n"}
    }
}
