! -*- f90 -*-
!-----------------------------------------------------------------------------
!          This file is part of QmcMol A GNU QMC program for molecules.
!       Copyright (C) 2002 CNRS - U.P.M.C. Paris 6 - FRANCE
!          R. Assaraf, M. Caffarel, F. Colonna, X. Krokidis, B. Levy, 
!          P. Pernod, and P. Reinhardt - qmcmol@lct.jussieu.fr
!                       http://www.lct.jussieu.fr/QmcMol
! QmcMol is free software; you can redistribute it and/or modify it
! under the terms of the GNU General Public License as published by the Free
! Software  Foundation;  either version 2, or (at your option) any later
! version. QmcMol is distributed in the hope that it will be useful,but
! WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or  FITNESS FOR A PARTICULAR PURPOSE.   See the GNU General Public License
! for  more  details.  You  should  have  received a copy of the GNU General
! Public  License  along  with  QmcMol;  see the file COPYING.  If not,
! write to the  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
! Boston, MA 02111-1307, USA.
!-----------------------------------------------------------------------------

module jastrow_mod

  use control_mod 
  use tools_mod 

! Description    : 
! beta_ee : Inverse electron - electron parameter r_ab/(1+beta_ee r_ab)
! beta_en : Inverse electron - nuleus parameter r_ia/(1+beta_en(I) r_ia)
! a_ee    : Electron - electron interaction parameters 
!         : s(r_ab) 4th degree polynome with a_ee as coefficients
!         : a_ee(1:4,1:2)
! a_en    : Electron - nulcleus interaction
!         : p(r_ia) 4th degree polynome with a_en as coefficients
! a_een   : Electron - electon - nucleus interaction
!         : a_een(1,I)*r_ia^2*rjJ^2
!         : a_een(2,I)*(r_ia^2 + rjI^2)*r_ab^2

  type jastrow
  real(dp), pointer :: BETA_EE(:)  => NULL ()
  real(dp), pointer :: BETA_EN(:)  => NULL ()
  real(dp), pointer :: A_EE(:,:)   => NULL ()  
  real(dp), pointer :: A_EN(:,:)   => NULL ()
  real(dp), pointer :: A_EEN(:,:)  => NULL ()
  end type jastrow

  type (jastrow), save  :: conf_jastr
end module jastrow_mod
