! -*- f90 -*-
!-----------------------------------------------------------------------------
!          This file is part of QmcMol A GNU QMC program for molecules.
!              Copyright (C) 2002 CNRS - U.P.M.C. Paris 6 - FRANCE
!          R. Assaraf, M. Caffarel, F. Colonna, X. Krokidis, B. Levy, 
!          P. Pernod, and P. Reinhardt - qmcmol@lct.jussieu.fr
!                       http://www.lct.jussieu.fr/QmcMol
! QmcMol is free software; you can redistribute it and/or modify it
! under the terms of the GNU General Public License as published by the Free
! Software  Foundation;  either version 2, or (at your option) any later
! version. QmcMol is distributed in the hope that it will be useful,but
! WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or  FITNESS FOR A PARTICULAR PURPOSE.   See the GNU General Public License
! for  more  details.  You  should  have  received a copy of the GNU General
! Public  License  along  with  QmcMol;  see the file COPYING.  If not,
! write to the  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
! Boston, MA 02111-1307, USA.
!-----------------------------------------------------------------------------

! ========================================================================
  subroutine main_menu_mc
! ------------------------------------------------------------------------
!
! Name   : main_menu_mc
!
! Authors:F. Colonna
! Date  :18 Jan 2002
! ------------------------------------------------------------------------

  use basis_menu_mod
  use density_grid_menu_mod
  use electrons_menu_mod
  use files_menu_mod
  use grid_menu_mod
  use intracule_mod
  use montecarlo_menu_mod
  use mos_menu_mod
  use print_mod
  use setup_mod
  use walkers_menu_mod
  use wavefunction_menu_mod
  use write_mod
  use minimize_mod
  use ecp_mod
  use force_bywlk_mod
!  use trial_menu_mod
  use guide_menu_mod

  implicit none

! local:
  character(len=max_string_len_routine_name) :: l_here
  logical(bool)                              :: done

! begin:
  l_here ='main_menu_mc'
  call enter (l_here)

  if (debug) write (logf,*)trim(l_here),'-d: start program '

  done = .false.
  call next_command_get ('main')
  do while (.not.done)
   call next_word_get('main')
   if(trim(cur_word) == 'help') then
    write (logf,*) 'main: main menu'
    write (logf,*) 'main: syntax'
    write (logf,*) 'main:  help'
    write (logf,*) 'main:  bas{is}        [command]'
    write (logf,*) 'main:  density_grid   [command]'
    write (logf,*) 'main:  ele{ctrons}    [command]'
    write (logf,*) 'main:  exi{t} ends program'      
    write (logf,*) 'main:  fil{e}         [command]'
    write (logf,*) 'main:  fun{ction}     [command] obsolete?'
    write (logf,*) 'main:  inc{lude}      [include file-name] '
    write (logf,*) 'main:  grid           [command]'
    write (logf,*) 'main:  guide          [command]'
    write (logf,*) 'main:  intracule      [command]'
    write (logf,*) 'main:  loop           [command]'
    write (logf,*) 'main:  min{imize}     [command]'
    write (logf,*) 'main:  mos            [command]'
    write (logf,*) 'main:  mon{tecarlo}   [command]'
    write (logf,*) 'main:  nuc{lei}       [command]'
    write (logf,*) 'main:  obj{ects}      [command]'
    write (logf,*) 'main:  pri{nt}        [command]'
    write (logf,*) 'main:  pse{udos}      [command]'
    write (logf,*) 'main:  rou{tines}     [command] obsolete?'
    write (logf,*) 'main:  set{up}        [command]'
    write (logf,*) 'main:  sho{w}         [command]'
    write (logf,*) 'main:  sto{p} ends program'      
    write (logf,*) 'main:  sym{bol}       [command]'
    write (logf,*) 'main:  tri{al}        [command]'
    write (logf,*) 'main:  wal{kers}      [command]'
    write (logf,*) 'main:  wav{efunction} [command]'
    write (logf,*) 'main:  wri{te}        [command]' 

   else if(cur_word(1:3) == 'bas') then
    call basis_menu

   else if(cur_word(1:3) == 'den') then
    call density_grid_menu 

   else if(cur_word(1:3) == 'ele')  then
    call electrons_menu

   else if(cur_word(1:3) == 'exi') then
    call finish
    stop 'end of program QmcMol'

   else if(cur_word(1:3) == 'fil')  then
    call files_menu

   else if(cur_word(1:3) == 'for') then
      call force_menu

   else if(cur_word(1:3) == 'cut') then
      call cutoff_menu

   else if(cur_word(1:3) == 'fun')  then
    call func_menu

   else if(cur_word(1:3) == 'gri') then
    call grid_menu 

   else if(cur_word(1:3) == 'gui') then
    call guide_menu

   else if(cur_word(1:3) == 'int') then
    call intracule_menu 

   else if(cur_word(1:3) == 'loo') then
    call loop_menu 

   else if(cur_word(1:3) == 'min')  then
    call minimize_menu

   else if(cur_word(1:3) == 'mon') then
    call montecarlo_menu

   else if(cur_word(1:3) == 'mos') then
    call mos_menu      

   else if(cur_word(1:3) == 'nuc') then
    call nuclei_menu      

   else if(cur_word(1:3) == 'obj') then
     call objects_menu

   else if(cur_word(1:3) == 'pri') then
    call print_menu
  
   else if(cur_word(1:3) == 'pse') then
    call pseudo_menu
  
   else if(cur_word(1:3) == 'rou') then
     call routines_menu 
   
   else if(cur_word(1:3) == 'set') then
    call setup_menu

   else if(cur_word(1:3) == 'sho') then
    call show_menu

   else if(cur_word(1:3) == 'sto') then
    call finish
    stop 'end of program'

   else if(cur_word(1:3) == 'sym') then
    call symbol_menu

!   else if(cur_word(1:3) == 'tri') then
!    write(logf,*) 'call trial menu'
!    call trial_menu

   else if(cur_word(1:3) == 'wal') then
    call walkers_menu

   else if(cur_word(1:3) == 'wav') then
    call wavefunction_menu      

   else if(cur_word(1:3) == 'wri') then
    call write_menu

   else
    call menu_exit (l_here, done)

   end if
   
  end do

  call exit (l_here)

  end subroutine main_menu_mc

! ========================================================================
  recursive subroutine loop_menu
! ------------------------------------------------------------------------
!
! Name   : main_menu_mc
!
! Authors:R. Assaraf
! Date  : 10 Jul 2005
! ------------------------------------------------------------------------

  use basis_menu_mod
  use density_grid_menu_mod
  use electrons_menu_mod
  use files_menu_mod
  use grid_menu_mod
  use montecarlo_menu_mod
  use mos_menu_mod
  use print_mod
  use setup_mod
  use walkers_menu_mod
  use wavefunction_menu_mod
  use write_mod
  use minimize_mod
  use ecp_mod
  use force_bywlk_mod

  implicit none

! local:
  character(len=max_string_len_routine_name) :: l_here
  logical(bool)                              :: done
  integer(dpi)                               :: cur_word_pos_sav
  integer(dpi)                               :: iter 
  integer(dpi)                               :: iter_nb 

! begin:
  l_here ='loop_menu'
  call enter (l_here)

  cur_word_pos_sav = cur_word_pos
  iter = 1

  if (debug) write (logf,*)trim(l_here),'-d: start program '

  done = .false.
  call next_command_get ('loop')
  do while (.not.done)
   call next_word_get('loop')
   if(trim(cur_word) == 'help') then
    write (logf,*) 'loop: loop menu'
    write (logf,*) 'loop: syntax'
    write (logf,*) 'loop:  help'
    write (logf,*) 'loop:  bas{is}        [command]'
    write (logf,*) 'loop:  ele{ctrons}    [command]'
    write (logf,*) 'loop:  exi{t} ends program'      
    write (logf,*) 'loop:  fil{e}         [command]'
    write (logf,*) 'loop:  fun{ction}     [command] obsolete?'
    write (logf,*) 'loop:  inc{lude}      [include file-name] '
    write (logf,*) 'loop:  grid           [command]'
    write (logf,*) 'loop:  min{imize}     [command]'
    write (logf,*) 'loop:  mos            [command]'
    write (logf,*) 'loop:  mon{tecarlo}   [command]'
    write (logf,*) 'loop:  nuc{lei}       [command]'
    write (logf,*) 'loop:  obj{ects}      [command]'
    write (logf,*) 'loop:  pri{nt}        [command]'
    write (logf,*) 'loop:  pse{udos}      [command]'
    write (logf,*) 'loop:  rou{tines}     [command] obsolete?'
    write (logf,*) 'loop:  set{up}        [command]'
    write (logf,*) 'loop:  sho{w}         [command]'
    write (logf,*) 'loop:  sto{p} ends program'      
    write (logf,*) 'loop:  sym{bol}       [command]'
    write (logf,*) 'loop:  wal{kers}      [command]'
    write (logf,*) 'loop:  wav{efunction} [command]'
    write (logf,*) 'loop:  wri{te}        [command]' 

   else if (token_is('ite',iter_nb)) then

   else if(cur_word(1:3) == 'bas') then
    call basis_menu

   else if(cur_word(1:3) == 'den') then
    call density_grid_menu 

   else if(cur_word(1:3) == 'ele')  then
    call electrons_menu

   else if(cur_word(1:3) == 'exi') then
    call finish
    stop 'end of program QmcMol'

   else if(cur_word(1:3) == 'fil')  then
    call files_menu

   else if(cur_word(1:3) == 'for') then
      call force_menu

   else if(cur_word(1:3) == 'cut') then
      call cutoff_menu

   else if(cur_word(1:3) == 'fun')  then
    call func_menu

   else if(cur_word(1:3) == 'gri') then
    call grid_menu 

   else if(cur_word(1:3) == 'loo') then
    call loop_menu 

   else if(cur_word(1:3) == 'min')  then
    call minimize_menu

   else if(cur_word(1:3) == 'mon') then
    call montecarlo_menu

   else if(cur_word(1:3) == 'mos') then
    call mos_menu      

   else if(cur_word(1:3) == 'nuc') then
    call nuclei_menu      

   else if(cur_word(1:3) == 'obj') then
     call objects_menu

   else if(cur_word(1:3) == 'pri') then
    call print_menu
  
   else if(cur_word(1:3) == 'pse') then
    call pseudo_menu
  
   else if(cur_word(1:3) == 'rou') then
     call routines_menu 
   
   else if(cur_word(1:3) == 'set') then
    call setup_menu

   else if(cur_word(1:3) == 'sho') then
    call show_menu

   else if(cur_word(1:3) == 'sto') then
    call finish
    stop 'end of program'

   else if(cur_word(1:3) == 'sym') then
    call symbol_menu

   else if(cur_word(1:3) == 'wal') then
    call walkers_menu

   else if(cur_word(1:3) == 'wav') then
    call wavefunction_menu      

   else if(cur_word(1:3) == 'wri') then
    call write_menu

   else
      if (iter .ge. iter_nb)  then 
         write (res,*)
         write (res,*)  'End of iteration #', iter, ' End of the loop'
         write (res,*)

         write (logf,*)  trim (l_here), ': End of iteration #', iter, ' End of the loop'

         call menu_exit (l_here, done) 
      else
         cur_word_pos = cur_word_pos_sav
         write (res,*)
         write (res,*)  'End of iteration #', iter, ' of the command loop'
         write (res,*)
         
         write (logf,*) trim (l_here),  ':End of iteration #', iter, ' of the command loop'
         iter = iter + 1
      endif
 
   
   end if
   
  end do

  call exit (l_here)

  end subroutine loop_menu
