
! -*- f90 -*-
module step_bywlk_secondary_mod
  use step_bywlk_mod
  use secondary_mod
  implicit none


 
  real(dp), pointer  :: elec_coor_old_bywlk_2 (:,:,:) => NULL () 
  real(dp), pointer  :: drift_old_bywlk_2 (:,:,:) => NULL () 
  real(dp), pointer  :: e_loc_tot_old_bywlk_2 (:) => NULL () 

  contains


! ========================================================================
  subroutine one_step_bywlk_2_bld
! ------------------------------------------------------------------------
! Name : one_step_bywlk_2_bld
!
! 

!                  
! Authors :  R. Assaraf
! Date    : 18  June 2006
! ------------------------------------------------------------------------
  implicit none
  
! i/o:

! local:
  character(len=max_string_len_routine_name),save :: l_here

  integer(dpi)       :: dimensions_nb
  integer(dpi)       :: electrons_nb
  integer(dpi)       :: walkers_nb
  integer(dpi)       :: dim_i, elec_i, walk_i, i

  integer(dpi), pointer, save :: path_bynod (:) => NULL ()

  integer(i4b) :: cloned(2) = 0
  integer(i4b) :: clones(2) = 0
 


! header:
  
  if (header_exe) then

  l_here = "one_step_bywlk_2_bld"

  call object_create ('elec_coor_old_bywlk_2')
  call object_create ('drift_old_bywlk_2')

  call object_needed ('e_loc_2_i')
  call object_needed ('drift_2_i')

  call object_needed ('drift_bywlk:c2')
  call object_needed ('e_loc_tot_bywlk:c2')

  call object_needed ('elec_coor_random_bywlk') 

  call object_needed ('elec_coor_old_bywlk')
  call object_needed ('drift_old_bywlk')
  call object_needed ('psi_old_bywlk')
  call object_needed ('e_loc_tot_old_bywlk')

  call object_needed ('elec_coor_bywlk')
  call object_needed ('drift_bywlk')
  call object_needed ('psi_bywlk')
  call object_needed ('e_loc_tot_bywlk')
  call object_needed ('walk_reconf_ind')
  return

  end if

! begin
  l_here = 'one_step_bywlk_2_bld'
  call enter (l_here)

  call is_needed (drift_2_i)
  call is_needed (e_loc_2_i)

  call is_needed (drift_bywlk_2)
  call is_needed (e_loc_tot_bywlk_2)  

  call is_needed (elec_coor_random_bywlk)

  call is_needed (elec_coor_old_bywlk)
  call is_needed (drift_old_bywlk)
  call is_needed (psi_old_bywlk)
  call is_needed (e_loc_tot_old_bywlk)

  call is_needed (elec_coor_bywlk)
  call is_needed (drift_bywlk)
  call is_needed (psi_bywlk)
  call is_needed (e_loc_tot_bywlk)

  electrons_nb  = size (drift_bywlk, 1)
  dimensions_nb = size (drift_bywlk, 2)
  walkers_nb    = size (drift_bywlk, 3)

  call alloc ('elec_coor_old_bywlk_2', elec_coor_old_bywlk_2, &
                electrons_nb, dimensions_nb, walkers_nb)

  call alloc ('drift_old_bywlk_2', drift_old_bywlk_2, &
                electrons_nb, dimensions_nb, walkers_nb)

   
  elec_coor_old_bywlk_2 = elec_coor_bywlk_2
  drift_old_bywlk_2     = drift_bywlk_2  


! build new coordinates set, Langevin step 

  do walk_i = 1, walkers_nb

     elec_coor_bywlk_2 (:,:,walk_i) = elec_coor_bywlk_2 (:,:, walk_i)     &
          +  elec_coor_bywlk(:,:,walk_i)-elec_coor_old_bywlk(:,:,walk_i)  &
          + (drift_bywlk_2 (:,:, walk_i)-drift_old_bywlk (:,:, walk_i))   &
          * time_step 
 
! for DMC       
!     elec_coor_bywlk_2 (:,:,walk_i) = elec_coor_old_bywlk_2 (:,:, walk_reconf_ind(walk_i))  &
!          +  elec_coor_bywlk(:,:,walk_i)-elec_coor_old_bywlk(:,:,walk_reconf_ind(walk_i))  &
!          + (drift_bywlk_2 (:,:, walk_reconf_ind(walk_i))-drift_old_bywlk (:,:, walk_reconf_ind(walk_i)=) &
!          * time_step 
        


!   elec_coor_bywlk_2 (:,:,walk_i) = elec_coor_bywlk_2 (:,:, walk_i) &
!            + drift_bywlk_2 (:,:, walk_i) * time_step &
!            + sqrt(time_step)*elec_coor_random_bywlk (:,:,walk_i)

  enddo ! do walk_i

  if (.not.associated (path_bynod))  then
     call path_bynod_bld (path_bynod, (/ object_index('elec_coor_bywlk_2') /), (/ (i, i=1, objects_nb) /))
  endif
  is_valid_bynod (path_bynod) = .false.

  call exit (l_here)
  
end subroutine one_step_bywlk_2_bld

end module step_bywlk_secondary_mod
