! -*- f90 -*-
!-----------------------------------------------------------------------------
!          This file is part of QmcMol A GNU QMC program for molecules.
!       Copyright (C) 2002 CNRS - U.P.M.C. Paris 6 - FRANCE
!          R. Assaraf, M. Caffarel, F. Colonna, X. Krokidis, B. Levy, 
!          P. Pernod, and P. Reinhardt - qmcmol@lct.jussieu.fr
!                       http://www.lct.jussieu.fr/QmcMol
! QmcMol is free software; you can redistribute it and/or modify it
! under the terms of the GNU General Public License as published by the Free
! Software  Foundation;  either version 2, or (at your option) any later
! version. QmcMol is distributed in the hope that it will be useful,but
! WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or  FITNESS FOR A PARTICULAR PURPOSE.   See the GNU General Public License
! for  more  details.  You  should  have  received a copy of the GNU General
! Public  License  along  with  QmcMol;  see the file COPYING.  If not,
! write to the  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
! Boston, MA 02111-1307, USA.
!-----------------------------------------------------------------------------

module walkers_menu_mod

  use system_data_mod
  use files_menu_mod
  use parser_mod

  use walkers_bywlk_mod

  implicit none
  
  contains

! ========================================================================
  subroutine walkers_menu
! ------------------------------------------------------------------------
!
! Name           : walkers_menu
!
! Description    : input for walkers
!
! Author:P. Reinhardt  F. Colonna
! Date  :13 Nov 2000
! ------------------------------------------------------------------------
  implicit none

! local:
  character(len=max_string_len_routine_name) :: l_here
  logical(bool)                              :: done
  logical(bool)                              :: l_print   
  logical(bool)                              :: l_write   

! begin:
  l_here ='walkers_menu'
  call enter (l_here) 

! initialize:

  l_print               = .false.  
  l_write               = .false.  

  done = .false.
  call next_command_get ('walkers')
  do while (.not.done)
   call next_word_get('walkers')
   if(trim(cur_word) .eq. 'help') then

    write (logf,*) 'walk-h: walkers definitions'
    write (logf,*) 'walk-h: syntaxe:'
    write (logf,*) 'walk-h: walkers '
    write (logf,*) 'walk-h:  help'
    write (logf,*) 'walk-h:  fil{e}   [command]'
    write (logf,*) 'walk-h:  num{ber} = [integer] nb of walkers'
    write (logf,*) 'walk-h:  pri{nt}  = [boolean]'
    write (logf,*) 'walk-h:  wri{te}  = [boolean]'
    write (logf,*) 'walk-h: end'
    write (logf,*) 'walk-h: example'
    write (logf,*) 'walk-h: walkers   file ... end  end'

   else if(cur_word(1:3) .eq. 'fil') then
     call files_menu

   else if(token_is ('pri', l_print)) then

   else if(token_is ('wri', l_write)) then

   else if(token_is ('num', system%walkers_nb)) then

   else
    call menu_exit (l_here, done)
   end if
  end do

  if(l_print) call walkers_bywlk_print 

  call exit (l_here)

  end subroutine walkers_menu

end module walkers_menu_mod

