# builds alloc_object_name.inc file from Needs Comment

die "Usage:\n perl $0 *.f90" if $#ARGV < 0 ;

$DimensH{"ao"}    = "aos_nb";
$DimensH{"ao_c"}  = "aos_c_nb";
$DimensH{"ao_s"}  = "aos_s_nb";
$DimensH{"atom"}  = "atoms_nb";
$DimensH{"atom)%coordinates(dim"}  = "dimensions_nb";
$DimensH{"alfa"}  = "alfa_electrons_nb";
$DimensH{"beta"}  = "beta_electrons_nb";
$DimensH{"bloc"}  = "blocks_nb";
$DimensH{"conf"}  = "configurations_nb"; 
$DimensH{"conf)%conf_jastr%beta_en(atom"} = "configurations_nb";
$DimensH{"conf)%conf_jastr%a_ee(lik"}="lik_nb";
$DimensH{"conf)%conf_jastr%a_een(lik"}="lik_nb";
$DimensH{"conf)%conf_jastr%a_en(deg"}="max_degree_a_ee";
$DimensH{"conf)%conf_jastr%beta_ee(lik"}="lik_nb";
$DimensH{"conf)%conf_deter(det"}="max_determinants_nb";
$DimensH{"conf)%conf_deter(det)%alfa_orbitals(elec_a"}="alfa_electrons_nb";
$DimensH{"conf)%conf_deter(det)%beta_orbitals(elec_b"}="beta_electrons_nb";
$DimensH{"deg"}   = "max_degree_a_ee";
$DimensH{"det"}   = "max_determinants_nb";
$DimensH{"det)%alfa_orbitals(elec_a"}="alfa_electrons_nb";
$DimensH{"det)%beta_orbitals(elec_b"}="beta_electrons_nb";
$DimensH{"dim"}   = "dimensions_nb";
$DimensH{"dpn"}   = "dependences_nb";
$DimensH{"elec"}  = "electrons_nb";
$DimensH{"elec_a"}  = "alfa_electrons_nb";
$DimensH{"elec_b"}  = "beta_electrons_nb";
$DimensH{"lik"}   = "lik_nb";
$DimensH{"epf"}   = "epfs_nb";
$DimensH{"max_d"} = "max_determinants_nb";
$DimensH{"mo"}    = "mos_nb";
$DimensH{"mocl"}    = "mos_coeff_list_nb";
$DimensH{"obj"}    = "objects_nb";
$DimensH{"pow"}   = "power_max";
$DimensH{"pnt"}   = "points_nb";
$DimensH{"rtn"}   = "routines_nb";
$DimensH{"step"}   = "steps_nb";
$DimensH{"xpf"}   = "xpfs_nb";
$DimensH{"xpf_s"}   = "xpfs_s_nb";
$DimensH{"xpf_c"}   = "xpfs_c_nb";
$DimensH{"walk"}  = "walkers_nb";

@ijkl=('i','j','k','l');

# read object to routine file:
$objtorF="object-built-by-routine.lis";

open OBJTOR,"<$objtorF" || die "$0-e: can't open $objtorF:\n";

# create list of creation subroutine @SubCreatL
while(<OBJTOR>){
	($o,$r)= split ' ',$_;
	$ObjToRouH{$o}=$r;
	push @SubCreatL, $r
}

close OBJTOR ;

# &prt_hash ("ObjToRouH", %ObjToRouH);
# &prt_list ("SubCreatL", @SubCreatL);

# scan fortran file
foreach $codeF (@ARGV){

	open(INP, "<$codeF");

	$inside=0;             
	while(<INP>){
		if(/^\s*end\s*subroutine/){ # end of routine line
			$inside=0;             
		}
# get subroutine name
		elsif(($s)=($_ =~ /^\s*subroutine\s*(\S+)\s*(\()?/)){ # top of routine
			$inside=1;
			$subname=$s ;
			print "current routine $s\n";
		}
		elsif(($o,$d)=($_ =~ /^!\s+Creates\s+:\s+(\S+)\s+\((.*)\)/)){

			if($inside){
# array declaration
			$declar="$o ($d)";
			print "current object  $o\n";

			$r=$ObjToRouH{$o};
			# print "r >$r<\n";
			if($r ne $subname && $subname ne ""){
			 print "Object $o creation routine is $r in file $objtorF\nand $subname in fortran file $codeF\n";
			}

			$d =~ s/ //g;
			@dimL= split ',',$d;
			@dimijL='';
			foreach $d (@dimL) {
				print "$0-e: file $codeF in routine $subname\n";
        die "dimension item '$d' undefined\n" unless (exists $DimensH{$d});

				$DimTimesH{$d} = $DimTimesH{$d} +1 ;
				$ij=$ijkl[$DimTimesH{$d}-1];
				push @dimijL, $d."_".$ij ; # elec_i, elec_j etc...
#			print "DimTimes  $DimTimesH{$d}\n";
#			print "ij $ij\n";
			}
			shift @dimijL;
			foreach $d (@dimijL) {
#			print "dimijL $d\n";
			}

			#print "o $o\n";
			#print join("\n",@dimL),"\n";

# create file alloc_object.inc
      $allocF="alloc_$o.inc";
			print "  include '$allocF'\n";
			open ALLOC,">$allocF";
				print ALLOC "! allocations:\n\n";
				print ALLOC "  if(.not.associated($o)) then\n";
				print ALLOC "    if(trace_depend) &\n";
        			print ALLOC "      print *,trim(l_here),': $o not yet associated'\n";
				print ALLOC "      call allocation ('$o', &\n";
				print ALLOC "                        $o,  &\n";

			$n=0;
      foreach $d (@dimL){
				$n++; 
        print ALLOC "                        $DimensH{$d}";
				if($n > $#dimL){print ALLOC ")\n"}   # close parenthesis
				else {print ALLOC ", &\n"}
      }
				print ALLOC "  else \n";
				print ALLOC "    if(trace_depend) &\n";
				print ALLOC "     print *,trim(l_here),': $o left in memory'\n";
				print ALLOC "  end if\n";
				print ALLOC "\n! end allocations\n\n";
      close ALLOC;

# debug
      $debugF="debug_$o.inc";
			print "  include '$debugF'\n";
			open DEBUG,">$debugF";
			print DEBUG "\n  if(debug) then\n";
			$n=0;
 			foreach $di (reverse @dimijL){
				$n++; 
				($d = $di) =~ s/_[i-l]//;
				print DEBUG "  " x $n;
				print DEBUG "do $di = 1, $DimensH{$d}\n";
			}

#  print *,trim(l_here),'-d: elec_elec_dist_grd_bywlk (elec, elec, dim, walk)'

   		print DEBUG "   print *,trim(l_here),'-d: '\n";
   		print DEBUG "   print *,trim(l_here),'-d: $declar'\n";
   		print DEBUG "   print *,trim(l_here),'-d: $o (',";

# print *,trim(l_here),'-d: elec_elec_dist_grd_bywlk (',elec_i,',',
# 						elec_j,',',dim_i,',', walk_i,') =', &
	$n=0;
	foreach $di (@dimijL){
		$n++;
		print DEBUG " $di";
		if($n > $#dimijL){print DEBUG ",') =', &\n"}
		else {print DEBUG ",',',"}
	}

# elec_elec_dist_grd_bywlk (elec_i, elec_j, dim_i, walk_i)

	print DEBUG "                             $o (";
	$n=0;
	foreach $di (@dimijL){
		$n++;
		print DEBUG " $di";
		if($n > $#dimL){print DEBUG ")\n"}
		else {print DEBUG ","}
	}

# end do
	$n=0;
	foreach $d (@dimL){
		$n++;
		print DEBUG "  " x ($#dimL-$n+2);
        	print DEBUG "end do\n";
	}
	print DEBUG "  end if \n\n";
	close DEBUG;

# not numerical
      $ensnbF="ensnb_$o.inc";
			print "  include '$ensnbF'\n";
			open ENSNB,">$ensnbF";
			$n=0;
 			foreach $di (reverse @dimijL){
				$n++; 
				($d = $di) =~ s/_[i-l]//;
				print ENSNB "  " x $n;
				print ENSNB "do $di = 1, $DimensH{$d}\n";
			}

  print ENSNB "   write(strjunk,*)";
  print ENSNB " $o (";
	$n=0;
	foreach $di (@dimijL){
		$n++;
		print ENSNB " $di";
		if($n > $#dimL){print ENSNB ")\n"}
		else {print ENSNB ","}
	}
	print ENSNB "   if(.not. numeric_is(strjunk))then\n";

#  print *,trim(l_here),'-d: elec_elec_dist_grd_bywlk (elec, elec, dim, walk)'

   		print ENSNB "   print *,trim(l_here),'-e: '\n";
   		print ENSNB "   print *,trim(l_here),'-e: $declar'\n";
   		print ENSNB "   print *,trim(l_here),'-e: $o (',";

# print *,trim(l_here),'-d: elec_elec_dist_grd_bywlk (',elec_i,',',
# 						elec_j,',',dim_i,',', walk_i,') =', &
	$n=0;
	foreach $di (@dimijL){
		$n++;
		print ENSNB " $di";
		if($n > $#dimijL){print ENSNB ",') =', &\n"}
		else {print ENSNB ",',',"}
	}

# elec_elec_dist_grd_bywlk (elec_i, elec_j, dim_i, walk_i)

	print ENSNB "                             $o (";
	$n=0;
	foreach $di (@dimijL){
		$n++;
		print ENSNB " $di";
		if($n > $#dimL){print ENSNB ")\n"}
		else {print ENSNB ","}
	}
	print ENSNB "    call die (l_here,'$o is not numerical')\n";
	print ENSNB "    end if\n";

# end do
	$n=0;
	foreach $d (@dimL){
		$n++;
		print ENSNB "  " x ($#dimL-$n+2);
        	print ENSNB "end do\n";
	}
	close ENSNB;


# reset %DimTimesH
	foreach $d (keys %DimTimesH){
		$DimTimesH{$d} = 0 ;
		#print " %DimTimesH{$d} = $DimTimesH{$d}\n";
	}
	} # inside
	} # Creates
	} # while
	close INP;
}

sub prt_hash {
   local($String,%Array) = @_;
   $n=keys(%Array);
   print "prt_hash: error no elements Hash $String\n" if $n == 0;
   print " Hash $String:\n";
   foreach $elem (sort keys(%Array)) {
      print " " x (39 - length($elem));
      print '"',$elem,'"', "  ",$Array{$elem}, "\n";
   }
} # end
1;

sub prt_list {
   local($String,@Array) = @_;
   local($name);
   $n=$#Array;
 	print "prt_list: error no elements in List $String\n" if $n == -1;
   print " List $String:\n";
   foreach $name (@Array) {
      print " " x 10;
      print '"',$name,'"',"\n";
   }
} # end
1;

