#!/usr/bin/perl
# builds ensnb_object_name.inc file from Creates Comment
# builds debug_object_name.inc file from Creates Comment
# builds empty_object_name.inc file from Creates Comment

die "Usage:\n $0 *.f95" if $#ARGV < 0 ;

$DimensH{"ao"}    = "aos_nb";
$DimensH{"ao_c"}  = "aos_c_nb";
$DimensH{"ao_s"}  = "aos_s_nb";
$DimensH{"atom"}  = "atoms_nb";
$DimensH{"atom)%coordinates(dim"}  = "dimensions_nb";
$DimensH{"alfa"}  = "alfa_electrons_nb";
$DimensH{"beta"}  = "beta_electrons_nb";
$DimensH{"bloc"}  = "blocks_nb";
$DimensH{"conf"}  = "configurations_nb"; 
$DimensH{"conf)%conf_jastr%beta_en(atom"} = "configurations_nb";
$DimensH{"conf)%conf_jastr%a_ee(lik"}="lik_nb";
$DimensH{"conf)%conf_jastr%a_een(lik"}="lik_nb";
$DimensH{"conf)%conf_jastr%a_en(deg"}="max_degree_a_ee";
$DimensH{"conf)%conf_jastr%beta_ee(lik"}="lik_nb";
$DimensH{"conf)%conf_deter(det"}="max_determinants_nb";
$DimensH{"conf)%conf_deter(det)%alfa_orbitals(elec_a"}="alfa_electrons_nb";
$DimensH{"conf)%conf_deter(det)%beta_orbitals(elec_b"}="beta_electrons_nb";
$DimensH{"deg"}   = "max_degree_a_ee";
$DimensH{"det"}   = "max_determinants_nb";
$DimensH{"det)%alfa_orbitals(elec_a"}="alfa_electrons_nb";
$DimensH{"det)%beta_orbitals(elec_b"}="beta_electrons_nb";
$DimensH{"dim"}   = "dimensions_nb";
$DimensH{"dpn"}   = "dependences_nb";
$DimensH{"elec"}  = "electrons_nb";
$DimensH{"elec_a"}  = "alfa_electrons_nb";
$DimensH{"elec_b"}  = "beta_electrons_nb";
$DimensH{"expr"}  = "expressions_nb";
$DimensH{"lik"}   = "lik_nb";
$DimensH{"epf"}   = "epfs_nb";
$DimensH{"max_d"} = "max_determinants_nb";
$DimensH{"mo"}    = "mos_nb";
$DimensH{"mocl"}    = "mos_coeff_list_nb";
$DimensH{"obj"}    = "objects_nb";
$DimensH{"outl"}    = "output_list_nb";
$DimensH{"pow"}   = "power_max";
$DimensH{"pnt"}   = "points_nb";
$DimensH{"rtn"}   = "routines_nb";
$DimensH{"step"}   = "steps_nb";
$DimensH{"tar"}   = "targets_nb";
$DimensH{"xpf"}   = "xpfs_nb";
$DimensH{"xpf_s"}   = "xpfs_s_nb";
$DimensH{"xpf_c"}   = "xpfs_c_nb";
$DimensH{"walk"}  = "walkers_nb";
$DimensH{"wrd"}  = "input_words_nb";

@ijkl=('i','j','k','l');

# read object to routine file:
$objtorF="object-built-by-routine.lis";

open OBJTOR,"<$objtorF" || die "$0-e: can't open $objtorF:\n";

# create list of creation subroutine @SubCreatL
while(<OBJTOR>){
	($o,$r)= split ' ',$_;
	$ObjToRouH{$o}=$r;
	push @SubCreatL, $r
}

close OBJTOR ;

# &prt_hash ("ObjToRouH", %ObjToRouH);
# &prt_list ("SubCreatL", @SubCreatL);

# scan fortran file
foreach $codeF (@ARGV){

	open(INP, "<$codeF");

	while(<INP>){
		if(($o,$d)=($_ =~ /^!\s+Creates\s+:\s+(\S+)\s+\((.*)\)/)){

# array declaration
			$declar="$o ($d)";
			print "current object  $o\n";

			$d =~ s/ //g;
			@dimL= split ',',$d;
			@dimijL='';
			foreach $d (@dimL) {
				print "$0-e: file $codeF in routine $subname\n";
        die "dimension item '$d' undefined\n" unless (exists $DimensH{$d});

				$DimTimesH{$d} = $DimTimesH{$d} +1 ;
				$ij=$ijkl[$DimTimesH{$d}-1];
				push @dimijL, $d."_".$ij ; # elec_i, elec_j etc...
#			print "DimTimes  $DimTimesH{$d}\n";
#			print "ij $ij\n";
			}

			shift @dimijL;
			foreach $d (@dimijL) {
#			print "dimijL $d\n";
			}

			#print "o $o\n";
			#print join("\n",@dimL),"\n";

# debug
      $debugF="debug_$o.inc";
			print "  include '$debugF'\n";
			open DEBUG,">$debugF";
			print DEBUG "\n  if(debug) then\n";
			$n=0;
 			foreach $di (reverse @dimijL){
				$n++; 
				($d = $di) =~ s/_[i-l]//;
				print DEBUG "  " x $n;
				print DEBUG "do $di = 1, $DimensH{$d}\n";
			}

#  print *,trim(l_here),'-d: elec_elec_dist_grd_bywlk (elec, elec, dim, walk)'

   		print DEBUG "   write (logf,*) trim(l_here),'-d: '\n";
   		print DEBUG "   write (logf,*) trim(l_here),'-d: $declar'\n";
   		print DEBUG "   write (logf,*) trim(l_here),'-d: $o (',";

# print *,trim(l_here),'-d: elec_elec_dist_grd_bywlk (',elec_i,',',
# 						elec_j,',',dim_i,',', walk_i,') =', &
	$n=0;
	foreach $di (@dimijL){
		$n++;
		print DEBUG " $di";
		if($n > $#dimijL){print DEBUG ",') =', &\n"}
		else {print DEBUG ",',',"}
	}

# elec_elec_dist_grd_bywlk (elec_i, elec_j, dim_i, walk_i)

	print DEBUG "                             $o (";
	$n=0;
	foreach $di (@dimijL){
		$n++;
		print DEBUG " $di";
		if($n > $#dimL){print DEBUG ")\n"}
		else {print DEBUG ","}
	}

# end do
	$n=0;
	foreach $d (@dimL){
		$n++;
		print DEBUG "  " x ($#dimL-$n+2);
        	print DEBUG "end do\n";
	}
	print DEBUG "  end if \n\n";
	close DEBUG;

# not numerical
      $ensnbF="ensnb_$o.inc";
			print "  include '$ensnbF'\n";
			open ENSNB,">$ensnbF";
			$n=0;
 			foreach $di (reverse @dimijL){
				$n++; 
				($d = $di) =~ s/_[i-l]//;
				print ENSNB "  " x $n;
				print ENSNB "do $di = 1, $DimensH{$d}\n";
			}

  print ENSNB "   write(strjunk,*)";
  print ENSNB " $o (";
	$n=0;
	foreach $di (@dimijL){
		$n++;
		print ENSNB " $di";
		if($n > $#dimL){print ENSNB ")\n"}
		else {print ENSNB ","}
	}
	print ENSNB "   if(.not. numeric_is(strjunk))then\n";

#  print *,trim(l_here),'-d: elec_elec_dist_grd_bywlk (elec, elec, dim, walk)'

   		print ENSNB "   write (logf,*) trim(l_here),'-e: '\n";
   		print ENSNB "   write (logf,*) trim(l_here),'-e: $declar'\n";
   		print ENSNB "   write (logf,*) trim(l_here),'-e: $o (',";

# print *,trim(l_here),'-d: elec_elec_dist_grd_bywlk (',elec_i,',',
# 						elec_j,',',dim_i,',', walk_i,') =', &
	$n=0;
	foreach $di (@dimijL){
		$n++;
		print ENSNB " $di";
		if($n > $#dimijL){print ENSNB ",') =', &\n"}
		else {print ENSNB ",',',"}
	}

# elec_elec_dist_grd_bywlk (elec_i, elec_j, dim_i, walk_i)

	print ENSNB "                             $o (";
	$n=0;
	foreach $di (@dimijL){
		$n++;
		print ENSNB " $di";
		if($n > $#dimL){print ENSNB ")\n"}
		else {print ENSNB ","}
	}
	print ENSNB "    call die (l_here,'$o is not numerical')\n";
	print ENSNB "    end if\n";

# end do
	$n=0;
	foreach $d (@dimL){
		$n++;
		print ENSNB "  " x ($#dimL-$n+2);
        	print ENSNB "end do\n";
	}
	close ENSNB;

# empty:
      $emptyF="empty_$o.inc";
			print "  include '$emptyF'\n";
			open EMPTY,">$emptyF";

			print EMPTY "  valjunk = 0.d0\n";;
			$n=0;
 			foreach $di (reverse @dimijL){
				$n++; 
				($d = $di) =~ s/_[i-l]//;
				print EMPTY "  " x $n;
				print EMPTY "do $di = 1, $DimensH{$d}\n";
			}

  print EMPTY "   valjunk = valjunk +" ;
  print EMPTY " $o (";
	$n=0;
	foreach $di (@dimijL){
		$n++;
		print EMPTY " $di";
		if($n > $#dimL){print EMPTY ")\n"}
		else {print EMPTY ","}
	}

#  print *,trim(l_here),'-d: elec_elec_dist_grd_bywlk (elec, elec, dim, walk)'

# print *,trim(l_here),'-d: elec_elec_dist_grd_bywlk (',elec_i,',',
# 						elec_j,',',dim_i,',', walk_i,') =', &
#	$n=0;
#	foreach $di (@dimijL){
#		$n++;
#		print EMPTY " $di";
#		if($n > $#dimijL){print EMPTY ",') =', &\n"}
#		else {print EMPTY ",',',"}
#	}

# elec_elec_dist_grd_bywlk (elec_i, elec_j, dim_i, walk_i)

#	print EMPTY "                             $o (";
#	$n=0;
#	foreach $di (@dimijL){
#		$n++;
#		print EMPTY " $di";
#		if($n > $#dimL){print EMPTY ")\n"}
#		else {print EMPTY ","}
#	}

# end do
	$n=0;
	foreach $d (@dimL){
		$n++;
		print EMPTY "  " x ($#dimL-$n+2);
        	print EMPTY "end do\n";
	}
	print EMPTY "  if( abs(valjunk) < 1.d-15 )then\n";
	print EMPTY "    call die (l_here,'$o has only zeroes')\n";
 	print EMPTY "  end if\n";
	close EMPTY;


# reset %DimTimesH
	foreach $d (keys %DimTimesH){
		$DimTimesH{$d} = 0 ;
		#print " %DimTimesH{$d} = $DimTimesH{$d}\n";
	}
	} # Creates
	} # while
	close INP;
}

sub prt_hash {
   local($String,%Array) = @_;
   $n=keys(%Array);
   print "prt_hash: error no elements Hash $String\n" if $n == 0;
   print " Hash $String:\n";
   foreach $elem (sort keys(%Array)) {
      print " " x (39 - length($elem));
      print '"',$elem,'"', "  ",$Array{$elem}, "\n";
   }
} # end
1;

sub prt_list {
   local($String,@Array) = @_;
   local($name);
   $n=$#Array;
 	print "prt_list: error no elements in List $String\n" if $n == -1;
   print " List $String:\n";
   foreach $name (@Array) {
      print " " x 10;
      print '"',$name,'"',"\n";
   }
} # end
1;

