# builds routine-routine-depend.lis file from Needs
# shold be copied to routine-routine-depend.inc to be used by the program

die "Usage:\n perl $0 *.f90" if $#ARGV < 0 ;

$objtorF="object-built-by-routine.lis";

$dependF="routine-routine-depend.lis";
$dependG="routine-routine-depend.inc";
$dependB="dependences_list_bld.lis";
$dependC="dependences_list_bld.inc";

if (-s $objtorF ){
	open OBJTOR,"<$objtorF";
	while(<OBJTOR>){
		($o,$r)=($_ =~ /^(\S+)\s+(\S+)/);
		$ObjToRouH{$o}=$r;
	}
	close OBJTOR;
}

if (-s $dependF ){
	open DEPEND,"<$dependF";
	$Tout=join('',<DEPEND>);
	@DependL=split(/\n/,$Tout);
	close DEPEND;
}
$nlist=$#DependL+1;
print "length of list $nlist\n";

# scan fortran file
foreach $codeF (@ARGV){

print "fortran file $codeF\n";

	open(INP, "<$codeF");

	$subname="" ;

	while(<INP>){

		if(/^\s*end\s*subroutine/){ # end of routine line
			$subname="" ;
		}
# get subroutine name
		elsif(($s)=($_ =~ /^\s*subroutine\s*(\S+)\s*(\()?/)){ # top of routine
			$subname=$s ;
		}
		elsif(($o)=($_ =~ /^!\s*Needs\s*:\s*(\S+)\s+\(.*\)/)){

			# print "needed object $o\n";
			$r = $ObjToRouH{$o};

			if ($r eq ""){
				print "$0-e: in $codeF in routine $subname\n";
				print "needed object $o has no creation routine\n";
				print "check file $objtorF\n";
				print "run perl BuildObjectToRoutinesFromCreates.pl *.f90\n";
				exit;
			}
 		else{
 			$newcouple = $subname." ".$r;
 		}

      unless ((grep /^$newcouple$/,@DependL) || $subname eq ""){
				$newcouple = $subname." ".$r;
				print "new couple $newcouple\n";
				push @DependL,$newcouple;
      }

		}
	}
	close INP;
}

open DEPEND,">$dependF";
print DEPEND join("\n",@DependL),"\n";
close DEPEND;

open BLD,">$dependB";

$nlist=$#DependL+1;

print BLD   "  dependences_nb = $nlist\n";
print BLD   "! allocations:\n";
print BLD   "\n";
print BLD   "  if(.not.associated(dependences_list)) then\n";
print BLD   "    if(trace_depend) &\n";
print BLD   "      print *,trim(l_here),': dependences_list not yet associated'\n";
print BLD   "      call allocation ('dependences_list', &\n";
print BLD   "                        dependences_list,  &\n";
print BLD   "                        dependences_nb)\n";
print BLD   "  else\n";
print BLD   "    if(trace_depend) &\n";
print BLD   "     print *,trim(l_here),': dependences_list left in memory'\n";
print BLD   "  end if\n";
print BLD   "\n";
print BLD   "! end allocations\n";
print BLD   "\n";
print BLD   "  system%dependences_nb = dependences_nb\n";
print BLD   "  print *,trim(l_here),': ',dependences_nb,";
print BLD   "' elements in dependence list'\n";

$n=0;
foreach $r (@DependL){
	$n++;
	print BLD "  dependences_list (",$n,") = '$r'\n";
}

print "cp $dependF $dependG\n";
print "cp $dependB $dependC\n";
