# builds notass_object_name.inc file from Needs Comment

die "Usage:\n perl $0 *.f90" if $#ARGV < 0 ;

$DimensH{"ao"}    = "aos_nb";
$DimensH{"ao_c"}  = "aos_c_nb";
$DimensH{"ao_s"}  = "aos_s_nb";
$DimensH{"atom"}  = "atoms_nb";
$DimensH{"alfa"}  = "alfa_electrons_nb";
$DimensH{"beta"}  = "beta_electrons_nb";
$DimensH{"bloc"}  = "blocks_nb";
$DimensH{"conf"}  = "configurations_nb"; 
$DimensH{"conf)%conf_jastr%beta_en(atom"} = "configurations_nb";
$DimensH{"conf)%conf_jastr%a_ee(lik"}="lik_nb";
$DimensH{"conf)%conf_jastr%a_een(lik"}="lik_nb";
$DimensH{"conf)%conf_jastr%a_en(deg"}="max_degree_a_ee";
$DimensH{"conf)%conf_jastr%beta_ee(lik"}="lik_nb";
$DimensH{"conf)%conf_deter(det"}="max_determinants_nb";
$DimensH{"conf)%conf_deter(det)%alfa_orbitals(elec_a"}="alfa_electrons_nb";
$DimensH{"conf)%conf_deter(det)%beta_orbitals(elec_b"}="beta_electrons_nb";
$DimensH{"deg"}   = "max_degree_a_ee";
$DimensH{"det"}   = "max_determinants_nb";
$DimensH{"det)%alfa_orbitals(elec_a"}="alfa_electrons_nb";
$DimensH{"det)%beta_orbitals(elec_b"}="beta_electrons_nb";
$DimensH{"dim"}   = "dimensions_nb";
$DimensH{"dpn"}   = "dependences_nb";
$DimensH{"elec"}  = "electrons_nb";
$DimensH{"elec_a"}  = "alfa_electrons_nb";
$DimensH{"elec_b"}  = "beta_electrons_nb";
$DimensH{"epf"}   = "epfs_nb";
$DimensH{"lik"}   = "lik_nb";
$DimensH{"max_d"} = "max_determinants_nb";
$DimensH{"mo"}    = "mos_nb";
$DimensH{"mocl"}    = "mos_coeff_list_nb";
$DimensH{"obj"}    = "objects_nb";
$DimensH{"pow"}   = "power_max";
$DimensH{"pnt"}   = "points_nb";
$DimensH{"rtn"}   = "routines_nb";
$DimensH{"step"}   = "steps_nb";
$DimensH{"xpf"}   = "xpfs_nb";
$DimensH{"xpf_s"}   = "xpfs_s_nb";
$DimensH{"xpf_c"}   = "xpfs_c_nb";
$DimensH{"walk"}  = "walkers_nb";
$DimensH{"atom)%coordinates(dim"}  = "dimensions_nb";

# RefDimensH for chksiz include
foreach $d (keys %DimensH){
	$RefDimensH{$d} = "system%$DimensH{$d}";
}

# Exceptions:
$RefDimensH{"walk"} = "walkers_data%walkers_nb";
$RefDimensH{"xpf_c"} = "system%xpfs_nb";
$RefDimensH{"xpf_s"} = "system%xpfs_nb";
$RefDimensH{"deg"}  = "4";

# &prt_hash ("RefDimensH", %RefDimensH);

# read object to routine file:
$objtorF="object-built-by-routine.lis";

open OBJTOR,"<$objtorF" || die "$0-e: can't open $objtorF:\n";

# create list of creation subroutine @SubCreatL
while(<OBJTOR>){
	($o,$r)= split ' ',$_;
	$ObjToRouH{$o}=$r;
	push @SubCreatL, $r
}

close OBJTOR ;

# &prt_hash ("ObjToRouH", %ObjToRouH);
# &prt_list ("SubCreatL", @SubCreatL);

# scan fortran file
foreach $codeF (@ARGV){

  $inside = 0;
	open(INP, "<$codeF");

	while(<INP>){
		if(/^\s*end\s*subroutine/){ # end of routine line
      $inside = 0;
			$subname ="";
		}
# get subroutine name
		elsif(($s)=($_ =~ /^\s*subroutine\s*(\S+)\s*(\()?/)){ # top of routine
      $inside = 1;
			$subname=$s ;
			 print "file  $codeF routine $s\n";
		}
		elsif(($o,$d)=($_ =~ /^!\s+Needs\s+:\s+(\S+)\s+\((.*)\)/)){

			if($inside){
			$d =~ s/ //g;
			$r=$ObjToRouH{$o};
			#print "r $r\n";

			if($r ne ""){

				# @dimL= split ',',$d;
				@dimL = grep /[a-z]+/,(split ',',$d);

				foreach $d (@dimL){
					if(!(exists $DimensH{$d})){
					print "$0-e: file $codeF routine $subname\n";
					die "dimension item '$d' undefined\n";
        	}
        }

			 	#print "\n";
			 	#print "o $o\n";
			 	#print "d $d\n";
				#print "dimL:\n",join("\n",@dimL),"\n";

# create file notass_object.inc
      $notassF="notass_$o.inc";
			print "  include '$notassF'\n";
			open NOTASS,">$notassF";
				print NOTASS "  if( index (obsolete_list, '$r') .ne. 0 &\n";
				print NOTASS "   .or. .not.associated($o)) then\n";
				print NOTASS "    if(trace_depend) then\n";
        print NOTASS "      print *,trim(l_here),': $o not associated'\n";
				print NOTASS "      print *,trim(l_here),': calling $r'\n";
				print NOTASS "    end if\n";
				print NOTASS "    call $r\n";
				print NOTASS "  else \n";
				print NOTASS "    if(trace_depend) print *,trim(l_here),': $o already associated'\n";
				print NOTASS "  end if\n";
      close NOTASS;

      $chksizF="chksiz_$o.inc";
      print "  include '$chksizF'\n";
      open CHKSIZ,">$chksizF";
      $n=0;
      foreach $d (@dimL){
				$n++;
				print CHKSIZ "  call check_ubound (l_here,'$RefDimensH{$d}', $RefDimensH{$d}, &\n";
				print CHKSIZ "  '$o', ubound ($o, $n), $n)\n\n";
      }

      $dimensF="dimens_$o.inc";
			print "  include '$dimensF'\n";
			open DIMENS,">$dimensF";
			print DIMENS "! dimensions:\n\n";
			$n=0;
 			foreach $d (@dimL){
				$d =~ s/ //g;
				$n++;
				print DIMENS "  $DimensH{$d} = size ($o, $n)\n";
			}
			print DIMENS "\n  if(debug) then\n";

      foreach $d (@dimL){
        $d =~ s/ //g;
   			print DIMENS "   print *,trim(l_here),'-d: $DimensH{$d} =',$DimensH{$d}\n";
       }
			print DIMENS "  end if \n\n";
			print DIMENS "! end dimensions\n";
      close DIMENS;
		}
		else{
			print "$0: Object $o has no creation routine.\n";
			print "$0: Check file $objtorF or Run\n";
			die   "$0: perl BuildRoutNamesFromCreatesAndNeeds.pl $codeF\n";
		} # no routine
	} # inside
	} # Needs
	} # file  
   close INP;
}

sub prt_hash {
   local($String,%Array) = @_;
   $n=keys(%Array);
   print "prt_hash: error no elements Hash $String\n" if $n == 0;
   print " Hash $String:\n";
   foreach $elem (sort keys(%Array)) {
      print " " x (39 - length($elem));
      print '"',$elem,'"', "  ",$Array{$elem}, "\n";
   }
} # end
1;

sub prt_list {
   local($String,@Array) = @_;
   local($name);
   $n=$#Array;
 	print "prt_list: error no elements in List $String\n" if $n == -1;
   print " List $String:\n";
   foreach $name (@Array) {
      print " " x 10;
      print '"',$name,'"',"\n";
   }
} # end
1;

