# builds objects_names.lis file from Creates and Needs (printing objects)
# should be copied to objects_names.inc to be used by the program

# builds objects_names_bld.lis file from Creates and Needs (printing objects)
# should be copied to objects_names_bld.inc to be used by the program

die "Usage:\n perl $0 *.f90\n" if $#ARGV < 0 ;

$objectF="objects_names.lis";
$objectG="objects_names.inc";
$objectB="objects_names_bld.lis";
$objectC="objects_names_bld.inc";
$objectD="objects_address_bld.lis";
$objectE="objects_address_bld.inc";

if ( -s $objectF){
	open object,"<$objectF";
	$Tout=join('',<object>);
	@ObjectL=split(/\n/,$Tout);
	close object;
}

$n =$#ObjectL+1;
print "$n objects read \n";
# scan fortran file
foreach $codeF (@ARGV){

	open(F90, "<$codeF");

	while(<F90>){
		if(/^\s*end\s*subroutine/){ # end of objecte line
		}
# get subroutine name
		elsif(($s)=($_ =~ /^\s*subroutine\s*(\S+)\s*\(?/)){ # top of objecte
			$subname=$s ;
		}
    elsif(($o)=($_ =~ /^!\s+Creates\s+:\s+(\S+)\s*/)){

			unless (grep /^$o/,@ObjectL){
			print "new object $o from creating routine $subname file $codeF\n";
			push (@ObjectL,$o);
			}

    }
		elsif(($o)=($_ =~ /^!\s*Needs\s*:\s*(\S+)\s*/)){

			unless (grep /^$o/,@ObjectL){
			print "new object $o from needing routine $subname file $codeF\n";
			push (@ObjectL,$o);
			}

		}
	}
	close F90;
}

open object,">$objectF";
print object join("\n",@ObjectL),"\n";
close object;

open BLD,">$objectB";

$n =$#ObjectL+1;
print BLD   "  objects_nb = $n\n";
print BLD   "! allocations:\n";
print BLD   "\n";
print BLD   "  if(.not.associated(objects_names)) then\n";
print BLD   "    if(trace_depend) &\n";
print BLD   "      print *,trim(l_here),': objects_names not yet associated'\n";
print BLD   "      call allocation ('objects_names', &\n";
print BLD   "                        objects_names,  &\n";
print BLD   "                        objects_nb)\n";
print BLD   "  else\n";
print BLD   "    if(trace_depend) &\n";
print BLD   "     print *,trim(l_here),': objects_names left in memory'\n";
print BLD   "  end if\n";
print BLD   "\n";
print BLD   "! end allocations\n";
print BLD   "\n";
print BLD   "  system%objects_nb = objects_nb\n";
print BLD   "  print *,trim(l_here),': ',objects_nb,' objects names'\n";

$n=0;
foreach $r (sort @ObjectL){
	$n++;
	print BLD "  objects_names (",$n,") = '$r'\n";
}

close BLD;

open BLD,">$objectD";
foreach $r (sort @ObjectL){
    print BLD "  obj_i = string_in_array_locate ('$r', objects_names, 1 , objects_nb)\n";
    print BLD "  objects_address (obj_i) = address ($r)\n";
}

close BLD;

print "cp $objectF $objectG\n";
print "cp $objectB $objectC\n";
print "cp $objectD $objectE\n";
