# builds object-built-by-routine.lis files from Creates
# should be copied to object-built-by-routine.inc to be used by the program

# builds objects_crearout_bld.lis files from Creates
# should be copied to objects_crearout_bld.inc to be used by the program

die "Usage:\n perl $0 *.f90\n" if $#ARGV < 0 ;

$objtorF="object-built-by-routine.lis";
$objtorG="object-built-by-routine.inc";
$objtorB="objects_crearout_bld.lis";
$objtorC="objects_crearout_bld.inc";

$nbobj=0;
if ( -s $objtorF ){
	open OBJTOR,"<$objtorF";
	while(<OBJTOR>){
		($o,$r)= split ;
		$ObjToRouH{$o}=$r;
		$nbobj++;
	}
	close OBJTOR;
}

print "nb of Objects read =$nbobj\n";

# scan fortran file
foreach $codeF (@ARGV){

	open(INP, "<$codeF");

	while(<INP>){
		if(/^\s*end\s*subroutine/){ # end of routine line
		}
# get subroutine name
		elsif(($s)=($_ =~ /^\s*subroutine\s*(\S+)\s*(\()?/)){ # top of routine
			$subname=$s ;
		}
		elsif(($o)=($_ =~ /^!\s*Creates\s*:\s*(\S+)\s*/)){

			if( $subname ne ""){
				$ObjToRouH{$o}=$subname;
			#	print "in $codeF $o created by $subname\n";
			}
		}
	}
	close INP;
}

open OBJTOR,">$objtorF";
$nbobj=0;
foreach $o (sort keys %ObjToRouH){
		$nbobj++;
		print OBJTOR "$o $ObjToRouH{$o}\n";
}
close OBJTOR;
print "nb of Objects written =$nbobj\n";

open OBJTOR,">$objtorB";
foreach $o (sort keys %ObjToRouH){
		$r = $ObjToRouH{$o};
		print OBJTOR "  obj_i = string_in_array_locate ('$o', objects_names, 1 , objects_nb)\n";
		print OBJTOR "  rtn_i = string_in_array_locate ('$r', routines_names, 1 , routines_nb)\n";
		print OBJTOR "  objects_crearout (obj_i) = rtn_i\n";
}
close OBJTOR;

print "cp $objtorF $objtorG\n";
print "cp $objtorB $objtorC\n";

