# builds routines_catalog_init.lis file from Creates and Needs 
# should be copied to routines_catalog_init.inc to be used by the program

die "Usage:\n perl $0 *.f90\n" if $#ARGV < 0 ;

$routinN="routines_creat_need_names.lis";
$routinO="routines_creat_need_names.inc";
$routinC="routines_catalog_init.lis";
$routinD="routines_catalog_init.inc";

if ( -s $routinN){
	open FIL,"<$routinN";
	$Tout=join('',<FIL>);
	@RoutinL=split(/\n/,$Tout);
	close FIL;
}

$n =$#RoutinL+1;
print "$n routines read \n";
# scan fortran file
foreach $codeF (@ARGV){

  print "file $codeF\n";

# check for Creates or Needs files

	open(F90, "<$codeF");
  @f90L =(<F90>);
  close F90;

  $creatorneed = grep /^!\s*Creates|^!\s*Needs/,@f90L;

  if (!$creatorneed ) {
    print "file $codeF has no Creates or Needs \n" unless $creatorneed;
    print "file $codeF skipped\n";
    next;
  };

	open(F90, "<$codeF");

  $subname="";
	$module="";

	while(<F90>){
		if(($m)=($_ =~ /^\s*module\s*(\S+)\s*$/)){ 
			$module=$m;
			print "file $codeF module $module\n";
      push (@ModuleL,$module);
		}
		elsif(/^\s*end\s*module/){ # end of module line
			$module="";
		}
		elsif(/^\s*end\s*subroutine/){ # end of routinD line
			$subname="";
		}
# get subroutine name
		elsif(($s)=($_ =~ /^\s*subroutine\s*(\S+)\s*\(?/)){ # top of routinD
			$subname=$s ;
		}
    elsif(($o)=($_ =~ /^!\s+Creates\s+:\s+(\S+)\s*/)){

# store routinD name in @RoutinL

      unless ((grep /^$subname$/,@RoutinL) || $subname eq ""){
      	print "new subroutine >$subname<\n" ;
      	print "creates object $o in file $codeF\n" ;
      	push (@RoutinL,$subname);
			}

    }
		elsif(($o)=($_ =~ /^!\s*Needs\s*:\s*(\S+)\s*/)){

      unless ((grep /^$subname$/,@RoutinL) || $subname eq ""){
      	print "new subroutine >$subname<\n" ;
      	print "needs object $o in file $codeF\n" ;
      	push (@RoutinL,$subname);
			}

		}
	}
	close F90;
}

# save routines' list
open FIL,">$routinN";
print FIL join("\n",@RoutinL),"\n";
close FIL;

# list of routines to be excluded
@excludedL =();
push @excludedL,'objects_address_bld' ;
push @excludedL,'routines_address_bld' ;
push @excludedL,'routines_address_init' ;
push @excludedL,'routines_names_bld' ;
push @excludedL,'routines_names_print' ;

open FIL,">$routinC";

foreach $r (sort @RoutinL){
	if (!(grep /$r/,@excludedL)){
  	print FIL "  call one_routine_catalog ('$r', $r)\n";
	}
}

close FIL;

print "cp $routinN $routinO\n";
print "cp $routinC $routinD\n";
