# builds routines_names.lis file from Creates and Needs 
# should be copied to routines_names.inc to be used by the program

# builds routines_names_bld.lis file from Creates and Needs 
# should be copied to routines_names_bld.inc to be used by the program

# builds routines_address_init.lis file from Creates and Needs 
# should be copied to routines_address_init.inc to be used by the program

die "Usage:\n perl $0 *.f90\n" if $#ARGV < 0 ;

$routinF="routines_names.lis";
$routinG="routines_names.inc";
$routinB="routines_names_bld.lis";
$routinC="routines_names_bld.inc";
$routinD="routines_address_init.lis";
$routinE="routines_address_init.inc";
$routinX="routines_external.lis";
$routinY="routines_external.inc";
$moduleU="modules_uses.lis";
$moduleV="modules_uses.inc";

if ( -s $routinF){
	open ROUTIN,"<$routinF";
	$Tout=join('',<ROUTIN>);
	@RoutinL=split(/\n/,$Tout);
	close ROUTIN;
}

$n =$#RoutinL+1;
print "$n routines read \n";
# scan fortran file
foreach $codeF (@ARGV){

	open(F90, "<$codeF");

  $subname="";
	$module="";

	while(<F90>){
		if(($m)=($_ =~ /^\s*module\s*(\S+)\s*$/)){ 
			$module=$m;
			print "module $module\n";
      push (@ModuleL,$module);
		}
		elsif(/^\s*end\s*module/){ # end of module line
			$module="";
		}
		elsif(/^\s*end\s*subroutine/){ # end of routine line
			$subname="";
		}
# get subroutine name
		elsif(($s)=($_ =~ /^\s*subroutine\s*(\S+)\s*\(?/)){ # top of routine
			$subname=$s ;
		}
    elsif(($o)=($_ =~ /^!\s+Creates\s+:\s+(\S+)\s*/)){

# store routine name in @RoutinL

      unless ((grep /^$subname$/,@RoutinL) || $subname eq ""){
      	print "new subroutine >$subname<\n" ;
      	print "creates object $o in file $codeF\n" ;
      	push (@RoutinL,$subname);
			}

    }
		elsif(($o)=($_ =~ /^!\s*Needs\s*:\s*(\S+)\s*/)){

      unless ((grep /^$subname$/,@RoutinL) || $subname eq ""){
      	print "new subroutine >$subname<\n" ;
      	print "needs object $o in file $codeF\n" ;
      	push (@RoutinL,$subname);
			}

		}
	}
	close F90;
}

open ROUTIN,">$routinF";
print ROUTIN join("\n",@RoutinL),"\n";
close ROUTIN;

open BLD,">$routinB";

$n =$#RoutinL+1;
print BLD   "  routines_nb = $n\n";
print BLD   "! allocations:\n";
print BLD   "\n";
print BLD   "  if(.not.associated(routines_names)) then\n";
print BLD   "    if(trace_depend) &\n";
print BLD   "      print *,trim(l_here),': routines_names not yet associated'\n";
print BLD   "      call allocation ('routines_names', &\n";
print BLD   "                        routines_names,  &\n";
print BLD   "                        routines_nb)\n";
print BLD   "  else\n";
print BLD   "    if(trace_depend) &\n";
print BLD   "     print *,trim(l_here),': routines_names left in memory'\n";
print BLD   "  end if\n";
print BLD   "\n";
print BLD   "! end allocations\n";
print BLD   "\n";
print BLD   "  system%routines_nb = routines_nb\n";
print BLD   "  print *,trim(l_here),': ',routines_nb,' routines names'\n";

$n=0;
foreach $r (sort @RoutinL){
	$n++;
	print BLD "  routines_names (",$n,") = '$r'\n";
}

close BLD;

# list of routines to be excluded
push @excludedL,'objects_address_bld' ;
push @excludedL,'routines_address_bld' ;
push @excludedL,'routines_address_init' ;
push @excludedL,'routines_names_bld' ;
push @excludedL,'routines_names_print' ;

open BLD,">$routinD";
foreach $r (sort @RoutinL){
	if (!(grep /$r/,@excludedL)){
  	print BLD "  rtn_i = string_in_array_locate ('$r', routines_names, 1 , routines_nb)\n";
		print BLD "  routines_address (rtn_i) = address ($r)\n";
	}
}

close BLD;

open BLD,">$moduleU";
foreach $m (sort @ModuleL){
		print BLD "  use $m\n";
}

close BLD;

open BLD,">$routinX";
foreach $r (sort @RoutinL){
	if (!(grep /$r/,@excludedL)){
		print BLD "  external $r\n";
	}
}

close BLD;

print "cp $routinF $routinG\n";
print "cp $moduleU $moduleV\n";
print "cp $routinX $routinY\n";
print "cp $routinB $routinC\n";
print "cp $routinD $routinE\n";
