#!/usr/local/bin/perl -w

# Conversion des simple precision en double precision
# Jean-Marie Teuler (teuler@idris.fr), 9 decembre 1996

# Il y a trois formes de reels. On va les definir

$double{'e'} = 'd' ;
$double{'E'} = 'D' ;

$signe_optionnel = '[+-]?' ;
$entier = '\\d+' ;
$entier_optionnel = '\\d*' ;
$point = '\\.' ;
$symbole = '[eE]' ;
$exposant = $symbole . $signe_optionnel . $entier ;
$exposant_optionnel = '(' .$symbole . $signe_optionnel . $entier . ')?' ;
$debut = '(^|\\W)' ;
$fin = '($|(?=\\W))' ;

$forme1 = $debut . $entier . $exposant . $fin ;
$forme2 = 
  $debut . $entier . $point . $entier_optionnel . $exposant_optionnel . $fin ;
$forme3 = $debut . $point . $entier . $exposant_optionnel . $fin ;

# On parcourt le fichier a traiter

while ( <> ) {

  $reponse = '' ;

  while (/$forme1/o) {
    $match = $& ; $avant = $` ; $apres = $' ;
    # On convertit les "e" en "d"
    $match =~ s/[eE]/$double{$&}/ ; 
    $reponse .= $avant . $match ;
    $_ = $apres ;
  }

  while (/$forme2/o) {
    $match = $& ; $avant = $` ; $apres = $' ; $exp = $2 ;
    # S'il y a une partie exposant
    if ($exp) {
    # On convertit les "e" en "d"
      $match =~ s/[eE]/$double{$&}/ ;
      $reponse .= $avant . $match ;
      $_ = $apres ;
    }
    # Sinon, on la rajoute
    else {
      $reponse .= $avant . $match . 'd0' ;
      $_ = $apres ;
    }
  }

  while (/$forme3/o) {
    $match = $& ; $avant = $` ; $apres = $' ; $exp = $2 ;
    if ($exp) {
    # S'il y a une partie exposant
      $match =~ s/[eE]/$double{$&}/ ;
      $reponse .= $avant . $match ;
      $_ = $apres ;
    }
    # Sinon, on la rajoute
    else {
      $reponse .= $avant . $match . 'd0' ;
      $_ = $apres ;
    }
  }

  print "$reponse$_" ;

}


