die "Usage:\n perl $0 *.f90" if $#ARGV < 0 ;

$debug = 0;

# read object to routine file:
$objF="objects-to-routines.lis";

open OBJ,"<$objF";

# create list of creation subroutine 
while(<OBJ>){
	($o,$r)= split ' ',$_;
	$ObjToRouH{$o}=$r;
	push @SubCreatL, $r
}

close OBJ ;

&prt_hash ("ObjToRouH", %ObjToRouH) if $debug ;
&prt_list ("SubCreatL", @SubCreatL) if $debug ;

# scan fortran file
foreach $f90file (@ARGV){
	$savfil = $f90file.".sav";
	rename $f90file, $savfil;

	print " diff $savfil $f90file\n";

	open(INP, "<$savfil");
	open(OUT, ">$f90file");

	while(<INP>){

		if (/^!\s*requirements/){
				$requirements_exits = 1;
				$inside_requirements = 1;
				print "requirements found in $subname\n" if $debug ;

			if($skipping_exits == 0){
				print OUT "  include 'skipping.inc'\n";
				print OUT "\n";
			}
		}
		elsif(/^!\s*end\s*requirements/ || /^!\s*allocations:/){

# end requirements or allocations

				$inside_requirements = 0;
      	print "end of requirements in current routine $subname\n" if $debug ;
		}
		elsif(/^\s+include\s*\'skipping.inc\'/){
# is include skipping already here?

			$skipping_exits = 1;
		}
		elsif(/^  integer\(i4b\)\, save \:\: iteration \= 0/){

# is iteration declaration already here?

			$iteration_declaration = 1;
		}
		elsif(/^\s*end\s*subroutine/){ # end of routine line

			if($curr_rout_in_list != 0){

			  if($requirements_exits == 0){
      	  print "no requirements label in current routine $subname\n";
      	  close OUT;
				  rename $savfil, $f90file;
				  last ;
				}
			}
			else{
      	  print "current routine $subname not in list\n";
			}
		}
		elsif(($s)=($_ =~ /^\s*subroutine\s*(\S+)\s*(\()?/)){ # top of routine
			$subname=$s ;
			$curr_rout_in_list = grep /\b$subname\b/,@SubCreatL ;
			$requirements_exits = 0;
			$skipping_exits     = 0;
			$inside_requirements = 0;
			$iteration_declaration = 0;
		}
      
# process if not already done

		if($curr_rout_in_list) { # this routine has to be in list

# add iteration declaration if necessary
			if (/^\s*!\s*begin\s*:/  && $iteration_declaration == 0 ){
				print OUT "  integer(i4b), save :: iteration = 0\n";
				print OUT "\n";
			}

      if($inside_requirements){

				if (/^\s+if\s*\(\.not\.associated\s*\(/){

					($o) = ($_ =~ /associated\s*\((\w+)\)/);
					$r = $ObjToRouH{$o};
			 		print " object '$o' is built by routine '$r'\n";

# check wether called routine in list ?
					if($r ne ""){
						$called_rout_is_in_list = grep /\b$r\b/,@SubCreatL; 
					}
					else {
			 			print " object $o has no building routine in file\n";
						$called_rout_is_in_list = 0;
					}
	
			#	print " obj  $o\n";
			#	print " rou  $r\n";
			#	print " called_rout_is_in_list  $called_rout_is_in_list\n";

# modify association test
					if($called_rout_is_in_list){
						$_  = "  if( index (obsolete_list, '$r') .ne. 0 &\n";
						$_ .= "     .or. .not.associated($o)) then\n";
			 			print " object '$o' obsoletized calling routine '$r'\n";
					}
					else{
			 			print " object '$o' NOT obsoletized calling routine '$r' not in list\n";
					}

				}
			} # $inside_requirements

		} # found routine in list
		else {
#			print " routine $subname not in list \n";
		}

		print OUT ;
	}
   close INP;
   close OUT;
}

sub prt_hash {
   local($String,%Array) = @_;
   $n=keys(%Array);
   print "prt_hash: error no elements Hash $String\n" if $n == 0;
   print " Hash $String:\n";
   foreach $elem (sort keys(%Array)) {
      print " " x (39 - length($elem));
      print '"',$elem,'"', "  ",$Array{$elem}, "\n";
   }
} # end
1;

sub prt_list {
   local($String,@Array) = @_;
   local($name);
   $n=$#Array;
 	print "prt_list: error no elements in List $String\n" if $n == -1;
   print " List $String:\n";
   foreach $name (@Array) {
      print " " x 10;
      print '"',$name,'"',"\n";
   }
} # end
1;

