die "Usage:\n perl $0 *.f90" if $#ARGV < 0 ;

# scan fortran file
foreach $f90file (@ARGV){

	print "file $f90file \n";

	open(INP, "<$f90file");

	while(<INP>){

		if(($s)=($_ =~ /^\s*subroutine\s*(\S+)\s*(\()?/)){ # top of routine
			$subname=$s ;
			$iteration_declaration = 0;
			$skipping_exits = 0;
			$requirements_exits = 0;
		}
		elsif(/^  integer\(i4b\)\, save \:\: iteration \= 0/){
			$iteration_declaration = 1;
		}
		elsif (/^!\s*requirements/){
				$requirements_exits = 1;
		}
		elsif(/^\s+include\s*\'skipping.inc\'/){
			$skipping_exits = 1;
		}
		elsif(/^\s*end\s*subroutine/){ # end of routine line
			print "requirements NOT found in $subname\n" unless $requirements_exits;
			print "iteration    NOT found in $subname\n" unless $iteration_declaration;
			print "skipping     NOT found in $subname\n" unless $skipping_exits;
	    print "file $f90file subroutine  $subname is ok \n" if $requirements_exits && $iteration_declaration && $skipping_exits ;
		}
      
}
   close INP;
}
