die "Usage:\n perl $0 1 2 3 max-nb-of-dim" if $#ARGV < 0 ;

@dimL=('dim_1','dim_2','dim_3','dim_4','dim_5','dim_6');
$arglist=join(', ',@dimL);
$argS=":,:,:,:,:,:,:,:";
foreach $n (@ARGV){
$argdim = substr $arglist,0,7*$n-2;
$argn= substr $argS,0,2*$n-1;
print "! =====================================================================\n";
print "  subroutine allocation_inte_${n} (name, object, $argdim)\n";
print "! ---------------------------------------------------------------------\n";
print "!\n";
print "! Name           : allocation_inte_${n}\n";
print "!\n";
print "! Argument (in ) : name\n";
print "! Argument (in ) : object\n";
for $i (1..$n){
print "! Argument (in ) : dim_${i}\n";
}
print "!\n";
print "! Description    : allocate integer object of dimension ${n} \n";
print "! Desctiption    : and catalog it using fictituous 'inte_${n}' type\n";
print "! Desctiption    : object must not be associated\n";
print "!\n";
print "! Authors: R. Assaraf\n";
print "! Date   : 17 May 2002\n";
print "! ----------------------------------------------------------------------\n";
print "  implicit none\n";
print "\n";
print "! i/o:\n";
print "  character(len=*)       :: name\n";
print "  integer(i4b), pointer  :: object($argn)\n";
print "  integer(i4b)           :: $argdim\n";
print "\n";
print "! local:\n";
print "  character(len=max_string_len_routine_name)  :: l_here \n";
print "  integer(i4b)       :: index\n";
print "  integer(i4b), save :: cur_type = NOT_INIT_I \n";
print "\n";
print "! begin:\n";
print "  l_here='allocation_inte_${n}'\n";
print "\n";
print "  if (header_exe) then\n";
print "    call string_in_list_add_once &\n";
print "              ('inte_${n}', fortran_types, max_string_len_fort_type)\n";
print "    cur_type = string_in_array_locate_or_die ('inte_${n}', fortran_types)\n";
print "    return\n";
print "  end if\n";
print "\n";
print "  call enter (l_here)\n";
print "\n";
print "  if (associated(object)) then\n";
print "    message='object '*name*' should not be associated'\n";
print "    call die (message,l_here)\n";
print "  endif\n";
print "\n";
print "  index = string_in_array_locate_or_die (name, objects_name)\n";
print "\n";
print "  allocate (inte_${n}_alias)\n";
print "  allocate (inte_${n}_alias%p (${argdim})) \n";
print "\n";
print "  object => inte_${n}_alias%p\n";
print "       \n";
print "  objects_addr(index) = address (inte_${n}_alias)\n";
print "  objects_type(index) = cur_type\n";
print "\n";
print "  nullify (inte_${n}_alias)\n";
print "\n";
print "  call exit (l_here)\n";
print "\n";
print "  end subroutine allocation_inte_${n}\n";
print "\n";
}
