# builds  header

die "Usage:\n perl $0 *.f90\n" if $#ARGV < 0 ;

# scan fortran file
foreach $codeF (@ARGV){

# check for Creates or Needs and skip some files

	open(F90, "<$codeF");
	@f90L =(<F90>);
  close F90;
 
  $module = grep /^\s*module\s+\S+/,@f90L;
  $skipmodule = grep /^\s*module\s+dependences_mod|^\s*module\s+objects_old_mod/,@f90L;

	if ($skipmodule || !$module ) {
		print "file $codeF has no module\n" unless $module;
		print "file $codeF skipped\n";
    last;
	};

  $insertuse = grep /^!\s*Creates|^!\s*Needs/,@f90L;

	$saveF=$codeF.".sav";
	print " transforms $codeF\n";
	print " saved in   $saveF\n";
	print " diff $saveF $codeF \n";

	rename $codeF, $saveF;
	open(F90, "<$saveF");
	open(OUT, ">$codeF");

	$inside =0;
	$skip   =0;
	$create =0;
	$needed =0;

	while(<F90>){
		if(/^\s*use\s+\S+/){ 
			print OUT "  use objects_mod\n" if ($insertuse) ;
			$insertuse = 0;
			print OUT ;
		}
		elsif(/^\s*end\s*subroutine/){ # end of subroutine line
			$inside =0;
			$create =0;
			$needed =0;
			$skip   =0;
			@ObjectCreateL=();
			@ObjectNeededL=();

			print OUT ;
		}
# get subroutine name
		elsif(($s)=($_ =~ /^\s*subroutine\s*(\S+)\s*\(?/)){ # top subroutine
			$subname=$s ;
			$inside =1;
			print OUT ;
		}
    elsif(($o)=($_ =~ /^!\s+Creates\s+:\s+(\S+)\s*/)){
			$create = 1;
			if($inside){
				print "created object $o from routine $subname file $codeF\n";
				push (@ObjectCreateL,$o);
			}
			print OUT ;

    }
		elsif(($o)=($_ =~ /^!\s*Needs\s*:\s*(\S+)\s*/)){

			$needed = 1;
			if($inside){
				print "needed object $o from routine $subname file $codeF\n";
				push (@ObjectNeededL,$o);
			}
			print OUT ;

		}
		elsif($_ =~ /^\s+character.*\s*\,save\s*::\s*l_here/){
			$skip = 1;
			print OUT ;
		}
		elsif($_ =~ /^\s+character.*\s*::\s*l_here/){
			if($inside && ($create || $needed)) {
print "subname $subname\n";
print "inside $inside\n";
print "create $create\n";
print "needed $needed\n";
				s/\)/\),save/;
			}
				print OUT 
		}
		elsif($_ =~ /^\s+integer.*\s*::\s*iteration/){
			print OUT ;
			if( !$skip && $inside && ($create || $needed) ){
			}
		}
		elsif($_ =~ /^\s*l_here\s*\=\s*\'/){
			if( ! ($create || $needed) ){ print OUT }
		} # skipped
		elsif($_ =~ /^\s*l_here\s*\=\s*\"/){
			if( ! ($create || $needed) ){ print OUT }
		} # skipped
		elsif($_ =~ /^!\s*begin\s*:/){
			
			if( !$skip && $inside && ($create || $needed) ){
			  print OUT "  integer\(i4b\), save :: routine_index\n\n";
				print OUT "! header:\n\n";
      	print OUT "  if \(header_exe\) then\n\n";
      	print OUT "    l_here = routine_cur_name \(\)\n\n";
      	print OUT "    routine_index = routine_cur_index \(\)\n\n";

				foreach $o (@ObjectCreateL){
     			print OUT "    call object_create ('$o')\n";
				}

      	print OUT "\n" if $#ObjectCreateL > -1 ;

				foreach $o (@ObjectNeededL){
      		print OUT "    call object_needed ('$o')\n";
				}

      	print OUT "\n" if $#ObjectNeededL > -1 ;

      	print OUT "    return\n\n";
      	print OUT "  end if\n\n";

			}

      print OUT "! begin:\n\n";

		} # above begin 
		else{
      print OUT $_;
		}
	}
	close F90;
}
