#!/usr/bin/perl -w
foreach $n (@ARGV){
print "! =========================================================================\n";
print "  subroutine real_${n}_type_write (real_${n}_type_obj, unit)\n";
print "! -------------------------------------------------------------------------\n";
print "!\n";
print "! Name           : real_${n}_type_write\n";
print "!\n";
print "! Argument (in ) : real_${n}_type_obj\n";
print "! Argument (in ) : unit\n";
print "!\n";
print "! Description    : writes an object of type 'real_${n}_type' on unit 'unit'\n";
print "! Description    : with a text\n";
print "!\n";
print "! Authors: R. Assaraf\n";
print "! Date   : 17 July 2002\n";
print "! -------------------------------------------------------------------------\n";
print "  implicit none\n";
print "\n";
print "! i/o:\n";
print "  type(real_${n}_type) :: real_${n}_type_obj \n";
print "  integer (i4b)     :: unit\n";
print " \n";
print "! local:\n";
print "  character (len=max_string_len_routine_name) :: l_here \n";
print "  integer (i4b)     :: cur_type \n";

if ($n > 0){
	print "  integer (i4b)     :: ";
	foreach $j (1..$n-1){
		print "dim_$j, ";
	}
	print "dim_$n\n";
}

print "\n";
print "! header:\n";
print "  if (header_exe) then\n";
print "\n";
print "    l_here = routine_cur_name ()\n";
print "\n";
print "    cur_type = string_in_array_locate_or_die ('real_${n}', types_name)\n";
print "\n";
print "    types_write (cur_type) = routine_cur_index ()\n";
print "\n";
print "    return\n";
print "\n";
print "  endif\n";
print "\n";
print "! begin:\n";
print "  call enter(l_here)\n";
print "\n";
print "  if (.not.associated(real_${n}_type_obj%p)) then\n";
print "    print *, trim(text_print), 'not associated'\n";
print "  endif\n";
print "\n";

foreach $j (1..$n){
		$i = 1 + $n - $j;
		print "  do dim_$i = lbound(real_${n}_type_obj%p,dim=$i),";
		print " ubound(real_${n}_type_obj%p,dim=$i)\n";
}

if ($n == 0){
		print "  message = text_print\n";
		print "  write (unit, '(1x,2a,g25.15)') trim(message),' = ',real_${n}_type_obj%p\n";
}
else{
	print "\n";
	print "    message = text_print+'('";
	foreach $j (1..$n-1){
			print "+dim_$j+','";
	}
	print "+dim_$n+')'\n";

	print "    write (unit, '(1x,2a,g25.15)') trim(message),' = ', &\n";
	print "           real_${n}_type_obj%p(";

	foreach $j (1..$n-1){
		print "dim_$j, ";
	}

	print "dim_$n)\n\n";
	foreach $i (1..$n){
		print "  end do ! dim_$i\n";
	}
}

print "\n";
print "  call exit(l_here)\n";
print "\n";
print "  end subroutine real_${n}_type_write\n";
print "\n";
}
