die "Usage:\n perl $0 output" if $#ARGV < 0 ;

# gather dependencies from output
$routorF="routine-calls-routine.dat";
$objtorF="object-built-by-routine.dat";
$obsoletesF="routines-obsoletes.dat";
$objectsF="objects.dat";
$routinesF="routines.dat";

open ROUTOR,">$routorF";
open OBJTOR,">$objtorF";
open OBSOLETES,">$obsoletesF";
open OBJECTS,">$objectsF";
open ROUTINES,">$routinesF";

print "$routorF\n";
print "$objtorF\n";
print "$obsoletesF\n";
print "$objectsF\n";
print "$routinesF\n";

while(<>){

# parse the two consecutive lines emitted from "notass" includes
# routine_name: needed_object_name not associated
# routine_name: calling building_routine

	if ( ($r, $o) = ($_ =~ /^\s*(\w+):\s+(\w+)\s+not associated/)){

		$obj=$o;
		$rou=$r;
		# print "routine $r\n";
		# print "needed object $obj\n";
	}
	if ( ($r_1, $r_2) = ($_ =~ /^\s*(\w+):\s+calling\s+(\w+)/)){

		# print "routine $r_1 calls building routine $r_2\n";
		# save on "routine-calls-routine.dat"
		if ($rou ne $r_1){ print "error: routine $r_1 should be $rou\n"}

		printf ROUTOR ("%s     %s\n",$r_1,$r_2);

		# save in Hash $Object_built_byH{$obj} = $r_2

		$Object_built_byH{$obj} = $r_2;
	}
}

close ROUTOR;

foreach $obj (sort keys %Object_built_byH){

	#	print "object $obj built by $Object_built_byH{$obj}\n";
	# save on "object-built-by-routine.dat";

	print OBJTOR "$obj      $Object_built_byH{$obj}\n";
}
close OBJTOR;

# save all objects on "objects.dat";
foreach $obj (sort keys %Object_built_byH){
	$rou = $Object_built_byH{$obj};
	push @RoutinesL, $rou unless grep /$rou/,@RoutinesL;
	print OBJECTS "    $obj\n";
}
close OBJECTS;

# save obsoletes routines on "routines-obsoletes.dat"
print OBSOLETES "   obsolete_list = &\n";
foreach $rou (sort @RoutinesL){
	print OBSOLETES "    '$rou'// &\n" unless $rou =~ /init$|read$/ ;
}
print OBSOLETES "    ' ' \n";
close OBSOLETES;

# save routines on "routines.dat";
print ROUTINES "    '\@SubList=('\n";
foreach $rou (sort @RoutinesL){
	print ROUTINES "    '$rou',\n";
}
print ROUTINES "    'x') \n";
close ROUTINES;

