#!/usr/bin/perl
$firstpage=shift(@ARGV);
@src_files=@ARGV;

# building %file_mod : module  -> file
# building %file_rtn : routine -> file
# building %rtn_obj  : object  -> routine

foreach $src_file (@src_files){open SRC, "<$src_file";
   foreach (<SRC>) {
       if (/^\s*module/)              {($mod) = ($_=~/module\s*(\S*)/);                  $file_mod{$mod} = $src_file}
       if (/^\s*subroutine/)          {($rtn) = ($_=~/subroutine\s*([^\s|\(]*)/);              $file_rtn{$rtn} = $src_file}
       if (/^\s*call\s*object_create/){($obj) = ($_=~/object_create\s*\(\s*\'(\S*)\'/);  $rtn_obj{$obj}  = $rtn}
   }
			       close SRC}

# building %file_obj   : obj -> file
# building %anchor_rtn : rtn -> anchor
# building %anchor_mod : mod -> anchor
# building %ref_rtn    : rtn  -> ref
# building  %ref_obj   : obj  -> ref
# building  %ref_mod   : mod  -> ref
%file_obj = &hash_compose ( file_rtn,rtn_obj);
foreach $key (keys %file_rtn) {$anchor_rtn{$key} = $key};
foreach $key (keys %file_mod) {$anchor_mod{$key} = $key};
foreach $key (keys %file_rtn) {$ref_rtn{$key}  =  $file_rtn{$key}.".html#".$anchor_rtn{$key}};
%ref_obj = &hash_compose (ref_rtn,rtn_obj);
foreach $key (keys %file_mod) {$ref_mod{$key} = $file_mod{$key}.".html#".$anchor_mod{$key}};


# building %ref_rtn_menu : rtn (.._menu) -> ref
# building %ref_rtn_bld  : rtn (.._bld)  -> ref
# building %ref_rtn_calc : rtn (.._calc) -> ref
# building %ref_rtn_lib  : rtn (other)   -> ref

foreach $rtn (sort keys %file_rtn) { if    ($rtn =~ /.*_menu\b/) {$ref_rtn_menu{$rtn}=$ref_rtn{$rtn}}
                                     elsif ($rtn =~ /.*_bld\b/)  {$ref_rtn_bld{$rtn}=$ref_rtn{$rtn}}
                                     elsif ($rtn =~ /.*_calc\b/) {$ref_rtn_calc{$rtn}=$ref_rtn{$rtn}}
                                     else {$ref_rtn_lib{$rtn}=$ref_rtn{$rtn}}}

#write the files in a html form
foreach $src_file (@src_files){open SRC, "<$src_file"; open HTML, ">$src_file.html"; 
   &html_header_write(HTML, $src_file, "source_code");
   while (<SRC>) { 
   if (/^\s*subroutine/)          {($beg,$rtn,$end) = ($_=~/^(\s*subroutine\s*)(\S*)(\s*.*)/); $_= $beg.&anchor($anchor_rtn{$rtn}).$end}
   if (/^\s*module/)              {($beg,$mod,$end) = ($_=~/^(\s*module\s*)(\S*)(\s*.*)/)    ; $_= $beg.&anchor($anchor_mod{$mod}).$end}
   if (/^!.*/)                    {($beg,$cnt,$end) = ($_=~/(^[~!]*)(!)(.*)/);                 $_= "<FONT COLOR=#797d79>".$beg.$cnt.$end."</FONT>"}
   if (/^\s*call\s*object_needed/){($beg,$obj,$end) = ($_=~/^(.*?\')(\S*)(\'.*)/);    $ref=$ref_rtn{$rtn_obj{$obj}}; $_=$beg.&href($obj,$ref).$end}
   if (/^\s*use\s*/)              {($beg,$mod,$end) = ($_=~/^(\s*use\s*)(\S*)(\s*)/); $ref=$ref_mod{$mod};           $_=$beg.&href($mod,$ref).$end}
   if (/^\s*call\s*/)             {($beg,$rtn,$end) = ($_=~/^(\s*call\s*)(\w*)(.*)/); $ref=$ref_rtn{$rtn};           $_=$beg.&href($rtn,$ref).$end}  

   ($html = $_) =~  s/\s\s/&nbsp\;/og; 
    print HTML $html, '<BR>'}
    &html_tail_write(HTML);
    close SRC; close HTML 
   }

#index table
&index_write("source_index.html","source_index","$firstpage.html","source_code");
open HTML, ">source_index.html";

print HTML "<FONT  COLOR=#1930FF>";
&html_header_write(HTML,"<H2>Index</H2>","source_code");
print HTML "<H3> <LI TYPE=square> Objects </LI> </H3> ";
&html_list_write (HTML, ref_obj);
print HTML "<H3> <LI TYPE=square>  Routines </LI> </H3>";
print HTML "<UL>";
print HTML "<H4>  <LI TYPE=square>  Building routines </LI> </H4>";
&html_list_write (HTML, ref_rtn_bld);
print HTML "<H4>  <LI TYPE=square>  Menu routines </LI> </H4>";
&html_list_write (HTML, ref_rtn_menu);
print HTML "<H4>  <LI TYPE=square>  Operators routines </LI> </H4>";
&html_list_write (HTML, ref_rtn_calc);
print HTML "<H4>  <LI TYPE=square>  Library routines </LI> </H4>";
&html_list_write (HTML, ref_rtn_lib);
print HTML "</UL>";
print HTML "<H3> <LI TYPE=square>  Modules </LI> </H3>";
&html_list_write (HTML, ref_mod);
print HTML "</UL>";
&html_tail_write(HTML);
print HTML "<FONT>";
close(HTML);

# &html_header_write($file) writes the html header in the file $file
sub html_header_write {
    local($html)=shift(@_);
    local($title)=shift(@_);
    local($base_target)=shift(@_);
    print $html  '<html> ';
    print $html  '<head> ';
    print $html  '<meta http-equiv="Content-Type" contents="text/html"> ';
    print $html  "<H3> <title>$title</title></H3> ";
    print $html  "<BASE TARGET = $base_target>";
    print $html  '</head> ';
    print $html  '<body> ';
    print $html  '<BODY BGCOLOR = #f5f5f5>';
    print $html  '<BODY LINK    = #1930FF>';
    print $html  '<BODY ALINK   = #FF452B>';
    print $html  '<BODY VLINK   = #F847FF>';
    print $html  "<A NAME = toppage><CENTER><B>$title </B></CENTER></A>";
    }

# &html_tail_write($file) writes the html end in the file $file
sub html_tail_write{
local($file)=shift(@_);
print $file " <BR>";
print $file "<A HREF=#toppage><B>back to top</B></A>";
print $file '</body></html>';
}

sub anchor {
local($string)=@_[0];
$anchor="<A NAME=$string> $string </A>";
$anchor;
}

sub href {
local($string)=@_[0];
local($ref)=@_[1];
$href="<A HREF=$ref> $string </A>";
$href;
}

sub file_obj {
    local($obj);
    $obj=@_[0];
    $file= $file_rtn{$rtn_obj{$obj}};
    $file;
}

# &html_list_write ($file,$list)
sub html_list_write {
    local($file)=@_[0];
    local($list)=@_[1];
    print $file "<UL> \n";
     foreach $a (sort  keys %$list){ if ($a) {print $file "<LI TYPE=disc>".href($a,$$list{$a})."\n"}};
    print $file "</UL>";
  }

# &hash_compose (hahs1, hash2) est un hash hash1 (hash2)
sub hash_compose {
    local($hash1)=@_[0];
    local($hash2)=@_[1];
    local(%comp);
    foreach $a (sort keys %$hash2) {$comp{$a}=$$hash1{$$hash2{$a}}}
   
    %comp; 
}

# &index_write($src1,$nam1,$src2,$nam2) writes index.html with two frames
sub index_write{
    local($src1)=@_[0];
    local($nam1)=@_[1];
    local($src2)=@_[2];
    local($nam2)=@_[3];

    open html, ">index.html";
    print html "<HTML> \n";
    print html "<HEAD> \n";
    print html "<TITLE>Index</TITLE> \n";
    print html "<BASE TARGET=source_code>\n";
    print html "</HEAD> \n";
    print html "<FRAMESET COLS=\"30%,*\"> \n";
    print html "<FRAME SRC=$src1 NAME=$nam1> \n";
    print html "<FRAME SRC=$src2 NAME=$nam2> \n";
    print html "</FRAMESET> \n";
    print html "</HTML> \n";
    close html
}
