#!/usr/bin/perl
$rtn_name=shift (@ARGV);
$var_name=shift (@ARGV);
$file_name="other_types.inc";

@rtn_lines=&rtn_from_file ($file_name,$rtn_name);
print @rtn_lines;
print "type of $var_name=", &type ($object,@rtn_lines),"\n";
print "dimension  of $var_name=", &dimension    ($object,@rtn_lines),"\n";

print &modify_type ($object,"integer(i4b)","2",@rtn_lines);


# &modify_type ($object,$new_type,$new_dim,@rtn_lines) create the code for the qame routine as @rtn_lines but with the object $object with type $new_type and dimension $new_dim

sub modify_type {
local($object)    = shift(@_);
local($new_type)  = shift(@_);
local($new_dim)   = shift(@_);
local(@rtn)     =   @_;
local(@new_rtn) =   @_;

@new_rtn;
}

# &type ($object,@lines) fortran type object found in the lines @lines
sub type {
   local($object)=shift(@_);
   local(@lines)=@_;
   local($i)=&declaration ($object,@lines);
   $_=@lines[$i]; print $_;
   ($type) = ($_ =~ /^\s*(\S*)\s*[,|]\s*.*::\s*($object)/);
    $type;
}


# &dimension ($object,@lines) dimension of object found in the lines @lines
sub dimension {
   local($object)=shift(@_);
   local(@lines)=@_;
   local($i)=&declaration ($object,@lines);
   $_=@lines[$i];
   ($dim) = ($_ =~ /^\s*\S*.*::\s*$object\s*(\S*)/);
    $dimension = split(":",$dim)-1;
   
}


# line number &declaration ($object,@lines) is the fortran declaration line of $object in @lines 
sub declaration {
   local($object)=shift(@_);
   local(@lines)=@_;
   local($type);
   undef $type;
   local($declaration)=0;
   foreach(@lines) { if (! defined $type) {($type) = ($_ =~ /^\s*(\S*)\s*::\s*($object)/), $declaration=$declaration+1}}
   $declaration;
}


# &rtn_from_file ($file,$rtn) are the lines of the routine $rtn in file
# $file
sub rtn_from_file {
    local($file)=shift(@_);
    local($rtn)=shift(@_);
    open (INP,"<$file");
    local(@lines)=<INP>;
    local(@rtn_lines)=
    &between_expr ("subroutine $rtn","end subroutine $rtn",@lines);
    @rtn_lines;
    }

#  &between_expr ($r1,$r2,@list) is the sublist between 
#  lines matching regular  expressions $r1, $r2
sub between_expr {
    local($r1)=shift(@_);
    local($r2)=shift(@_);
    local(@list)=@_;
  
    local(@sublist);

    undef local($in);
    local($i)=0;

    foreach(@list) { if ((! defined $in) &&   /$r1/) {$in=1};
                     if (defined $in) {@sublist[$i]=$_; $i=$i+1}
                     if (defined $in && /$r2/) {undef $in};
		 }
@sublist
}
