#! /usr/bin/perl

use Env qw(GTO_LIB PWD);
use File::Find;

use array;
use parse_geom;
use atom_parser;
use tools;

my($input_file) = @ARGV[0];
my($basis)      = @ARGV[1];

$basis = uc($basis);

my($match_basis) = $basis;

if($basis =~ m/\*/i)
{
    $match_basis =~ s/\*/\\*/ig;
}

$match_basis = $match_basis . ".out";

my($INPUT_FILE)  = array->ARRAY($input_file);

my($input_array) = $INPUT_FILE->{array};

my($atoms_nb) = tools->size_dim1_array($input_array);

for($atom_i = 0; $atom_i < $atoms_nb; $atom_i++)
{
    my($line) = $input_array->[$atom_i];

    print "$line\n";

    $line =~ m/([a-z]+)/i;
    
    my($atom) = $1;

    $atom = uc($atom);

    my($gto_basis_dir) = "$GTO_LIB/$atom";

    my($basis)         = $atom . "-" . $basis . ".out";

    my($basis_file)    = "$gto_basis_dir/$basis";

    find( \&process_basis_file, $gto_basis_dir);

    if( -e $basis_file) {}
    else
    {
	print "\n";
	print "\t cannot find requested basis: $basis\n";
	print "\t exiting...\n";
	print "\n";
	
	exit;
    }

    my($BASIS_FILE)  = array->ARRAY($basis_file);
    
    my($basis_array) = $BASIS_FILE->{array};

    my($line_nb) = tools->size_dim1_array($basis_array);

    for($line_i =0; $line_i < $line_nb; $line_i++)
    {
	my($basis_line) = $basis_array->[$line_i];

	if( ($line_i == ($line_nb - 1)) && ($basis_line ne "") )
	{
	    print "$basis_line\n";
	    print "\n";
	}
	else
	{
	    print "$basis_line\n";
	}
    }
}

sub process_basis_file
{
    $file = $_;

    if($file =~ m/$match_basis/i)
    {
	last;
    }
}

