#! /usr/bin/perl

use array;
use atom_parser;

my($list) = @ARGV[0];

my($LIST)  = array->ARRAY($list);

$array = $LIST->{array};

my($CUSP) = array->ARRAY("cusp.data");

$cusp_values = $CUSP->{array};

$occ = "false";

foreach $item (@$array)
{
    open(OUT, ">tmp") or die "cannot create output file\n";
 
    open(IN, "$item") or die "cannot open $file file\n";

    while(<IN>)
    {
	chomp $_;
	if($_ =~ m/occupations/i) {$occ = "true"; last;}
    }

    close(IN);

    $item =~m/([a-z]+)\-([a-z]+)\-([a-z]+)\-(neutral|\-1|\+1)\-([a-z]+)/i;

    $name    = ucfirst(lc($2));
    $type    = uc(lc($3));
    $charge  = $4;
    $state   = ucfirst(lc($5));

    if( $charge =~ m/neutral/i)
    {
	$charge = 0;
    }

    open(IN, "$item") or die "cannot open $file file\n";

    while(<IN>)
    {
    
	chomp $_;
	if($_ ne "") {$line = $_; last;}
    }

    $line =~ m/([a-z]+)/i;

    $element = $1;

    my($ATOM) = atom_parser->ATOM_DATA($element,"query", $charge);

    print OUT "Element          : $ATOM->{element_name}\n";
    print OUT "Z                : $ATOM->{element_charge}\n";
    print OUT "State            : $state\n";
    print OUT "Charge           : $charge\n";
    print OUT "Whose            : $name\n";
    print OUT "Type             : $type\n";
    print OUT "Multiplicity     : $ATOM->{element_multiplicity}\n";
    print OUT "\n";

    for($i=0; $i< @$cusp_values; $i++)
    {
	$value = $cusp_values->[$i];

	if($value =~ m/$item/i)
	{
	    $count = $i;
	    
	    last;
	}
    }
    
    for($j=$i+1; $j< @$cusp_values; $j++)
    {
	if($cusp_values->[$j] eq "") {last;}
	else { print OUT "$cusp_values->[$j]\n"; }
    }

    if($occ eq "false")
    {
	my($s_string) = "";
	my($p_string) = "";
	my($d_string) = "";

	$occupation = $ATOM->{element_occupation};
	
	if($occupation =~ m/K\(2\)/i)
	{
	    $s_string = $s_string . "1s(2) ";
	}

	if($occupation =~ m/L\(8\)/i)
	{
	    $s_string = $s_string . "2s(2) ";
	    $p_string = $p_string . "2p(6) ";
	}

	if($occupation =~ m/M\(18\)/i)
	{
	    $s_string = $s_string . "3s(2) ";
	    $p_string = $p_string . "3p(6) ";
	    $d_string = $d_string . "3d(10) ";
	}

	while($occupation =~ m/(\d+[spdf]\(\d+\))/ig)
	{
	    $orb = lc($1);

	    if($orb =~ m/S/i) { $s_string = $s_string . "$orb "; }
	    if($orb =~ m/P/i) { $p_string = $p_string . "$orb "; }
	    if($orb =~ m/D/i) { $d_string = $d_string . "$orb "; }
	    if($orb =~ m/F/i) { $f_string = $f_string . "$orb "; }
	}

	print OUT "\n";
	print OUT "Orbital Occupation:\n";
	print OUT "\n";

	if($s_string ne "") { print OUT  "S : $s_string\n"; }
	if($p_string ne "") { print OUT  "P : $p_string\n"; }
	if($d_string ne "") { print OUT  "D : $d_string\n"; }
    }

    while(<IN>)
    {
	chomp $_;
	
	if($_ =~ m/[0-9][a-z]\(0\)/i)
	{
	    $_ =~ s/[0-9][a-z]\(0\)/ /;

	    print OUT "$_\n";
	}
	
	if($_ =~ m/total energy\s+\:\s+(-\d+\.\d+|\d+\.\d+)/i)
	{
	    printf OUT "Total energy     : %17.10f\n", $1;
	}

	elsif($_ =~ m/potential energy\s+\:\s+(-\d+\.\d+|\d+\.\d+)/i)
	{
	    printf OUT "Potential energy : %17.10f\n", $1;
	}

	elsif($_ =~ m/kinetic energy\s+\:\s+(-\d+\.\d+|\d+\.\d+)/i)
	{
	    printf OUT "Kinetic energy   : %17.10f\n", $1;
	}

	elsif($_ =~ m/virial theorem\s+\:\s+(-\d+\.\d+|\d+\.\d+)/i)
	{
	    printf OUT "Virial ratio     : %17.10f\n", $1;
	}

	else
	{
	    print OUT "$_\n";
	}
    }

    close(OUT);
    close(IN);

    print "tmp --> $item\n";

    system("mv tmp $item");
}
