#! /usr/bin/perl

use array;
use atom_parser;
use basis_parser;

my($file) = @ARGV[0];

$file =~ m/([a-z]+)/i;

my($element) = ucfirst(lc($1));

my($STO)  = basis_parser->STO_BASIS_DATA($file, "adf");
my($ATOM) = atom_parser->ATOM_DATA($element, "query");

my($charge)       = $ATOM->{element_charge};
my($element)      = $ATOM->{element_name};
my($label)        = $ATOM->{element_label};
my($multiplicity) = $ATOM->{element_multiplicity};

my($exponent)     = $STO->{exponent};
my($level)        = $STO->{r_power};
my($size)         = $STO->{function_number};
my($symmetry)     = $STO->{symmetry};

my($sym, $pow, $exp) = sort_basis("s");

my($sym, $pow, $exp) = sort_basis("p");

my($sym, $pow, $exp) = sort_basis("d");

$exponent = $exp;

$symmetry = $sym;

$level    = $pow;

if($multiplicity == 1) { $hf = "RHF";  }

if($multiplicity > 1)  { $hf = "ROHF"; }

print_gamess_header();

print_gamess_basis_format();

print_gamess_footer();

sub sort_basis
{
    my($sym) = $_[0];

    for($i=0; $i< size($exponent); $i++)
    {
	if($symmetry->[$i] =~ m/$sym/i)
	{
	    push(@sym, $symmetry->[$i]);
	    push(@pow, $level->[$i]);
	    push(@exp, $exponent->[$i]);
	}
    }
    
    return \@sym, \@pow, \@exp;
}

sub print_gamess_basis_format
{
    print " $label  $charge   0.0   0.0   0.0\n";

    for($i=0; $i < $size; $i++)
    {
	print " $level->[$i]$symmetry->[$i]  6  $exponent->[$i]\n";
    }
}

sub print_gamess_header
{
    print <<EOF;
 \$CONTRL SCFTYP=$hf ICHARG=0 MULT=$multiplicity MAXIT=100 UNITS=BOHR \$END
 \$SYSTEM TIMLIM=10000 MEMORY=5000000 \$END
 \$SCF SHIFT=.TRUE. DIRSCF=.TRUE. \$END
 \$GUESS GUESS=HUCKEL \$END
 \$DATA
 comment line
 C1
EOF
}

sub print_gamess_footer
{
    print <<EOF;

\$END
EOF
}

sub size
{
    my($array) = @_[0];
    my($count) = 0;

    foreach my $item (@$array) {$count++;}

    return $count;
}
