#!/usr/bin/env python
#
#
import sys
import libxml2
from re import *
from string import *

print "Zori basis conversion utility for QMCMOL (2004, Paris)"

if (len(sys.argv) < 4):
    print "ERROR: Not enough arguments supplied"
    print "USAGE: ./basis2qmcmol.py file.xml file.bas file.mos"
    print "Where file.xml is your input XML file "
    print "file.bas is the QMCMol file"
    print "file.mos is the QMCMol MO file"
    sys.exit(1)

file = sys.argv[1];
fileout = sys.argv[2];
filemos = sys.argv[3];

print "Converting... " + file

doc = libxml2.parseFile(file)
ctxt = doc.xpathNewContext()
centers = ctxt.xpathEval("/Orbitals/Basis/*")


out = open(fileout, "w")
moout = open(filemos, "w")

#dim = int(ensdesc[0].prop("Dim"))
#particles = int(ensdesc[0].prop("Particles"))
#type = ensdesc[0].prop("Type")
#print "Dimensions: " + str(dim) + " # Particles " + str(particles) + " Type " + type

num_centers = len(centers)

print "Number of centers to convert: " + str(num_centers)

out.write("title: Basis converted using basis2qmcmol.py from Zori\n")
out.write("end_of_header\n")


for i in range(1,num_centers+1):
    xpath = "/Orbitals/Basis/Center["+str(i)+"]"
    res2 = ctxt.xpathEval(xpath)
    xpath = "/Orbitals/Basis/Center["+str(i)+"]/*"
    contractions = ctxt.xpathEval(xpath)
    num_contractions = len(contractions)
    cent_name = res2[0].prop("Name")
    out.write("elem "+cent_name)
    for j in range(1,num_contractions+1):
        xpath="/Orbitals/Basis/Center["+str(i)+"]/Contraction["+str(j)+"]/*"
        gaussians = ctxt.xpathEval(xpath)
        num_gaussians = len(gaussians)
        idx=0
        for gaussian in gaussians:
            sym = gaussian.prop("Type")
            if (idx==0):
                out.write("\n\nsym " + sym + "\n")
            idx = idx +1
            exponent = gaussian.prop("Exponent")
            coefficient = gaussian.prop("Coefficient")
            out.write(" gto 1 "+ exponent + " " + coefficient + "\n")
            if (idx== num_gaussians):
                out.write("end sym\n")
    out.write("end_elem\n");
out.write("end_of_basis\n");
moout.write("mos_on_what = aos_c\n")
moout.write("end_of_header\n")
vectors = ctxt.xpathEval("/Orbitals/MOVectors/*")
for vector in vectors:
    moout.write("mo")
    moout.write(vector.content)
    moout.write("end_mo\n")
moout.write("end_of_mos\n")
out.close()
moout.close()    
