#! /usr/bin/perl

$file = @ARGV[0];

open(IN,"$file") or die "Cannot open input file\n";
while(<IN>)
{
    chomp $_;

    if( ($_ =~ m/([a-z]+)/i) && ($_ !~ m/[0-9\/\\]+/i) && ($_ !~ m/EOF/i) )
    {
	$element = ucfirst(lc($1));

	print "$element\n";
	print "\n";
    }

    if($_ =~ m/basis/i)
    {
	while($_ =~ m/(-\d+.\d+)/ig)
	{
	    push(@orb_energy, $1);

	    $count_s = -1;
	    $count_p = -1;
	    $count_d = -1;
	    $count_f = -1;
	}
    }

    extract_ke($_);

    if($_ =~ m/Z\s+\=\s+\d+/i)
    {
	print "$_\n";
	print "\n";
    }

    if($_ =~ m/P\.E\./i)
    {
	$_ =~ m/(-\d+\.\d+)E\+0(\d)/i;

	$power   = 10**$2;
	$potential = $1 * $power;

	printf "Potential energy : %17.10f\n",$potential;
    }
 
    if($_ =~ m/T\.E\./i)
    {
	$_ =~ m/(-\d+\.\d+)E\+0(\d)/i;

	$power = 10**$2;
	$total = $1 * $power;

	printf "Total energy     : %17.10f\n",$total;
    }

    if($_ =~ m/V\.T\./i)
    {
	$_ =~ m/(-\d+\.\d+)E\+0(\d)/i;

	$power = 10**$2;
	$total = $1 * $power;

	printf "Virial           : %17.10f\n",$total;
    }

    if( $_ =~ m/[\*\?\,]+/i)
    {
	print "HERE: $_\n";

	exit;
    }

    if( ($_ =~ m/[0-9]+\.([0-9a-z]+)/i) && ($_ !~ m/E\+/i))
    {
	my($here) = $1;

	if( $here =~ m/[a-z]+/i) 
	{
	    print "HERE: $_\n";

	    exit;
	}
    }

    if($_ =~ m/(\d+s|\d+p|\d+d)\s+(\d+.\d+)/i)
    {
	while($_ =~ m/(\d+s|\d+p|\d+d|\d+f|\d+.\d+|-\d+.\d+)/ig)
	{
	    $string = $1;
	    $val    = $1;

	    if($string =~m/([0-9]+[S]+)/)
	    {
		$string_s = $1;
		$count_s++;
	    }

	    if($string =~m/([0-9]+[P]+)/)
	    {
		$string_s = $1;
		$count_p++;
	    }

	    if($string =~m/([0-9]+[D]+)/)
	    {
		$string_s = $1;
		$count_d++;
	    }

	    if($string =~ m/([0-9]+[F]+)/)
	    {
		$string_s = $1;
		$count_f++;
	    }

	    elsif($string =~ m/(\d+\.\d+|-\d+\.\d+)/)
	    {
		$string_s = $string_s ." ". $1;

		if($string_s =~ m/S/)
		{
		    @s_array[$count_s] = $string_s;
		}
		
		if($string_s =~ m/P/)
		{
		    @p_array[$count_p] = $string_s;
		}

		if($string_s =~ m/D/)
		{
		    @d_array[$count_d] = $string_s;
		}

		if($string_s =~ m/F/)
		{
		    @f_array[$count_f] = $string_s;

		}
	    }
	}

    }

    if($_ =~ /eof/i)
    {

	print "\n";
	$s= 0;
	foreach $item (@s_array)
	{

	    @tmp = split(/\s+/,$item);

	    $count++;
	    $size_s = @tmp-2;
	    
	    if($count == 1)
	    {

		printf "%13s","s";

		for($i=0; $i<$size_s; $i++)
		{
		    $s++;
		    $h = $s . "s";
		    printf "%15s",$h;
		}

		print "                 \n";
		print "Basis    Exponent";

		for($i=0; $i<$size_s; $i++)
		{
		    printf "%15.6f",@orb_energy[$i];
		}
	    }

	    foreach $item (@tmp)
	    {
		if($item =~ m/s/i)
		{
		    print "\n";
		    print "$item";
		}
		else
		{
		    printf "%15.6f",$item;
		}
	    }
	}
	
	print "\n";
	print "\n";

	$count=0;

	foreach $item (@p_array)
	{
	    @tmp = split(/\s+/,$item);
	    
	    $count++;
	    $size_p = @tmp-2;
	    
	    if($count == 1)
	    {
		printf "%13s", "p";
		$p=2;
		for($i=$size_s; $i<$size_p+$size_s; $i++)
		{
		    $h = $p . "p";
		    
  		    printf "%15s",$h;
		    
		    $p++
		    }

 		print "\n";
 		print "Basis    Exponent";
		
		for($i=$size_s; $i<$size_p+$size_s; $i++)
		{
		    printf "%15.6f",@orb_energy[$i];
		}
	    }
	    
	    foreach $item (@tmp)
	    {
		if($item =~ m/p/i)
		{
		    print "\n";
		    print "$item";
		}
		else
		{
		    printf "%15.6f",$item;
		}
	    }
	}

	print "\n";
	print "\n";

	$count=0;

	foreach $item (@d_array)
	{
	    @tmp = split(/\s+/,$item);
	    
	    $count++;
	    $size_d = @tmp-2;

	    if(@f_array ne "") {$this = @orb_energy; }
	    if(@f_array eq "") {$this = @orb_energy;     }
	    
	    if($count == 1)
	    {
		printf "%13s","d";
		
		$d = 3;
		for($i=$size_s+$size_p; $i<$this; $i++)
		{
		    $h = $d . "d";
		    printf "%15s",$h;
		    $d++;
		}
		
		print "\n";
		print "Basis    Exponent";
		
		for($i=$size_s+$size_p; $i<$this; $i++)
		{
		    printf "%15.6f",@orb_energy[$i];
		}
	    }
	    
	    foreach $item (@tmp)
	    {
		if($item =~ m/d/i)
		{
		    print "\n";
		    print "$item";
		}
		else
		{
		    printf "%15.6f",$item;
		}
	    }
	}
	
	print "\n";
	print "\n";

	$count=0;

	foreach $item (@f_array)
	{
	    @tmp = split(/\s+/,$item);
	    
	    $count++;
	    $size_f = @tmp-2;
	    
	    if($count == 1)
	    {
		printf "%13s","f";
		
		$f = 5;
		for($i=$size_s+$size_p + $size_d; $i<@orb_energy; $i++)
		{
		    $h = $d . "f";
		    printf "%15s",$h;
		    $d++;
		}
		
		print "\n";
		print "Basis    Exponent";
		
		for($i=$size_s+$size_p+$size_d; $i<@orb_energy; $i++)
		{
		    printf "%15.6f",@orb_energy[$i];
		}
	    }
	    
	    foreach $item (@tmp)
	    {
		if($item =~ m/f/i)
		{
		    print "\n";
		    print "$item";
		}
		else
		{
		    printf "%15.6f",$item;
		}
	    }
	}
	
	print "\n";
	print "\n";
	print "eof\n";
	print "\n";
	print "\n";

	@s_array    = ();
	@p_array    = ();
	@d_array    = ();
	@f_array    = ();
	$string_s   = ();
	@orb_energy = ();
	$count      = ();
	$size_s     = ();
    }
}

close(IN);

sub extract_ke
{
    my($line) = $_[0];

    if($line =~ m/K\.E\./i)
    {
	$line =~ m/(\d+\.\d+)E\+0(\d)/i;

	$power   = 10**$2;
	$kinetic = $1 * $power;

	printf "Kinetic energy   : %17.10f\n",$kinetic;
    }
}
