#! /usr/bin/perl

use English;
use FileHandle;
use File::Copy;
use Getopt::Std;
use File::Basename;
use IO::File;

use basis_parser;

getopt("efgsw",\%args);

my($input_file) = $args{f};
my($whose)      = $args{w};
my($error)      = $args{e};
my($gaussian)   = $args{g};
my($slater)     = $args{s};

$GTO  = basis_parser->GTO_BASIS_DATA($input_file,"list");

print "sto-ng\n";
print "\tsto\n";
print "\t\tslater_type = $slater\n";
print "\tend_sto\n";
print "\n";
print "\tfit\n";
print "\t\tgaussian_type    = $gaussian\n";
print "\t\twhose            = $whose\n";
print "\t\tchi2_error       = $error\n";

print_sto_ng_cascade($GTO->{exponent},
		     $GTO->{coefficient},
		     $GTO->{function_number}
		     );

print "end_sto-ng\n";

sub print_sto_ng_cascade
{
    my($exponents)    = @_[0];
    my($coefficients) = @_[1];
    my($function_nb)  = $_[2];

    print "\t\tprimitive_number = $function_nb\n";
    print "\tend_fit\n";
    print "\n";
    print "\tprimitive\n";

    for($i=0; $i<$function_nb; $i++)
    {
	print "\t\texponent    = $exponents->[$i]\n";
	print "\t\tcoefficient = $coefficients->[$i]\n";
	print "\n";
    }
    
    print "\tend_primitive\n";
}
