#! /usr/bin/perl

my($file)    = @ARGV[0];
my($type)    = @ARGV[1];
my($name)    = @ARGV[2];
my($gto)     = @ARGV[3];
my($sto)     = @ARGV[4];

open(IN,"$file") or die "cannot open input file\n";

while(<IN>)
{
    chomp $_;

    if($_ =~ m/ER1\s+(\d+\.\d+|-\d+\.\d+)d(\+|\-)(\d+)/i)
    {
	$error = $1;
	$sign  = $2;
	$value = $3;

	$power = determine_power($sign, $value);
	
	$error = $error * $power;
    }
    

    if($_ =~ m/EXX\(\d+\)\s+\=\s+(\d+\.\d+|-\d+\.\d+)d(\+|\-)(\d+)/i)
    {
	$exp   = $1;
	$sign  = $2;
	$value = $3;

	$power = determine_power($sign, $value);

	$exp = $exp * $power;

	push(@exp,$exp);
    }

    if($_ =~ m/C$type\(\d+\)\s+\=\s+(\d+\.\d+|-\d+\.\d+)d(\+|\-)(\d+)/i)
    {
	$coeff = $1;
	$sign  = $2;
	$value = $3;

	$power = determine_power($sign, $value);

	$coeff = $coeff * $power;

	push(@coeff, $coeff);
    }
    
    if($_ =~ m/return/i)
    {
	$size = @coeff;
	
	print  "sto-ng\n";
	print  "\tsto\n";
	print  "\t\tslater_type = $sto\n";
	print  "\tend_sto\n";
	print  "\n";
	print  "\tfit\n";
	print  "\t\tgaussian_type    = $gto\n";
	print  "\t\twhose            = $name\n";
	printf "\t\tchi2_error       = %5.5e\n", $error;
	print  "\t\tprimitive_number = $size\n";
	print  "\tend_fit\n";
	print  "\n";
	print  "\tprimitive\n";

	for($i=0; $i<@coeff; $i++)
	{
	    printf "\t\texponent    = %15.10f\n", @exp[$i];
	    printf "\t\tcoefficient = %15.10f\n", @coeff[$i];
	    print  "\n";
	}

	print  "\tend_primitive\n";
	print "end_sto-ng\n";
	print "\n";

	@coeff = ();
	@exp   = ();
    }
}

close(IN);

	    
sub determine_power
{
    my($sign)  = $_[0];
    my($value) = $_[1];

    if($sign eq "-")
    {
	$power = 10 ** (-1.0*$value);
    }
    
    if($sign eq "+")
    {
	$power = 10**($value);
    }
    
    return $power;
}
