#!/usr/bin/env python
import sys
from re import *
from string import *

charges={
    'H' : 1.0,
    'He' : 2.0,
    'HE' : 2.0,
    'Li' : 3.0,
    'Be' : 4.0,
    'BE' : 4.0,
    'B' :  5.0,
    'C' :  6.0,
    'N' :  7.0,
    'O' :  8.0,
    'F' :  9.0,
    'Ne' : 10.0,
    'NE' : 10.0,
    'Na' : 11.0,
    'NA' : 11.0,
    'Mg' : 12.0,
    'MG' : 12.0,
    'Al' : 13.0,
    'AL' : 13.0,
    'Si' : 14.0,
    'SI' : 14.0,
    'P' :  15.0,
    'S' :  16.0,
    'Cl' : 17.0,
    'CL' : 17.0,
    'Ar' : 18.0,
    'AR' : 18.0,
    'K' :  19.0,
    'Ca' : 20.0,
    'CA' : 20.0,
    'Sc' : 21.0,
    'SC' : 21.0,
    'Ti' : 22.0,
    'TI' : 22.0,
    'V'  : 23.0,
    'Cr' : 24.0,
    'CR' : 24.0,
    'Mn' : 25.0,
    'MN' : 25.0,
    'Fe' : 26.0,
    'Co' : 27.0,
    'Ni' : 28.0,
    'Cu' : 29.0,
    'Zn' : 30.0,
    'Ga' : 31.0,
    'Ge' : 32.0,
    'As' : 33.0,
    'Se' : 34.0,
    'Br' : 35.0,
    'Kr' : 36.0,
    'Rb' : 37.0,
    'Sr' : 38.0,
    'Y' : 39.0,
    'Zr' : 40.0,
    'Nb' : 41.0,
    'Mo' : 42.0,
    'Tc' : 43.0,
    'Ru' : 44.0,
    'Rh' : 45.0,
    'Pd' : 46.0,
    'Ag' : 47.0,
    'Cd' : 48.0,
    'In' : 49.0,
    'Sn' : 50.0,
    'Sb' : 51.0,
    'Te' : 52.0,
    'I' : 53.0,
    'Xe' : 54.0,
    'Cs' : 55.0,
    'Ba' : 56.0
    #FIXME: Fill in the rest from eperiodic.el :)
    }


centroids=[]

def localized(file):
    lines = open(file,'r').readlines()
    nlin = len(lines)
    a = range(nlin)
    i=0
    for line in lines:
        a[i]=split(line)
        i=i+1

    centline=0;
    found_cent=0;
    for spl in a:
        for splstr in spl:
            if (find(splstr,"CENTROIDS")>=0):
                found_cent=1
                found_cent_line=centline
        centline=centline+1
    if(found_cent):
        #print "I found orbital centroids in GAMESS PUNCH file..."

        for spl in a[found_cent_line+2:]:
            if(find(spl[0],".....")>=0):
                break;
            centroids.append(spl)
        
    else:
        print "No centroids found in GAMESS PUNCH file (Second argument)."
        sys.exit(1)

ANGST2BOHR = 1.88972598857892320310

localized(sys.argv[2])

#booleans
found_localized_orbitals = 0;
found_regular_orbitals = 0;
cuento=0
nlin=len(open(sys.argv[1],'r').readlines())
ss=''
a=range(nlin)

coordfile = open("psi-coords.xml",'w');

totalcharge = 0.0;

atomoid = []
contractions=0;

print '<?xml version="1.0"?>'
print '<Orbitals>'
print '<Basis>'
for line in open(sys.argv[1],'r').readlines():
    a[cuento]=split(line)
    cuento=cuento+1

for j in range(0,nlin):
    la=len(a[j])
    for i in range(0,la):
        if(find(a[j][i],"NATOMS")>=0):
            natomos=atoi(a[j][i+1])
            #print a[j][i+1]
        
        if(find(a[j][i],"NAOS")>=0):
            naos=a[j][i+1]
            #print a[j][i+1]    
        if( (find(a[j][i],"KOLOR")>=0)):
            for nn in range(0,natomos):
#                print a[j+nn+1]
                ss=join(a[j+nn+1])
                ss=sub(" ","       ",ss)
                ss=sub(" -","-",ss)
                #print "atomin"
                #print ss
                splitoid = split(ss);
                atomoid.append(splitoid);
                #print "atominende"
        if( (find(a[j][i],"PLOTMOS")>=0)):
            #initializing basis parsing variables
            iatom=0;
            nextheader=0;
            nextheader_next=0;
            lookingforatom=1;
            for nn in range(j+1,nlin-2):
                ss=join(a[nn])

                ss=sub(" ","       ",ss)
                #print "bananoid"
                #print ss
                splitbas = split(ss)
                #print splitbas

                #events
                if (lookingforatom==0 and nextheader==0):
                    #I am adding a contraction
                    #print "En linea de contracciones..."
                    # Getting numbers up to 'numbers to get'
                    for my_token in splitbas:
                        if(my_token != ">"):
                            contnums.append(my_token);
                            #print "contnums so far" + str(contnums);
                            numbers2get = numbers2get - 1;
                            #print "numbers 2 get " + str(numbers2get);
                            if (numbers2get == 0):
                                numbasis = numbasis -1;
                                #print "Done with getting numbers man, remaining basis functions: " \
                                #      + str(numbasis);
                                nextheader_next=1;
                                if (type == "L"):
                                    print "<Contraction>"
                                    for i in range(numcontractions):
                                        print '<Gaussian Type="S" Exponent="' + \
                                              str(contnums[i]) + '" Coefficient="' + \
                                              str(contnums[i+numcontractions]) + '" />'
                                    print "</Contraction>"
                                    print "<Contraction>"
                                    for i in range(numcontractions):
                                        print '<Gaussian Type="P" Exponent="' + \
                                              str(contnums[i]) + '" Coefficient="' + \
                                              str(contnums[i+2*numcontractions]) + '" />'
                                    print "</Contraction>"
                                    contractions = contractions + 2;
                                else:
                                    if (contractions==0):
                                        print '<Contraction Slaterize="True">'
                                    else:
                                        print "<Contraction>"
                                    for i in range(numcontractions):
                                        print '<Gaussian Type="' + type + '" Exponent="' + \
                                              str(contnums[i]) + '" Coefficient="' + \
                                              str(contnums[i+numcontractions]) + '" />'
                                    contractions = contractions + 1;
                                    print "</Contraction>"

                                    if (numbasis == 0):
                                        contractions=0;
                                        lookingforatom_next=1;
                                        print "</Center>"
                if (nextheader == 1):
                    nextheader=0;
                    type = splitbas[0]
                    numcontractions=int(splitbas[1]);
                    #print "chale, tipo "+str(type)+" contracciones "+ str(numcontractions);
                    if (type == "L"):
                        numbers2get = 3*int(numcontractions);
                    else:
                        numbers2get = 2*int(numcontractions);
                    contnums = [];
                if (lookingforatom == 1 and splitbas[0] == atomoid[iatom][0]):
                    lookingforatom_next = 0;
                    numbasis = int(splitbas[1]);
                    #print "FOUND AN ATOM CARNAVAL: Numbasis: 8"
                    centx = atof(atomoid[iatom][1]);
                    centy = atof(atomoid[iatom][2]);
                    centz = atof(atomoid[iatom][3]);
                    centx = centx*ANGST2BOHR;
                    centy = centy*ANGST2BOHR;
                    centz = centz*ANGST2BOHR;
                    print '<Center Name="'+str(atomoid[iatom][0])+'" X="' \
                          +str(centx)+'" Y="'+ \
                          str(centy)+'" Z="' + \
                          str(centz)+'"> '
                    coordfile.write('<Atom Name="'+str(atomoid[iatom][0])+ \
                                    '" Charge="'+str(charges[atomoid[iatom][0]])+ \
                                    '" X="' +str(centx)+'" Y="'+ \
                                    str(centy)+'" Z="' + \
                                    str(centz)+'"/> \n');
                    totalcharge = totalcharge + float(charges[atomoid[iatom][0]]);
                    iatom=iatom+1
                    nextheader=1;
                    lookingforatom=0;
                if (lookingforatom_next == 1):
                    lookingforatom = 1;
                if (nextheader_next == 1):
                    nextheader = 1;
                    nextheader_next = 0;
                #print "bananoidende"
print "</Basis>"
vectorlines = [];
for j in range(0,nlin):
    la=len(a[j])
    for i in range(0,la):
        if(find(a[j][i],"ITERS")>=0):
            found_regular_orbitals=1;
            if(a[j+1][0]=="$VEC"):
                ivec_regular= j+2
                for nn in range(j+2,nlin):
                    if(find(a[nn][0],"$END")>=0):
                        
                        fvec_regular= nn;
                        num_vec = a[fvec_regular-1][0];
for j in range(0,nlin):
    la=len(a[j])
    for i in range(0,la):
        if(find(a[j][i],"LOCALIZED")>=0):
            found_localized_orbitals=1;
            if(a[j+1][0]=="$VEC"):
                ivec= j+2
                for nn in range(j+2,nlin):
                    if(find(a[nn][0],"$END")>=0):
                        
                        fvec= nn;
                        num_loc_vec = a[fvec-1][0];
if (found_localized_orbitals):
    if(found_regular_orbitals ==0):
        print "ERROR LOCALIZED ORBITALS WITHOUT REGULAR ORBITALS!";
        exit(1);
    #print naos;
    #naos is the number of vectors <critical>
    for j in range(ivec,fvec):
        ss=join((a[j]))
    
        ss=sub("-"," -",ss)
        ss=sub("E -","E-",ss)
        ss=sub(" ","  ",ss)
        ss=sub(" -","-",ss)
        vectorlines.append(ss);
        #print ss
    for j in range(ivec_regular+(fvec-ivec),fvec_regular):
        ss=join((a[j]))
    
        ss=sub("-"," -",ss)
        ss=sub("E -","E-",ss)
        ss=sub(" ","  ",ss)
        ss=sub(" -","-",ss)
        splat = split(ss);
        lala=len(splat)
        found_end=0;
        for i in range(0,lala):
            if(find(splat[i],"END")>=0):
                found_end=1;
        if (found_end == 1):
            break;
        vectorlines.append(ss);
        #print ss
else:
#    print "NO LOCALIZED ORBITALS"
    print naos;
    for j in range(ivec_regular,fvec_regular):
        ss=join((a[j]))
        
        ss=sub("-"," -",ss)
        ss=sub("E -","E-",ss)
        ss=sub(" ","  ",ss)
        ss=sub(" -","-",ss)
        
        #print ss
        vectorlines.append(ss);

#now, lets go over all the vector lines and create our nice <MOVectors>
#<Vector></Vector></MoVectors> structures
print "<MOVectors>"
newvector=0;
start=1;
currentvector=1;
for a in vectorlines:
    #print "processing: " + a
    vecsplit = split(a);
    if (int(vecsplit[0]) == currentvector):
        if (start== 1):
            localized=0
            for cent in centroids:
                if(atoi(cent[0]) == currentvector):
                    #print "Vector " +str(currentvector) + " is localized"
                    centlocalized = cent
                    localized=1
                #else:
                    #print "Not match" + str(atoi(cent[0])) + " " + str(currentvector)
            if (localized):
                print '<Vector CentroidX="' + str(centlocalized[1]) + '" CentroidY= "' + \
                      str(centlocalized[2]) +'" CentroidZ="' + str(centlocalized[3]) + '" >'
            else:
                print "<Vector>";
            start=0;
        printstr = " ";
        for mytoken in vecsplit[2:]:
            printstr = printstr + mytoken + " ";
        print printstr;
    else:
        print "</Vector>";
        localized=0;
        for cent in centroids:
            if(atoi(cent[0]) == currentvector):
                #print "Vector " +str(currentvector) + " is localized"
                centlocalized=cent
                localized=1
            #else:
            #    print "Not match" + str(atoi(cent[0])) + " " + str(currentvector)
        if (localized):
            print '<Vector CentroidX="' + str(centlocalized[1]) + '" CentroidY= "' + \
                      str(centlocalized[2]) +'" CentroidZ="' + str(centlocalized[3]) + '" >'
        else:
            print "<Vector>";
        #print "<Vector>";
        printstr = " ";
        for mytoken in vecsplit[2:]:
            printstr = printstr + mytoken + " ";
        print printstr;
        currentvector= currentvector + 1;
print "</Vector>"
print "</MOVectors>"
print """<Options MOVectorCutoff="1E-12" PrimitiveVectorCutoff="1E-12" Spline="True"
        NumSplineKnots="5000" SplineType="Contraction" SplineDerivs="True"
        ContractionCutoff="1E-18" LocalizationRadius="12.0" Localize="True"
        ContractionLaplacianCutoff="1E-6" /> """
print "</Orbitals>"

#coordfile occupations
intcharge = int(totalcharge);
coordfile.write("<Occupations>\n");
coordfile.write(" 1.0 ");
for a in range(intcharge/2 - 1):
    coordfile.write("D");

if (intcharge%2 == 1):
    coordfile.write("A\n");
else:
    coordfile.write("D\n");
coordfile.write("</Occupations>\n");
coordfile.close();
