#! /usr/bin/perl

use gnuplot_parser;

$file = @ARGV[0];

my($GNUPLOT)  = gnuplot_parser->GNUPLOT($file);

my($size) = $GNUPLOT->{parameter_number};

for($i=0;$i<$size; $i++)
{
    $label = $GNUPLOT->{parameter_label}->[$i];

    $label =~ m/([a-z])(\d+)/i;

    $number = $2;

    if($number%2 == 0 )
    {
	push(@exp_val, $GNUPLOT->{parameter_value}->[$i]);
	push(@exp_err, $GNUPLOT->{parameter_error}->[$i]);
	push(@exp_per, $GNUPLOT->{parameter_percent}->[$i]);
    }
    
    else
    {
	push(@coeff_val, $GNUPLOT->{parameter_value}->[$i]);
	push(@coeff_err, $GNUPLOT->{parameter_error}->[$i]);
	push(@coeff_per, $GNUPLOT->{parameter_percent}->[$i]);
    }

}

$size = @exp_val;

my($exp_val, 
   $exp_per, 
   $exp_err,
   $coeff_val,
   $coeff_per,
   $coeff_err) = bubble_sort($size, 
				   \@exp_val, 
				   \@exp_per, 
				   \@exp_err,
				   \@coeff_val,
				   \@coeff_per,
				   \@coeff_err);

for($i=0;$i<$size; $i++)
{
    $j = $i+1;

    printf "\t\texponent_%0.2d            = %17.10f\n", $j, $exp_val->[$i];
    printf "\t\texponent_error_%0.2d      = %17.10f\n", $j, $exp_err->[$i];
    printf "\t\texp_percent_error_%0.2d   = %17.10f\n", $j, $exp_per->[$i];
    print "\n";
    printf "\t\tcoefficient_%0.2d         = %17.10f\n", $j, $coeff_val->[$i];
    printf "\t\tcoefficient_error_%0.2d   = %17.10f\n", $j, $coeff_err->[$i];
    printf "\t\tcoeff_percent_error_%0.2d = %17.10f\n", $j, $coeff_per->[$i];
    print "\n";
}

sub bubble_sort
{
    my($count) = $_[0];

    my($exp_val) = @_[1];
    my($exp_per) = @_[2];
    my($exp_err) = @_[3];

    my($coeff_val) = @_[4];
    my($coeff_per) = @_[5];
    my($coeff_err) = @_[6];

    for($i=0; $i<$count-1; $i++)
    {
        for( $j=0; $j<$count-($i+1); $j++)
        {
            if( $exp_val->[$j] < $exp_val->[$j+1] )
            {
                $temp1           = $exp_val->[$j+1];
                $exp_val->[$j+1] = $exp_val->[$j];
                $exp_val->[$j]   = $temp1;
		
		$temp2           = $exp_err->[$j+1];
                $exp_err->[$j+1] = $exp_err->[$j];
                $exp_err->[$j]   = $temp2;

		$temp3           = $exp_per->[$j+1];
                $exp_per->[$j+1] = $exp_per->[$j];
                $exp_per->[$j]   = $temp3;

		$temp4           = $coeff_val->[$j+1];
                $coeff_val->[$j+1] = $coeff_val->[$j];
                $coeff_val->[$j]   = $temp4;
		
		$temp5           = $coeff_err->[$j+1];
                $coeff_err->[$j+1] = $coeff_err->[$j];
                $coeff_err->[$j]   = $temp5;

		$temp6           = $coeff_per->[$j+1];
                $coeff_per->[$j+1] = $coeff_per->[$j];
                $coeff_per->[$j]   = $temp6;
            }
        }
    }

    return 
	$exp_val, 
	$exp_per, 
	$exp_err, 
	$coeff_val,
	$coeff_per,
	$coeff_err;
}
