#! /usr/bin/perl

use cascade;
use tools;
use regular_expressions;
use array;

my($input_file, $token) = get_arguments();

my($token) = format_string($token);

my($array) = file_to_array($input_file);

my($array) = format_array($array);

my($array) = find_token($array, $token);

#print_array_list($array);

print_array($array);

sub print_array
{
    my($array) = @_[0];

    foreach my $item (@$array)
    {
	print "$item\n";
    }
}

sub get_arguments
{
   my($input_file) =  shift @ARGV;

   my(@arguments)  = ();

    foreach $arg (@ARGV)
    {
	push(@arguments, $arg);
    }

   return $input_file, \@arguments;
}

sub print_array_list
{
    my($array) = @_[0];
    
    print "\#";

    foreach my $item (@$token)
    {
	$item =~ s/\\//ig;

	printf "%20s", $item;
    }
    
    print "\n";

    foreach my $line (@$array)
    {
	$count++;

	printf "%4d",$count;

	while($line =~ m/([a-z0-9\.\(\)\_\-]+)\s+\=\s+([a-z0-9\.\(\)\_\-]+)/ig)
	{
	    printf "%20s", $2;
	}

	print "\n";
    }
}

sub find_token
{
    my($array) = @_[0];
    my($token_array) = @_[1];

    my(@token_value_array) = ();

    foreach my $line (@$array)
    {
	my($string) = ();

	foreach my $token (@$token_array)
	{
	    while($line =~ m/\s+($token)\s+\=\s+([a-z0-9\.\(\)\_\-]+)/ig)
	    {
		my($found_token)  = $1;

		my($found_value)  = $2;

		$string = $string . " " . "$found_token = $found_value";
	    }
	}

	if( $string ne "" )
	{
	    push(@token_value_array, $string);
	}
    }

    return \@token_value_array;
}

sub format_array
{
    my($array) = @_[0];
    
    my(@tmp_array) = ();

    foreach my $line (@$array)
    {
	$line =~ s/\=/ \= /ig;
	
	push(@tmp_array, $line);
    }

    return \@tmp_array;
}

sub format_string
{
    my($argument_array) = @_[0];

    my(@string_array) = ();

    foreach my $string (@$argument_array)
    {
	$string =~ s/\(/\\\(/i;

	$string =~ s/\)/\\\)/i;

	$string =~ s/\_/\\\_/i;

	$string =~ s/\=/\\\=/i;

	push(@string_array, $string);
    }

    return \@string_array;
}

sub file_to_array
{
    my($file)       = $_[0];

    my($FILE)       = array->ARRAY($file);

    my($file_array) = $FILE->{array};

    if( $file_array->[0] =~ m/\=/i ) { return $file_array; }

    else
    {
	my($INPUT_DATA) = cascade->CASCADE($file);

	my($data)       = $INPUT_DATA->{array};

	return $data;
    }
}
