#! /usr/bin/perl

$base       = @ARGV[0]; # base file name
$file       = @ARGV[1]; # list file 
$exp_factor = @ARGV[3]; # give exp_factor 1/0 
$atom       = @ARGV[2]; # give atom number for force

open(IN,"$file") or die "cannot open input file\n";
while(<IN>)
{
    chomp $_;
    if($_ =~ m/(\d+.\d+)/)
    {
        push(@array,$1);
    }
}
close(IN);

foreach $item (@array)
{
    $par_in   = $base . "-" . $item . ".par-in";
    $par_out  = $base . "-" . $item . ".par-out";

    print "$par_in\n";
    print "$par_out\n";

    open(IN,"$par_out") or die "cannot open par-out file\n";
    @data =<IN>;
    close(IN);

    open(OUT,">$par_in") or die "cannot create par-in file\n";

    print OUT "\n";
    print OUT "end_of_header\n";
    
    if($exp_factor == 1)
    {
	if($atom == 1)
	{
	    print OUT "atoms_coor_vector(1,3)=1.d0\n";
	    print OUT "atoms_coor_vector(2,3)=0.d0\n";
	}

	if($atom == 2)
	{
	    print OUT "atoms_coor_vector(1,3)=0.d0\n";
	    print OUT "atoms_coor_vector(2,3)=1.d0\n";
	}
    }

    print OUT "exp_factor=$exp_factor.\n";

    foreach $par (@data)
    {
	chomp $par;
	if($par =~ m/delta/i)
	{
	    print OUT "$par\n";
	}
    }

    @data=();

    close(OUT);

}
