#! /usr/bin/perl

use array;

my($list)     = @ARGV[0];
my($sto_file) = @ARGV[1];

my($LIST)  = array->ARRAY($list);

$array = $LIST->{array};

foreach $item (@$array)
{
    if($item =~ m/parameter\_\d+\s+=\s+(\d+\.\d+|-\d+\.\d+)/i)
    {
	push(@param, $1);
    }
    
    if($item =~ m/derivative\_\d+\s+=\s+(.*)/i)
    {
	push(@deriv, $1);
    }
}

my($STO)      = array->ARRAY($sto_file);
my($sto_data) = $STO->{array};

foreach my $line (@$sto_data)
{
    if($line =~ m/(exponent|coefficient)\_(\d+)+\s+\=\s+((|-)\d+\.\d\d\d\d\d\d\d\d\d)/i)
    {
	print "$line\n";

	$num   = $2;
	$coeff = $1;
	$param = $3;

	$count = 0;

	foreach my $value (@param)
	{
	    if($value == $param)
	    {
		$deriv_val =  $deriv[$count];

		if($coeff eq "exponent")
		{
		    printf "\t\texp_derivative\_$num      =     % 15.10e\n", $deriv_val;
		}

		if($coeff eq "coefficient")
		{
		    printf "\t\tcoeff_derivative\_$num    =     % 15.10e\n", $deriv_val;
		}
	    }

	    $count++;
	}
    }

    else
    {
	print "$line\n";
    }
}
