#!/usr/bin/env python
#
#
import sys
import libxml2
from re import *
from string import *

print "Zori geometry conversion utility for QMCMOL (2004, Paris)"

if (len(sys.argv) < 3):
    print "ERROR: Not enough arguments supplied"
    print "USAGE: ./psi2qmcmol.py psi.xml file.inp"
    print "Where file.xml is your input XML file "
    print "file.inp is the (incomplete) QMCMol file"
    sys.exit(1)

file = sys.argv[1];
fileout = sys.argv[2];

print "Converting... " + file

doc = libxml2.parseFile(file)
ctxt = doc.xpathNewContext()
centers = ctxt.xpathEval("/Wavefunction/Potential/*")


out = open(fileout, "w")

num_centers = len(centers)

print "Number of atoms to convert: " + str(num_centers)

out.write("nuclei\n")
iterator=1;
for atom in centers:
    out.write( "atom name = " + atom.prop("Name") + str(iterator) + " symbol = " + atom.prop("Name") + " charge = " + atom.prop("Charge") + " coordinates = ( " + atom.prop("X") + ", " + atom.prop("Y") + ", " + atom.prop("Z") + ") end_ato\n")
    iterator = iterator + 1;

out.write("end_nuc\n");

occs = ctxt.xpathEval("/Wavefunction/MeanField/Engine/Slater/Occupations")

out.write("wavefunction\n")

data = split(occs[0].content)

i=1;
occ_index = 1;
for a in data:
    if (i%2 == 1):
        out.write("configuration\n")
        out.write("name = CONF_" + str(i) + "\n")
        out.write("print = false\n")
        out.write("weight = " + str(a) + "\n")
        out.write("\n determinant\n")
        

    else:
        alpha = []
        beta = []
        for ch in range(len(a)):
            if (a[ch] == "D"):
                alpha.append(occ_index)
                beta.append(occ_index)
            elif (a[ch] == "A"):
                alpha.append(occ_index)
            elif (a[ch] == "B"):
                beta.append(occ_index)
            elif (a[ch] == "U"):
                bogus = 1
            else:
                print "Unrecognized character " + a[ch] + "in occupations list..."
                print "Valid characters are D,A,B and U"
                exit(1)
            occ_index = occ_index + 1
        #print alpha
        out.write ("alfa_orbitals= (")
        for c in alpha[:-1]:
            out.write(str(c) + ",")
        for c in alpha[-1:]:
            out.write(str(c))
        out.write(")\n")
        out.write ("beta_orbitals= (")
        for c in beta[:-1]:
            out.write(str(c) + ",")
        for c in beta[-1:]:
            out.write(str(c))
        out.write(")\n")
        #print beta
        out.write("end_det\n")
        out.write("end configuration\n")
    i = i + 1
out.write("end_wave\n")


out.close()

