#! /usr/bin/perl

use Env qw(HOME PWD LD_LIBRARY_PATH);
use English;
use File::Copy;
use Getopt::Std;

getopt("be:",\%args);

$base = $args{b}; #base file name
$exe  = $args{e}; # executable

$scr  = $base . ".scr";
$inp  = $base . ".inp";
$out  = $base . ".out";

open(SCR,">$scr") or die "cannot create submission script file\n";
print SCR "\#!/bin/sh\n";
print SCR "\$ -N $base\n";
print SCR "\#\n";
print SCR "setenv LD_LIBRARY_PATH $LD_LIBRARY_PATH\n";
print SCR "setenv QMCMOL_UNAME_a \`uname -a\`\n";
print SCR "setenv QMCMOL_UNAME_m \`uname -m\`\n";
print SCR "setenv QMCMOL_UNAME_s \`uname -s\`\n";
print SCR "setenv PWD \`pwd\`\n";
print SCR "\#\n";
print SCR "cd $HOME\n";
print SCR "cd $PWD\n";
print SCR "\#\n";
print SCR "./$exe < $inp > $out\n";
close(SCR);
