#! /usr/bin/perl

use Math::Trig;

$pi = acos(-1.0);

$basis_function = @ARGV[0];

for($i=1; $i<=7000; $i++)
{
    $r   = 0.0 + $i * 0.005;
    $sto =  sto_function( $r, $basis_function );

    printf "%15.10f %15.10f\n", $r, $sto;
}

sub sto_function
{
    my($r)        = $_[0];
    my($function) = $_[1];
    
    my($sto)      = ();

    if($function =~ m/1s/i )
    {
	$sto = 1.0 / ($pi)**(0.5) * $r;
    }

    if( $function =~ m/2s/i )
    {
	$sto = ( 1 / ($pi * 3.0) )**(0.5) * $r**2 * 2.0 * $pi**0.5;
    }

    if( $function =~ m/3s/i )
    {
	$sto =  2.0 / 3.0 * ( 2.0 / 5.0 )**(0.5) * $r**3;
    }

    if( $function =~ m/4s/i )
    {
	$sto =  2.0 / 105.0 * 35.0**(0.5)  * $r**4;
    }

    if( $function =~ m/5s/i )
    {
	$sto =  2.0 * 14.0**(0.5) / 315.0 * $r**5;
    }

    if( $function =~ m/2p/i )
    {
	$sto = 2.0 / 3.0 * 3.0**(0.5) * $r**2;
    }

    if($function =~ m/3p/i )
    {
	$sto = 2.0 / 3.0 * ( 2.0 / 5.0 )**(0.5) * $r**3;
    }

    if( $function =~ m/4p/i )
    {
        $sto = 2.0 / 105.0 * 35.0**(0.5) * $r**4;
    }

    if( $function =~ m/5p/i )
    {
        $sto = 2.0 / 315.0 * 14.0**(0.5) * $r**5;
    }

    if( $function =~ m/3d/i )
    {
	$sto = 2.0 / 15.0 * 10.0**(0.5) * $r**3;
    }

    if( $function =~ m/4f/i )
    {
	$sto = 2.0 / 105.0 * 35.0**(0.5) * $r**4;
    }

    if( $function =~ m/5g/i )
    {
	$sto = 2.0 / 315.0 * 14.0**(0.5) * $r**5;
    }

    $sto = $sto * exp( -$r );

    return $sto;
}
