#!/usr/bin/env python
#
#
import sys      # import module sys.argv
import libxml2
from re import * # import regexp from python library
from string import * # import string operators split
# import string : is different obliges to write string.len instead of len 
print "Zori walker conversion utility for QMCMOL (2004, Paris)"

if (len(sys.argv) < 3): # same in c (arguments of the command linne)
    print "ERROR: No arguments supplied" #tab means inside the if
    print "USAGE: ./walkers2qmcmol.py file.xml file.wlk-in"
    print "Where file.xml is your input XML file "
    sys.exit(1) 
    
file = sys.argv[1];
fileout= sys.argv[2];

print "Converting... " + file
doc = libxml2.parseFile(file)  # open  the file reads the tree
ctxt = doc.xpathNewContext()   # start xpath engine (in xml)
ensdesc = ctxt.xpathEval("/Walkers/Ensemble")  #   reads a single node returns a list
ensemble = ctxt.xpathEval("/Walkers/Ensemble/*") # all the subtree below the node

dim = int(ensdesc[0].prop("Dim")) # first element of the list 
particles = int(ensdesc[0].prop("Particles"))
type = ensdesc[0].prop("Type")
print "Dimensions: " + str(dim) + " # Particles " + str(particles) + " Type " + type

if (type != "Single"):
    print "Walker type not supported: " + type
    exit(1)

num_walkers = len(ensemble) # number of nodes inside ensemble

print "Number of walkers to convert: " + str(num_walkers)

out = open (fileout, 'w')
out.write ('File converted  from zori xml '+file+"\n")
out.write ('number_of_walkers='+str(num_walkers)+"\n")
out.write ('number_of_dimensions='+str(dim)+"\n")
out.write ('number_alfa_of_electrons'+str(particles)+"\n")
out.write ('end_of_header \n')

for wlk in ensemble:
    a = wlk.content
    list = split(a);

    out.write ("walker \n")
    size_list = len(list)
    for i in range(1,(size_list+1)/dim+1):
        out.write ("electron     "+str(i)+' ')
        for idx in range (0,3):
            out.write (str(list[(i-1)*dim +idx])+'  ')
        out.write (" \n")
    out.write  ("end_of_walker \n")
